Module["asm"] =  (function(global, env, buffer) {
  'almost asm';
  
  
  var HEAP8 = new global.Int8Array(buffer);
  var HEAP16 = new global.Int16Array(buffer);
  var HEAP32 = new global.Int32Array(buffer);
  var HEAPU8 = new global.Uint8Array(buffer);
  var HEAPU16 = new global.Uint16Array(buffer);
  var HEAPU32 = new global.Uint32Array(buffer);
  var HEAPF32 = new global.Float32Array(buffer);
  var HEAPF64 = new global.Float64Array(buffer);


  var STACKTOP=env.STACKTOP|0;
  var STACK_MAX=env.STACK_MAX|0;
  var DYNAMICTOP_PTR=env.DYNAMICTOP_PTR|0;
  var tempDoublePtr=env.tempDoublePtr|0;
  var ABORT=env.ABORT|0;

  var __THREW__ = 0;
  var threwValue = 0;
  var setjmpId = 0;
  var undef = 0;
  var nan = global.NaN, inf = global.Infinity;
  var tempInt = 0, tempBigInt = 0, tempBigIntP = 0, tempBigIntS = 0, tempBigIntR = 0.0, tempBigIntI = 0, tempBigIntD = 0, tempValue = 0, tempDouble = 0.0;
  var tempRet0 = 0;

  var Math_floor=global.Math.floor;
  var Math_abs=global.Math.abs;
  var Math_sqrt=global.Math.sqrt;
  var Math_pow=global.Math.pow;
  var Math_cos=global.Math.cos;
  var Math_sin=global.Math.sin;
  var Math_tan=global.Math.tan;
  var Math_acos=global.Math.acos;
  var Math_asin=global.Math.asin;
  var Math_atan=global.Math.atan;
  var Math_atan2=global.Math.atan2;
  var Math_exp=global.Math.exp;
  var Math_log=global.Math.log;
  var Math_ceil=global.Math.ceil;
  var Math_imul=global.Math.imul;
  var Math_min=global.Math.min;
  var Math_max=global.Math.max;
  var Math_clz32=global.Math.clz32;
  var Math_fround=global.Math.fround;
  var abort=env.abort;
  var assert=env.assert;
  var enlargeMemory=env.enlargeMemory;
  var getTotalMemory=env.getTotalMemory;
  var abortOnCannotGrowMemory=env.abortOnCannotGrowMemory;
  var abortStackOverflow=env.abortStackOverflow;
  var nullFunc_ii=env.nullFunc_ii;
  var nullFunc_iiii=env.nullFunc_iiii;
  var nullFunc_iii=env.nullFunc_iii;
  var nullFunc_iiiii=env.nullFunc_iiiii;
  var nullFunc_vi=env.nullFunc_vi;
  var invoke_ii=env.invoke_ii;
  var invoke_iiii=env.invoke_iiii;
  var invoke_iii=env.invoke_iii;
  var invoke_iiiii=env.invoke_iiiii;
  var invoke_vi=env.invoke_vi;
  var _pthread_cleanup_pop=env._pthread_cleanup_pop;
  var ___syscall220=env.___syscall220;
  var ___syscall195=env.___syscall195;
  var ___lock=env.___lock;
  var ___syscall6=env.___syscall6;
  var _pthread_cleanup_push=env._pthread_cleanup_push;
  var _abort=env._abort;
  var _llvm_stacksave=env._llvm_stacksave;
  var ___unlock=env.___unlock;
  var ___syscall5=env.___syscall5;
  var _emscripten_memcpy_big=env._emscripten_memcpy_big;
  var ___syscall54=env.___syscall54;
  var ___syscall140=env.___syscall140;
  var _exit=env._exit;
  var _llvm_stackrestore=env._llvm_stackrestore;
  var __exit=env.__exit;
  var ___syscall146=env.___syscall146;
  var ___setErrNo=env.___setErrNo;
  var tempFloat = Math_fround(0);
  const f0 = Math_fround(0);

// EMSCRIPTEN_START_FUNCS

function stackAlloc(size) {
  size = size|0;
  var ret = 0;
  ret = STACKTOP;
  STACKTOP = (STACKTOP + size)|0;
  STACKTOP = (STACKTOP + 15)&-16;
  if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(size|0);

  return ret|0;
}
function stackSave() {
  return STACKTOP|0;
}
function stackRestore(top) {
  top = top|0;
  STACKTOP = top;
}
function establishStackSpace(stackBase, stackMax) {
  stackBase = stackBase|0;
  stackMax = stackMax|0;
  STACKTOP = stackBase;
  STACK_MAX = stackMax;
}

function setThrew(threw, value) {
  threw = threw|0;
  value = value|0;
  if ((__THREW__|0) == 0) {
    __THREW__ = threw;
    threwValue = value;
  }
}

function setTempRet0(value) {
  value = value|0;
  tempRet0 = value;
}
function getTempRet0() {
  return tempRet0|0;
}

function _g($x) {
 $x = $x|0;
 var $0 = 0, $x$addr = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $x$addr = $x;
 $0 = $x$addr;
 store4(4,$0);
 STACKTOP = sp;return 0;
}
function _f($x) {
 $x = $x|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $a = 0, $call = 0, $neg = 0, $retval = 0, $tobool = 0, $x$addr = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $x$addr = $x;
 $0 = $x$addr;
 $neg = $0 ^ -1;
 $a = $neg;
 while(1) {
  $1 = $a;
  $tobool = ($1|0)!=(0);
  if (!($tobool)) {
   break;
  }
  $2 = $a;
  $call = (_g($2)|0);
  $a = $call;
 }
 $3 = $retval;
 STACKTOP = sp;return ($3|0);
}
function _main() {
 var $0 = 0, $cmp = 0, $retval = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $retval = 0;
 (_f(3)|0);
 $0 = load4(4);
 $cmp = ($0|0)!=(-4);
 if ($cmp) {
  _abort();
  // unreachable;
 } else {
  _exit(0);
  // unreachable;
 }
 return (0)|0;
}
function ___stdio_close($f) {
 $f = $f|0;
 var $0 = 0, $call = 0, $call1 = 0, $fd = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $fd = ((($f)) + 60|0);
 $0 = load4($fd);
 store4($vararg_buffer,$0);
 $call = (___syscall6(6,($vararg_buffer|0))|0);
 $call1 = (___syscall_ret($call)|0);
 STACKTOP = sp;return ($call1|0);
}
function ___stdout_write($f,$buf,$len) {
 $f = $f|0;
 $buf = $buf|0;
 $len = $len|0;
 var $0 = 0, $1 = 0, $and = 0, $call = 0, $call3 = 0, $fd = 0, $lbf = 0, $tio = 0, $tobool = 0, $tobool2 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $write = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 80|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(80|0);
 $vararg_buffer = sp;
 $tio = sp + 12|0;
 $write = ((($f)) + 36|0);
 store4($write,5);
 $0 = load4($f);
 $and = $0 & 64;
 $tobool = ($and|0)==(0);
 if ($tobool) {
  $fd = ((($f)) + 60|0);
  $1 = load4($fd);
  store4($vararg_buffer,$1);
  $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
  store4($vararg_ptr1,21505);
  $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
  store4($vararg_ptr2,$tio);
  $call = (___syscall54(54,($vararg_buffer|0))|0);
  $tobool2 = ($call|0)==(0);
  if (!($tobool2)) {
   $lbf = ((($f)) + 75|0);
   store1($lbf,-1);
  }
 }
 $call3 = (___stdio_write($f,$buf,$len)|0);
 STACKTOP = sp;return ($call3|0);
}
function ___stdio_seek($f,$off,$whence) {
 $f = $f|0;
 $off = $off|0;
 $whence = $whence|0;
 var $$pre = 0, $0 = 0, $1 = 0, $call = 0, $call1 = 0, $cmp = 0, $fd = 0, $ret = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, $vararg_ptr3 = 0, $vararg_ptr4 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $ret = sp + 20|0;
 $fd = ((($f)) + 60|0);
 $0 = load4($fd);
 store4($vararg_buffer,$0);
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 store4($vararg_ptr1,0);
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
 store4($vararg_ptr2,$off);
 $vararg_ptr3 = ((($vararg_buffer)) + 12|0);
 store4($vararg_ptr3,$ret);
 $vararg_ptr4 = ((($vararg_buffer)) + 16|0);
 store4($vararg_ptr4,$whence);
 $call = (___syscall140(140,($vararg_buffer|0))|0);
 $call1 = (___syscall_ret($call)|0);
 $cmp = ($call1|0)<(0);
 if ($cmp) {
  store4($ret,-1);
  $1 = -1;
 } else {
  $$pre = load4($ret);
  $1 = $$pre;
 }
 STACKTOP = sp;return ($1|0);
}
function ___syscall_ret($r) {
 $r = $r|0;
 var $call = 0, $cmp = 0, $retval$0 = 0, $sub = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $cmp = ($r>>>0)>(4294963200);
 if ($cmp) {
  $sub = (0 - ($r))|0;
  $call = (___errno_location()|0);
  store4($call,$sub);
  $retval$0 = -1;
 } else {
  $retval$0 = $r;
 }
 return ($retval$0|0);
}
function ___errno_location() {
 var $0 = 0, $1 = 0, $call$i = 0, $errno_ptr = 0, $retval$0 = 0, $tobool = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = load4(8396);
 $tobool = ($0|0)==(0|0);
 if ($tobool) {
  $retval$0 = 8440;
 } else {
  $call$i = (_pthread_self()|0);
  $errno_ptr = ((($call$i)) + 64|0);
  $1 = load4($errno_ptr);
  $retval$0 = $1;
 }
 return ($retval$0|0);
}
function ___stdio_write($f,$buf,$len) {
 $f = $f|0;
 $buf = $buf|0;
 $len = $len|0;
 var $$pre = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $add = 0, $add$ptr = 0, $add$ptr41 = 0, $add$ptr46 = 0;
 var $buf31 = 0, $buf_size = 0, $call = 0, $call10 = 0, $call7 = 0, $call9 = 0, $cmp = 0, $cmp17 = 0, $cmp22 = 0, $cmp29 = 0, $cmp38 = 0, $cnt$0 = 0, $cnt$1 = 0, $dec = 0, $fd8 = 0, $incdec$ptr = 0, $iov$0 = 0, $iov$1 = 0, $iov_base2 = 0, $iov_len = 0;
 var $iov_len24 = 0, $iov_len28 = 0, $iov_len3 = 0, $iov_len50 = 0, $iov_len50$phi$trans$insert = 0, $iovcnt$0 = 0, $iovcnt$1 = 0, $iovs = 0, $or = 0, $rem$0 = 0, $retval$0 = 0, $sub = 0, $sub$ptr$sub = 0, $sub26 = 0, $sub36 = 0, $sub51 = 0, $tobool = 0, $vararg_buffer = 0, $vararg_buffer3 = 0, $vararg_ptr1 = 0;
 var $vararg_ptr2 = 0, $vararg_ptr6 = 0, $vararg_ptr7 = 0, $wbase = 0, $wend = 0, $wend19 = 0, $wpos = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 48|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(48|0);
 $vararg_buffer3 = sp + 16|0;
 $vararg_buffer = sp;
 $iovs = sp + 32|0;
 $wbase = ((($f)) + 28|0);
 $0 = load4($wbase);
 store4($iovs,$0);
 $iov_len = ((($iovs)) + 4|0);
 $wpos = ((($f)) + 20|0);
 $1 = load4($wpos);
 $sub$ptr$sub = (($1) - ($0))|0;
 store4($iov_len,$sub$ptr$sub);
 $iov_base2 = ((($iovs)) + 8|0);
 store4($iov_base2,$buf);
 $iov_len3 = ((($iovs)) + 12|0);
 store4($iov_len3,$len);
 $add = (($sub$ptr$sub) + ($len))|0;
 $fd8 = ((($f)) + 60|0);
 $buf31 = ((($f)) + 44|0);
 $iov$0 = $iovs;$iovcnt$0 = 2;$rem$0 = $add;
 while(1) {
  $2 = load4(8396);
  $tobool = ($2|0)==(0|0);
  if ($tobool) {
   $4 = load4($fd8);
   store4($vararg_buffer3,$4);
   $vararg_ptr6 = ((($vararg_buffer3)) + 4|0);
   store4($vararg_ptr6,$iov$0);
   $vararg_ptr7 = ((($vararg_buffer3)) + 8|0);
   store4($vararg_ptr7,$iovcnt$0);
   $call9 = (___syscall146(146,($vararg_buffer3|0))|0);
   $call10 = (___syscall_ret($call9)|0);
   $cnt$0 = $call10;
  } else {
   _pthread_cleanup_push((6|0),($f|0));
   $3 = load4($fd8);
   store4($vararg_buffer,$3);
   $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
   store4($vararg_ptr1,$iov$0);
   $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
   store4($vararg_ptr2,$iovcnt$0);
   $call = (___syscall146(146,($vararg_buffer|0))|0);
   $call7 = (___syscall_ret($call)|0);
   _pthread_cleanup_pop(0);
   $cnt$0 = $call7;
  }
  $cmp = ($rem$0|0)==($cnt$0|0);
  if ($cmp) {
   label = 6;
   break;
  }
  $cmp17 = ($cnt$0|0)<(0);
  if ($cmp17) {
   label = 8;
   break;
  }
  $sub26 = (($rem$0) - ($cnt$0))|0;
  $iov_len28 = ((($iov$0)) + 4|0);
  $10 = load4($iov_len28);
  $cmp29 = ($cnt$0>>>0)>($10>>>0);
  if ($cmp29) {
   $11 = load4($buf31);
   store4($wbase,$11);
   store4($wpos,$11);
   $sub36 = (($cnt$0) - ($10))|0;
   $incdec$ptr = ((($iov$0)) + 8|0);
   $dec = (($iovcnt$0) + -1)|0;
   $iov_len50$phi$trans$insert = ((($iov$0)) + 12|0);
   $$pre = load4($iov_len50$phi$trans$insert);
   $14 = $$pre;$cnt$1 = $sub36;$iov$1 = $incdec$ptr;$iovcnt$1 = $dec;
  } else {
   $cmp38 = ($iovcnt$0|0)==(2);
   if ($cmp38) {
    $12 = load4($wbase);
    $add$ptr41 = (($12) + ($cnt$0)|0);
    store4($wbase,$add$ptr41);
    $14 = $10;$cnt$1 = $cnt$0;$iov$1 = $iov$0;$iovcnt$1 = 2;
   } else {
    $14 = $10;$cnt$1 = $cnt$0;$iov$1 = $iov$0;$iovcnt$1 = $iovcnt$0;
   }
  }
  $13 = load4($iov$1);
  $add$ptr46 = (($13) + ($cnt$1)|0);
  store4($iov$1,$add$ptr46);
  $iov_len50 = ((($iov$1)) + 4|0);
  $sub51 = (($14) - ($cnt$1))|0;
  store4($iov_len50,$sub51);
  $iov$0 = $iov$1;$iovcnt$0 = $iovcnt$1;$rem$0 = $sub26;
 }
 if ((label|0) == 6) {
  $5 = load4($buf31);
  $buf_size = ((($f)) + 48|0);
  $6 = load4($buf_size);
  $add$ptr = (($5) + ($6)|0);
  $wend = ((($f)) + 16|0);
  store4($wend,$add$ptr);
  $7 = $5;
  store4($wbase,$7);
  store4($wpos,$7);
  $retval$0 = $len;
 }
 else if ((label|0) == 8) {
  $wend19 = ((($f)) + 16|0);
  store4($wend19,0);
  store4($wbase,0);
  store4($wpos,0);
  $8 = load4($f);
  $or = $8 | 32;
  store4($f,$or);
  $cmp22 = ($iovcnt$0|0)==(2);
  if ($cmp22) {
   $retval$0 = 0;
  } else {
   $iov_len24 = ((($iov$0)) + 4|0);
   $9 = load4($iov_len24);
   $sub = (($len) - ($9))|0;
   $retval$0 = $sub;
  }
 }
 STACKTOP = sp;return ($retval$0|0);
}
function _cleanup_369($p) {
 $p = $p|0;
 var $0 = 0, $lockcount = 0, $tobool = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $lockcount = ((($p)) + 68|0);
 $0 = load4($lockcount);
 $tobool = ($0|0)==(0);
 if ($tobool) {
  ___unlockfile($p);
 }
 return;
}
function ___unlockfile($f) {
 $f = $f|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return;
}
function _mbtowc($wc,$src,$n) {
 $wc = $wc|0;
 $src = $src|0;
 $n = $n|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $add = 0, $and29 = 0, $arrayidx = 0, $call = 0, $cmp = 0, $cmp14 = 0, $cmp20 = 0, $cmp46 = 0, $cmp61 = 0, $conv = 0, $conv26 = 0, $conv44 = 0, $conv59 = 0, $dummy = 0;
 var $dummy$wc = 0, $incdec$ptr = 0, $incdec$ptr36 = 0, $incdec$ptr51 = 0, $lnot$ext = 0, $mul = 0, $or = 0, $or39 = 0, $or54 = 0, $or69 = 0, $retval$0 = 0, $shl35 = 0, $shl50 = 0, $shl65 = 0, $shr28 = 0, $shr30 = 0, $sub = 0, $sub22 = 0, $sub27 = 0, $sub38 = 0;
 var $sub45 = 0, $sub60 = 0, $tobool = 0, $tobool1 = 0, $tobool10 = 0, $tobool23 = 0, $tobool32 = 0, $tobool4 = 0, $tobool41 = 0, $tobool56 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $dummy = sp;
 $tobool = ($src|0)==(0|0);
 L1: do {
  if ($tobool) {
   $retval$0 = 0;
  } else {
   $tobool1 = ($n|0)==(0);
   do {
    if (!($tobool1)) {
     $tobool4 = ($wc|0)==(0|0);
     $dummy$wc = $tobool4 ? $dummy : $wc;
     $0 = load1($src);
     $conv = $0&255;
     $cmp = ($0<<24>>24)>(-1);
     if ($cmp) {
      store4($dummy$wc,$conv);
      $tobool10 = ($0<<24>>24)!=(0);
      $lnot$ext = $tobool10&1;
      $retval$0 = $lnot$ext;
      break L1;
     }
     $sub = (($conv) + -194)|0;
     $cmp14 = ($sub>>>0)>(50);
     if (!($cmp14)) {
      $incdec$ptr = ((($src)) + 1|0);
      $arrayidx = (1024 + ($sub<<2)|0);
      $1 = load4($arrayidx);
      $cmp20 = ($n>>>0)<(4);
      if ($cmp20) {
       $mul = ($n*6)|0;
       $sub22 = (($mul) + -6)|0;
       $2 = -2147483648 >>> $sub22;
       $and29 = $1 & $2;
       $tobool23 = ($and29|0)==(0);
       if (!($tobool23)) {
        break;
       }
      }
      $3 = load1($incdec$ptr);
      $conv26 = $3&255;
      $shr28 = $conv26 >>> 3;
      $sub27 = (($shr28) + -16)|0;
      $shr30 = $1 >> 26;
      $add = (($shr28) + ($shr30))|0;
      $or = $sub27 | $add;
      $tobool32 = ($or>>>0)>(7);
      if (!($tobool32)) {
       $shl35 = $1 << 6;
       $sub38 = (($conv26) + -128)|0;
       $or39 = $sub38 | $shl35;
       $tobool41 = ($or39|0)<(0);
       if (!($tobool41)) {
        store4($dummy$wc,$or39);
        $retval$0 = 2;
        break L1;
       }
       $incdec$ptr36 = ((($src)) + 2|0);
       $4 = load1($incdec$ptr36);
       $conv44 = $4&255;
       $sub45 = (($conv44) + -128)|0;
       $cmp46 = ($sub45>>>0)>(63);
       if (!($cmp46)) {
        $shl50 = $or39 << 6;
        $or54 = $sub45 | $shl50;
        $tobool56 = ($or54|0)<(0);
        if (!($tobool56)) {
         store4($dummy$wc,$or54);
         $retval$0 = 3;
         break L1;
        }
        $incdec$ptr51 = ((($src)) + 3|0);
        $5 = load1($incdec$ptr51);
        $conv59 = $5&255;
        $sub60 = (($conv59) + -128)|0;
        $cmp61 = ($sub60>>>0)>(63);
        if (!($cmp61)) {
         $shl65 = $or54 << 6;
         $or69 = $sub60 | $shl65;
         store4($dummy$wc,$or69);
         $retval$0 = 4;
         break L1;
        }
       }
      }
     }
    }
   } while(0);
   $call = (___errno_location()|0);
   store4($call,84);
   $retval$0 = -1;
  }
 } while(0);
 STACKTOP = sp;return ($retval$0|0);
}
function _open($filename,$flags,$varargs) {
 $filename = $filename|0;
 $flags = $flags|0;
 $varargs = $varargs|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $ap = 0, $arglist_current = 0, $arglist_next = 0, $call = 0, $call5 = 0, $expanded = 0, $expanded2 = 0, $expanded3 = 0, $expanded4 = 0, $expanded5 = 0, $expanded6 = 0, $expanded7 = 0, $or = 0, $vararg_buffer = 0, $vararg_ptr1 = 0;
 var $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $vararg_buffer = sp;
 $ap = sp + 16|0;
 store4($ap,$varargs);
 $arglist_current = load4($ap);
 $0 = $arglist_current;
 $expanded3 = ((0) + 4|0);
 $expanded2 = $expanded3;
 $expanded = (($expanded2) - 1)|0;
 $1 = (($0) + ($expanded))|0;
 $expanded7 = ((0) + 4|0);
 $expanded6 = $expanded7;
 $expanded5 = (($expanded6) - 1)|0;
 $expanded4 = $expanded5 ^ -1;
 $2 = $1 & $expanded4;
 $3 = $2;
 $4 = load4($3);
 $arglist_next = ((($3)) + 4|0);
 store4($ap,$arglist_next);
 $or = $flags | 32768;
 store4($vararg_buffer,$filename);
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 store4($vararg_ptr1,$or);
 $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
 store4($vararg_ptr2,$4);
 $call = (___syscall5(5,($vararg_buffer|0))|0);
 $call5 = (___syscall_ret($call)|0);
 STACKTOP = sp;return ($call5|0);
}
function _strlen($s) {
 $s = $s|0;
 var $$pn = 0, $$pn24 = 0, $$pre = 0, $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $and = 0, $and3 = 0, $incdec$ptr = 0, $incdec$ptr1323 = 0, $incdec$ptr7 = 0, $lnot = 0, $neg = 0, $rem = 0, $rem13 = 0, $retval$0 = 0, $s$addr$0$lcssa = 0;
 var $s$addr$015 = 0, $s$addr$1$lcssa = 0, $sub = 0, $sub$ptr$lhs$cast15 = 0, $tobool = 0, $tobool1 = 0, $tobool10 = 0, $tobool1021 = 0, $tobool14 = 0, $w$0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = $s;
 $rem13 = $0 & 3;
 $tobool14 = ($rem13|0)==(0);
 L1: do {
  if ($tobool14) {
   $s$addr$0$lcssa = $s;
   label = 4;
  } else {
   $5 = $0;$s$addr$015 = $s;
   while(1) {
    $1 = load1($s$addr$015);
    $tobool1 = ($1<<24>>24)==(0);
    if ($tobool1) {
     $$pn = $5;
     break L1;
    }
    $incdec$ptr = ((($s$addr$015)) + 1|0);
    $2 = $incdec$ptr;
    $rem = $2 & 3;
    $tobool = ($rem|0)==(0);
    if ($tobool) {
     $s$addr$0$lcssa = $incdec$ptr;
     label = 4;
     break;
    } else {
     $5 = $2;$s$addr$015 = $incdec$ptr;
    }
   }
  }
 } while(0);
 if ((label|0) == 4) {
  $w$0 = $s$addr$0$lcssa;
  while(1) {
   $3 = load4($w$0);
   $sub = (($3) + -16843009)|0;
   $neg = $3 & -2139062144;
   $and = $neg ^ -2139062144;
   $and3 = $and & $sub;
   $lnot = ($and3|0)==(0);
   $incdec$ptr7 = ((($w$0)) + 4|0);
   if ($lnot) {
    $w$0 = $incdec$ptr7;
   } else {
    break;
   }
  }
  $4 = $3&255;
  $tobool1021 = ($4<<24>>24)==(0);
  if ($tobool1021) {
   $s$addr$1$lcssa = $w$0;
  } else {
   $$pn24 = $w$0;
   while(1) {
    $incdec$ptr1323 = ((($$pn24)) + 1|0);
    $$pre = load1($incdec$ptr1323);
    $tobool10 = ($$pre<<24>>24)==(0);
    if ($tobool10) {
     $s$addr$1$lcssa = $incdec$ptr1323;
     break;
    } else {
     $$pn24 = $incdec$ptr1323;
    }
   }
  }
  $sub$ptr$lhs$cast15 = $s$addr$1$lcssa;
  $$pn = $sub$ptr$lhs$cast15;
 }
 $retval$0 = (($$pn) - ($0))|0;
 return ($retval$0|0);
}
function _stat($path,$buf) {
 $path = $path|0;
 $buf = $buf|0;
 var $call = 0, $call1 = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 store4($vararg_buffer,$path);
 $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
 store4($vararg_ptr1,$buf);
 $call = (___syscall195(195,($vararg_buffer|0))|0);
 $call1 = (___syscall_ret($call)|0);
 STACKTOP = sp;return ($call1|0);
}
function _strcmp($l,$r) {
 $l = $l|0;
 $r = $r|0;
 var $$lcssa = 0, $$lcssa6 = 0, $0 = 0, $1 = 0, $2 = 0, $3 = 0, $cmp = 0, $cmp7 = 0, $conv5 = 0, $conv6 = 0, $incdec$ptr = 0, $incdec$ptr4 = 0, $l$addr$010 = 0, $or$cond = 0, $or$cond9 = 0, $r$addr$011 = 0, $sub = 0, $tobool = 0, $tobool8 = 0, label = 0;
 var sp = 0;
 sp = STACKTOP;
 $0 = load1($l);
 $1 = load1($r);
 $cmp7 = ($0<<24>>24)!=($1<<24>>24);
 $tobool8 = ($0<<24>>24)==(0);
 $or$cond9 = $tobool8 | $cmp7;
 if ($or$cond9) {
  $$lcssa = $1;$$lcssa6 = $0;
 } else {
  $l$addr$010 = $l;$r$addr$011 = $r;
  while(1) {
   $incdec$ptr = ((($l$addr$010)) + 1|0);
   $incdec$ptr4 = ((($r$addr$011)) + 1|0);
   $2 = load1($incdec$ptr);
   $3 = load1($incdec$ptr4);
   $cmp = ($2<<24>>24)!=($3<<24>>24);
   $tobool = ($2<<24>>24)==(0);
   $or$cond = $tobool | $cmp;
   if ($or$cond) {
    $$lcssa = $3;$$lcssa6 = $2;
    break;
   } else {
    $l$addr$010 = $incdec$ptr;$r$addr$011 = $incdec$ptr4;
   }
  }
 }
 $conv5 = $$lcssa6&255;
 $conv6 = $$lcssa&255;
 $sub = (($conv5) - ($conv6))|0;
 return ($sub|0);
}
function _opendir($name) {
 $name = $name|0;
 var $call = 0, $call1 = 0, $cmp = 0, $retval$0 = 0, $tobool = 0, $vararg_buffer = 0, $vararg_buffer1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer1 = sp + 8|0;
 $vararg_buffer = sp;
 $call = (_open($name,589824,$vararg_buffer)|0);
 $cmp = ($call|0)<(0);
 do {
  if ($cmp) {
   $retval$0 = 0;
  } else {
   $call1 = (_calloc(1,2072)|0);
   $tobool = ($call1|0)==(0|0);
   if ($tobool) {
    store4($vararg_buffer1,$call);
    (___syscall6(6,($vararg_buffer1|0))|0);
    $retval$0 = 0;
    break;
   } else {
    store4($call1,$call);
    $retval$0 = $call1;
    break;
   }
  }
 } while(0);
 STACKTOP = sp;return ($retval$0|0);
}
function _readdir($dir) {
 $dir = $dir|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $add = 0, $add$ptr = 0, $arraydecay = 0, $buf_end = 0, $buf_pos = 0, $call = 0, $call6 = 0, $cmp = 0, $cmp1 = 0, $conv = 0, $d_off = 0, $d_reclen = 0, $retval$1 = 0, $sub = 0;
 var $tell = 0, $vararg_buffer = 0, $vararg_ptr1 = 0, $vararg_ptr2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 $buf_pos = ((($dir)) + 8|0);
 $0 = load4($buf_pos);
 $buf_end = ((($dir)) + 12|0);
 $1 = load4($buf_end);
 $cmp = ($0|0)<($1|0);
 L1: do {
  if ($cmp) {
   $3 = $0;
   label = 6;
  } else {
   $2 = load4($dir);
   $arraydecay = ((($dir)) + 24|0);
   store4($vararg_buffer,$2);
   $vararg_ptr1 = ((($vararg_buffer)) + 4|0);
   store4($vararg_ptr1,$arraydecay);
   $vararg_ptr2 = ((($vararg_buffer)) + 8|0);
   store4($vararg_ptr2,2048);
   $call = (___syscall220(220,($vararg_buffer|0))|0);
   $cmp1 = ($call|0)<(1);
   if (!($cmp1)) {
    store4($buf_end,$call);
    store4($buf_pos,0);
    $3 = 0;
    label = 6;
    break;
   }
   switch ($call|0) {
   case 0: case -2:  {
    $retval$1 = 0;
    break L1;
    break;
   }
   default: {
   }
   }
   $sub = (0 - ($call))|0;
   $call6 = (___errno_location()|0);
   store4($call6,$sub);
   $retval$1 = 0;
  }
 } while(0);
 if ((label|0) == 6) {
  $add$ptr = (((($dir)) + 24|0) + ($3)|0);
  $d_reclen = ((($add$ptr)) + 8|0);
  $4 = load2($d_reclen);
  $conv = $4&65535;
  $add = (($conv) + ($3))|0;
  store4($buf_pos,$add);
  $d_off = ((($add$ptr)) + 4|0);
  $5 = load4($d_off);
  $tell = ((($dir)) + 4|0);
  store4($tell,$5);
  $retval$1 = $add$ptr;
 }
 STACKTOP = sp;return ($retval$1|0);
}
function _closedir($dir) {
 $dir = $dir|0;
 var $0 = 0, $call = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = load4($dir);
 $call = (_close($0)|0);
 _free($dir);
 return ($call|0);
}
function _qsort($base,$nel,$width,$cmp) {
 $base = $base|0;
 $nel = $nel|0;
 $width = $width|0;
 $cmp = $cmp|0;
 var $$pre = 0, $$pre$i = 0, $$pre$i54 = 0, $$pre$i60 = 0, $$pre$i67 = 0, $$pre11$i = 0, $$pre11$i55 = 0, $$pre11$i61 = 0, $$pre11$i68 = 0, $0 = 0, $0$phi = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0;
 var $18 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $add = 0, $add$i120 = 0, $add$ptr = 0, $add$ptr1 = 0, $add$ptr33 = 0, $add$ptr55 = 0, $add$ptr57 = 0, $add$ptr65 = 0, $add14 = 0, $add47 = 0, $add59 = 0;
 var $add6 = 0, $and = 0, $and$i$i = 0, $and$i12$i = 0, $and4$i$i = 0, $and4$i5$i = 0, $arrayidx = 0, $arrayidx$i = 0, $arrayidx16 = 0, $arrayidx40 = 0, $arrayidx53 = 0, $arrayidx7 = 0, $call108 = 0, $call108111 = 0, $call108112 = 0, $cmp$i = 0, $cmp$i$i = 0, $cmp$i93 = 0, $cmp11 = 0, $cmp17 = 0;
 var $cmp24 = 0, $cmp37 = 0, $cmp37129 = 0, $cmp39 = 0, $cmp39130 = 0, $cmp41 = 0, $cmp41132 = 0, $cmp41136 = 0, $cmp43 = 0, $cmp8 = 0, $cmp9 = 0, $cmp9122 = 0, $head$0$lcssa = 0, $head$0123 = 0, $head$1$be = 0, $head$1134 = 0, $i$0 = 0, $idx$neg = 0, $idx$neg54 = 0, $inc = 0;
 var $inc$i$i = 0, $inc$i10$i = 0, $lnot$i$i = 0, $lnot$i13$i = 0, $lnot5$i$i = 0, $lnot5$i6$i = 0, $lp = 0, $mul = 0, $n$addr$0$i = 0, $n$addr$0$i100 = 0, $nTrailingZeros$07$i$i = 0, $nTrailingZeros$07$i8$i = 0, $or = 0, $or$cond = 0, $or$cond127 = 0, $or$cond127133 = 0, $or$cond131 = 0, $or$i = 0, $or$i104 = 0, $or$i58 = 0;
 var $or$i64 = 0, $or$i71 = 0, $or$i81 = 0, $or$i91 = 0, $or63 = 0, $p = 0, $pshift$0$lcssa = 0, $pshift$0124 = 0, $pshift$1 = 0, $pshift$2$be = 0, $pshift$2135 = 0, $retval$0$i15$i$ph = 0, $shl$i = 0, $shl$i103 = 0, $shl$i56 = 0, $shl$i62 = 0, $shl$i69 = 0, $shl$i80 = 0, $shl$i88 = 0, $shl8$i = 0;
 var $shl8$i65 = 0, $shl8$i72 = 0, $shr$i = 0, $shr$i$i = 0, $shr$i101 = 0, $shr$i11$i = 0, $shr$i57 = 0, $shr$i63 = 0, $shr$i70 = 0, $shr$i90 = 0, $shr8$i = 0, $shr8$i105 = 0, $shr8$i82 = 0, $sub$i = 0, $sub$i106 = 0, $sub$i98 = 0, $sub$ptr$lhs$cast = 0, $sub$ptr$rhs$cast = 0, $sub$ptr$sub = 0, $sub15 = 0;
 var $sub5$i = 0, $sub5$i102 = 0, $sub50 = 0, $tobool = 0, $x$addr$06$i$i = 0, $x$addr$06$i9$i = 0, $xor = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 208|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(208|0);
 $lp = sp + 8|0;
 $p = sp;
 $mul = Math_imul($width, $nel)|0;
 store8($p,i64_const(1,0));
 $tobool = ($mul|0)==(0);
 if (!($tobool)) {
  $idx$neg = (0 - ($width))|0;
  $arrayidx = ((($lp)) + 4|0);
  store4($arrayidx,$width);
  store4($lp,$width);
  $0 = $width;$1 = $width;$i$0 = 2;
  while(1) {
   $add = (($0) + ($width))|0;
   $add6 = (($add) + ($1))|0;
   $arrayidx7 = (($lp) + ($i$0<<2)|0);
   store4($arrayidx7,$add6);
   $cmp8 = ($add6>>>0)<($mul>>>0);
   $inc = (($i$0) + 1)|0;
   if ($cmp8) {
    $0$phi = $1;$1 = $add6;$i$0 = $inc;$0 = $0$phi;
   } else {
    break;
   }
  }
  $add$ptr = (($base) + ($mul)|0);
  $add$ptr1 = (($add$ptr) + ($idx$neg)|0);
  $cmp9122 = ($add$ptr1>>>0)>($base>>>0);
  $arrayidx$i = ((($p)) + 4|0);
  if ($cmp9122) {
   $sub$ptr$lhs$cast = $add$ptr1;
   $2 = 1;$head$0123 = $base;$pshift$0124 = 1;
   while(1) {
    $and = $2 & 3;
    $cmp11 = ($and|0)==(3);
    do {
     if ($cmp11) {
      _sift($head$0123,$width,$cmp,$pshift$0124,$lp);
      $$pre$i = load4($p);
      $$pre11$i = load4($arrayidx$i);
      $shr$i = $$pre$i >>> 2;
      $shl$i = $$pre11$i << 30;
      $or$i = $shl$i | $shr$i;
      store4($p,$or$i);
      $shr8$i = $$pre11$i >>> 2;
      store4($arrayidx$i,$shr8$i);
      $add14 = (($pshift$0124) + 2)|0;
      $7 = $or$i;$pshift$1 = $add14;
     } else {
      $sub15 = (($pshift$0124) + -1)|0;
      $arrayidx16 = (($lp) + ($sub15<<2)|0);
      $3 = load4($arrayidx16);
      $sub$ptr$rhs$cast = $head$0123;
      $sub$ptr$sub = (($sub$ptr$lhs$cast) - ($sub$ptr$rhs$cast))|0;
      $cmp17 = ($3>>>0)<($sub$ptr$sub>>>0);
      if ($cmp17) {
       _sift($head$0123,$width,$cmp,$pshift$0124,$lp);
      } else {
       _trinkle($head$0123,$width,$cmp,$p,$pshift$0124,0,$lp);
      }
      $cmp24 = ($pshift$0124|0)==(1);
      if ($cmp24) {
       $$pre$i54 = load4($arrayidx$i);
       $$pre11$i55 = load4($p);
       $shl$i56 = $$pre$i54 << 1;
       $shr$i57 = $$pre11$i55 >>> 31;
       $or$i58 = $shr$i57 | $shl$i56;
       store4($arrayidx$i,$or$i58);
       $shl8$i = $$pre11$i55 << 1;
       store4($p,$shl8$i);
       $7 = $shl8$i;$pshift$1 = 0;
       break;
      }
      $cmp$i = ($sub15>>>0)>(31);
      if ($cmp$i) {
       $sub$i = (($pshift$0124) + -33)|0;
       $4 = load4($p);
       store4($arrayidx$i,$4);
       store4($p,0);
       $5 = $4;$6 = 0;$n$addr$0$i = $sub$i;
      } else {
       $$pre$i67 = load4($arrayidx$i);
       $$pre11$i68 = load4($p);
       $5 = $$pre$i67;$6 = $$pre11$i68;$n$addr$0$i = $sub15;
      }
      $shl$i69 = $5 << $n$addr$0$i;
      $sub5$i = (32 - ($n$addr$0$i))|0;
      $shr$i70 = $6 >>> $sub5$i;
      $or$i71 = $shr$i70 | $shl$i69;
      store4($arrayidx$i,$or$i71);
      $shl8$i72 = $6 << $n$addr$0$i;
      store4($p,$shl8$i72);
      $7 = $shl8$i72;$pshift$1 = 1;
     }
    } while(0);
    $or = $7 | 1;
    store4($p,$or);
    $add$ptr33 = (($head$0123) + ($width)|0);
    $cmp9 = ($add$ptr33>>>0)<($add$ptr1>>>0);
    if ($cmp9) {
     $2 = $or;$head$0123 = $add$ptr33;$pshift$0124 = $pshift$1;
    } else {
     $head$0$lcssa = $add$ptr33;$pshift$0$lcssa = $pshift$1;
     break;
    }
   }
  } else {
   $head$0$lcssa = $base;$pshift$0$lcssa = 1;
  }
  _trinkle($head$0$lcssa,$width,$cmp,$p,$pshift$0$lcssa,0,$lp);
  $arrayidx40 = ((($p)) + 4|0);
  $cmp37129 = ($pshift$0$lcssa|0)==(1);
  $8 = load4($p);
  $cmp39130 = ($8|0)==(1);
  $or$cond131 = $cmp37129 & $cmp39130;
  $9 = load4($arrayidx40);
  $cmp41132 = ($9|0)==(0);
  $or$cond127133 = $or$cond131 & $cmp41132;
  if (!($or$cond127133)) {
   $10 = $8;$11 = $9;$cmp41136 = $cmp41132;$head$1134 = $head$0$lcssa;$pshift$2135 = $pshift$0$lcssa;
   while(1) {
    $cmp43 = ($pshift$2135|0)<(2);
    if ($cmp43) {
     $sub$i106 = (($10) + -1)|0;
     $cmp$i$i = ($sub$i106|0)==(0);
     do {
      if ($cmp$i$i) {
       $call108111 = 32;
       label = 28;
      } else {
       $and4$i$i = $sub$i106 & 1;
       $lnot5$i$i = ($and4$i$i|0)==(0);
       if ($lnot5$i$i) {
        $nTrailingZeros$07$i$i = 0;$x$addr$06$i$i = $sub$i106;
        while(1) {
         $inc$i$i = (($nTrailingZeros$07$i$i) + 1)|0;
         $shr$i$i = $x$addr$06$i$i >>> 1;
         $and$i$i = $shr$i$i & 1;
         $lnot$i$i = ($and$i$i|0)==(0);
         if ($lnot$i$i) {
          $nTrailingZeros$07$i$i = $inc$i$i;$x$addr$06$i$i = $shr$i$i;
         } else {
          $call108 = $inc$i$i;
          break;
         }
        }
       } else {
        if ($cmp41136) {
         $retval$0$i15$i$ph = 32;
        } else {
         $and4$i5$i = $11 & 1;
         $lnot5$i6$i = ($and4$i5$i|0)==(0);
         if ($lnot5$i6$i) {
          $nTrailingZeros$07$i8$i = 0;$x$addr$06$i9$i = $11;
         } else {
          $12 = $10;$13 = $11;$call108112 = 0;$n$addr$0$i100 = 0;
          break;
         }
         while(1) {
          $inc$i10$i = (($nTrailingZeros$07$i8$i) + 1)|0;
          $shr$i11$i = $x$addr$06$i9$i >>> 1;
          $and$i12$i = $shr$i11$i & 1;
          $lnot$i13$i = ($and$i12$i|0)==(0);
          if ($lnot$i13$i) {
           $nTrailingZeros$07$i8$i = $inc$i10$i;$x$addr$06$i9$i = $shr$i11$i;
          } else {
           $retval$0$i15$i$ph = $inc$i10$i;
           break;
          }
         }
        }
        $add$i120 = (($retval$0$i15$i$ph) + 32)|0;
        $call108 = $add$i120;
       }
       $cmp$i93 = ($call108>>>0)>(31);
       if ($cmp$i93) {
        $call108111 = $call108;
        label = 28;
       } else {
        $12 = $10;$13 = $11;$call108112 = $call108;$n$addr$0$i100 = $call108;
       }
      }
     } while(0);
     if ((label|0) == 28) {
      label = 0;
      $sub$i98 = (($call108111) + -32)|0;
      store4($p,$11);
      store4($arrayidx$i,0);
      $12 = $11;$13 = 0;$call108112 = $call108111;$n$addr$0$i100 = $sub$i98;
     }
     $shr$i101 = $12 >>> $n$addr$0$i100;
     $sub5$i102 = (32 - ($n$addr$0$i100))|0;
     $shl$i103 = $13 << $sub5$i102;
     $or$i104 = $shl$i103 | $shr$i101;
     store4($p,$or$i104);
     $shr8$i105 = $13 >>> $n$addr$0$i100;
     store4($arrayidx$i,$shr8$i105);
     $add47 = (($call108112) + ($pshift$2135))|0;
     $$pre = (($head$1134) + ($idx$neg)|0);
     $head$1$be = $$pre;$pshift$2$be = $add47;
    } else {
     $shl$i88 = $11 << 2;
     $shr$i90 = $10 >>> 30;
     $or$i91 = $shr$i90 | $shl$i88;
     $sub50 = (($pshift$2135) + -2)|0;
     $14 = $10 << 1;
     $xor = $14 & 2147483646;
     $15 = $shr$i90 << 31;
     $shl$i80 = $xor | $15;
     $or$i81 = $shl$i80 ^ 3;
     store4($p,$or$i81);
     $shr8$i82 = $or$i91 >>> 1;
     store4($arrayidx$i,$shr8$i82);
     $arrayidx53 = (($lp) + ($sub50<<2)|0);
     $16 = load4($arrayidx53);
     $idx$neg54 = (0 - ($16))|0;
     $add$ptr55 = (($head$1134) + ($idx$neg54)|0);
     $add$ptr57 = (($add$ptr55) + ($idx$neg)|0);
     $add59 = (($pshift$2135) + -1)|0;
     _trinkle($add$ptr57,$width,$cmp,$p,$add59,1,$lp);
     $$pre$i60 = load4($arrayidx$i);
     $$pre11$i61 = load4($p);
     $shl$i62 = $$pre$i60 << 1;
     $shr$i63 = $$pre11$i61 >>> 31;
     $or$i64 = $shr$i63 | $shl$i62;
     store4($arrayidx$i,$or$i64);
     $shl8$i65 = $$pre11$i61 << 1;
     $or63 = $shl8$i65 | 1;
     store4($p,$or63);
     $add$ptr65 = (($head$1134) + ($idx$neg)|0);
     _trinkle($add$ptr65,$width,$cmp,$p,$sub50,1,$lp);
     $head$1$be = $add$ptr65;$pshift$2$be = $sub50;
    }
    $cmp37 = ($pshift$2$be|0)==(1);
    $17 = load4($p);
    $cmp39 = ($17|0)==(1);
    $or$cond = $cmp37 & $cmp39;
    $18 = load4($arrayidx40);
    $cmp41 = ($18|0)==(0);
    $or$cond127 = $or$cond & $cmp41;
    if ($or$cond127) {
     break;
    } else {
     $10 = $17;$11 = $18;$cmp41136 = $cmp41;$head$1134 = $head$1$be;$pshift$2135 = $pshift$2$be;
    }
   }
  }
 }
 STACKTOP = sp;return;
}
function _sift($head,$width,$cmp,$pshift,$lp) {
 $head = $head|0;
 $width = $width|0;
 $cmp = $cmp|0;
 $pshift = $pshift|0;
 $lp = $lp|0;
 var $$pre = 0, $0 = 0, $1 = 0, $add$ptr = 0, $add$ptr6 = 0, $ar = 0, $arrayidx15 = 0, $arrayidx4 = 0, $call = 0, $call10 = 0, $call12 = 0, $cmp1 = 0, $cmp11 = 0, $cmp121 = 0, $cmp13 = 0, $cmp8 = 0, $head$addr$0$be = 0, $head$addr$023 = 0, $i$0$lcssa = 0, $i$024 = 0;
 var $idx$neg = 0, $idx$neg5 = 0, $inc = 0, $pshift$addr$0$be = 0, $pshift$addr$022 = 0, $sub = 0, $sub16 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 240|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(240|0);
 $ar = sp;
 store4($ar,$head);
 $cmp121 = ($pshift|0)>(1);
 L1: do {
  if ($cmp121) {
   $idx$neg = (0 - ($width))|0;
   $1 = $head;$head$addr$023 = $head;$i$024 = 1;$pshift$addr$022 = $pshift;
   while(1) {
    $add$ptr = (($head$addr$023) + ($idx$neg)|0);
    $sub = (($pshift$addr$022) + -2)|0;
    $arrayidx4 = (($lp) + ($sub<<2)|0);
    $0 = load4($arrayidx4);
    $idx$neg5 = (0 - ($0))|0;
    $add$ptr6 = (($add$ptr) + ($idx$neg5)|0);
    $call = (FUNCTION_TABLE_iii[$cmp & 15]($1,$add$ptr6)|0);
    $cmp8 = ($call|0)>(-1);
    if ($cmp8) {
     $call10 = (FUNCTION_TABLE_iii[$cmp & 15]($1,$add$ptr)|0);
     $cmp11 = ($call10|0)>(-1);
     if ($cmp11) {
      $i$0$lcssa = $i$024;
      break L1;
     }
    }
    $call12 = (FUNCTION_TABLE_iii[$cmp & 15]($add$ptr6,$add$ptr)|0);
    $cmp13 = ($call12|0)>(-1);
    $inc = (($i$024) + 1)|0;
    $arrayidx15 = (($ar) + ($i$024<<2)|0);
    if ($cmp13) {
     store4($arrayidx15,$add$ptr6);
     $sub16 = (($pshift$addr$022) + -1)|0;
     $head$addr$0$be = $add$ptr6;$pshift$addr$0$be = $sub16;
    } else {
     store4($arrayidx15,$add$ptr);
     $head$addr$0$be = $add$ptr;$pshift$addr$0$be = $sub;
    }
    $cmp1 = ($pshift$addr$0$be|0)>(1);
    if (!($cmp1)) {
     $i$0$lcssa = $inc;
     break L1;
    }
    $$pre = load4($ar);
    $1 = $$pre;$head$addr$023 = $head$addr$0$be;$i$024 = $inc;$pshift$addr$022 = $pshift$addr$0$be;
   }
  } else {
   $i$0$lcssa = 1;
  }
 } while(0);
 _cycle($width,$ar,$i$0$lcssa);
 STACKTOP = sp;return;
}
function _trinkle($head,$width,$cmp,$pp,$pshift,$trusty,$lp) {
 $head = $head|0;
 $width = $width|0;
 $cmp = $cmp|0;
 $pp = $pp|0;
 $pshift = $pshift|0;
 $trusty = $trusty|0;
 $lp = $lp|0;
 var $$pre = 0, $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $add = 0, $add$i47 = 0, $add$ptr = 0, $add$ptr15 = 0, $add$ptr20 = 0, $add$ptr87 = 0, $add$ptr96 = 0, $and$i$i = 0, $and$i12$i = 0, $and4$i$i = 0;
 var $and4$i5$i = 0, $ar = 0, $arrayidx18 = 0, $arrayidx2 = 0, $arrayidx28 = 0, $arrayidx9 = 0, $arrayidx985 = 0, $call = 0, $call21 = 0, $call23 = 0, $call2930 = 0, $call293040 = 0, $call293041 = 0, $call88 = 0, $cmp$i = 0, $cmp$i$i = 0, $cmp$i4$i = 0, $cmp11 = 0, $cmp1189 = 0, $cmp12 = 0;
 var $cmp22 = 0, $cmp24 = 0, $cmp6 = 0, $cmp649 = 0, $cmp8 = 0, $cmp850 = 0, $head$addr$0$lcssa = 0, $head$addr$0$lcssa76 = 0, $head$addr$05790 = 0, $head$addr$05790$phi = 0, $i$0$lcssa = 0, $i$0$lcssa75 = 0, $i$05691 = 0, $idx$neg = 0, $idx$neg14 = 0, $idx$neg19 = 0, $idx$neg86 = 0, $inc = 0, $inc$i$i = 0, $inc$i10$i = 0;
 var $lnot$i$i = 0, $lnot$i13$i = 0, $lnot5$i$i = 0, $lnot5$i6$i = 0, $n$addr$0$i = 0, $nTrailingZeros$07$i$i = 0, $nTrailingZeros$07$i8$i = 0, $or$cond = 0, $or$i = 0, $p$sroa$0$05394 = 0, $p$sroa$8$05195 = 0, $phitmp = 0, $pshift$addr$0$lcssa = 0, $pshift$addr$0$lcssa74 = 0, $pshift$addr$05592 = 0, $retval$0$i15$i$ph = 0, $shl$i = 0, $shr$i = 0, $shr$i$i = 0, $shr$i11$i = 0;
 var $shr8$i = 0, $sub = 0, $sub$i = 0, $sub$i31 = 0, $sub$i3142 = 0, $sub5$i = 0, $tobool31 = 0, $trusty$addr$0$lcssa = 0, $trusty$addr$05493 = 0, $x$addr$06$i$i = 0, $x$addr$06$i9$i = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 240|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(240|0);
 $ar = sp;
 $0 = load4($pp);
 $arrayidx2 = ((($pp)) + 4|0);
 $1 = load4($arrayidx2);
 store4($ar,$head);
 $idx$neg14 = (0 - ($width))|0;
 $cmp649 = ($0|0)!=(1);
 $cmp850 = ($1|0)!=(0);
 $2 = $cmp850 | $cmp649;
 L1: do {
  if ($2) {
   $arrayidx985 = (($lp) + ($pshift<<2)|0);
   $3 = load4($arrayidx985);
   $idx$neg86 = (0 - ($3))|0;
   $add$ptr87 = (($head) + ($idx$neg86)|0);
   $call88 = (FUNCTION_TABLE_iii[$cmp & 15]($add$ptr87,$head)|0);
   $cmp1189 = ($call88|0)<(1);
   if ($cmp1189) {
    $head$addr$0$lcssa = $head;$i$0$lcssa = 1;$pshift$addr$0$lcssa = $pshift;$trusty$addr$0$lcssa = $trusty;
    label = 18;
   } else {
    $phitmp = ($trusty|0)==(0);
    $add$ptr96 = $add$ptr87;$head$addr$05790 = $head;$i$05691 = 1;$p$sroa$0$05394 = $0;$p$sroa$8$05195 = $1;$pshift$addr$05592 = $pshift;$trusty$addr$05493 = $phitmp;
    while(1) {
     $cmp12 = ($pshift$addr$05592|0)>(1);
     $or$cond = $trusty$addr$05493 & $cmp12;
     if ($or$cond) {
      $add$ptr15 = (($head$addr$05790) + ($idx$neg14)|0);
      $sub = (($pshift$addr$05592) + -2)|0;
      $arrayidx18 = (($lp) + ($sub<<2)|0);
      $4 = load4($arrayidx18);
      $call21 = (FUNCTION_TABLE_iii[$cmp & 15]($add$ptr15,$add$ptr96)|0);
      $cmp22 = ($call21|0)>(-1);
      if ($cmp22) {
       $head$addr$0$lcssa76 = $head$addr$05790;$i$0$lcssa75 = $i$05691;$pshift$addr$0$lcssa74 = $pshift$addr$05592;
       label = 19;
       break L1;
      }
      $idx$neg19 = (0 - ($4))|0;
      $add$ptr20 = (($add$ptr15) + ($idx$neg19)|0);
      $call23 = (FUNCTION_TABLE_iii[$cmp & 15]($add$ptr20,$add$ptr96)|0);
      $cmp24 = ($call23|0)>(-1);
      if ($cmp24) {
       $head$addr$0$lcssa76 = $head$addr$05790;$i$0$lcssa75 = $i$05691;$pshift$addr$0$lcssa74 = $pshift$addr$05592;
       label = 19;
       break L1;
      }
     }
     $inc = (($i$05691) + 1)|0;
     $arrayidx28 = (($ar) + ($i$05691<<2)|0);
     store4($arrayidx28,$add$ptr96);
     $sub$i = (($p$sroa$0$05394) + -1)|0;
     $cmp$i$i = ($sub$i|0)==(0);
     do {
      if ($cmp$i$i) {
       $call293041 = 32;$sub$i3142 = 0;
       label = 15;
      } else {
       $and4$i$i = $sub$i & 1;
       $lnot5$i$i = ($and4$i$i|0)==(0);
       if ($lnot5$i$i) {
        $nTrailingZeros$07$i$i = 0;$x$addr$06$i$i = $sub$i;
        while(1) {
         $inc$i$i = (($nTrailingZeros$07$i$i) + 1)|0;
         $shr$i$i = $x$addr$06$i$i >>> 1;
         $and$i$i = $shr$i$i & 1;
         $lnot$i$i = ($and$i$i|0)==(0);
         if ($lnot$i$i) {
          $nTrailingZeros$07$i$i = $inc$i$i;$x$addr$06$i$i = $shr$i$i;
         } else {
          $call2930 = $inc$i$i;
          break;
         }
        }
       } else {
        $cmp$i4$i = ($p$sroa$8$05195|0)==(0);
        if ($cmp$i4$i) {
         $retval$0$i15$i$ph = 32;
        } else {
         $and4$i5$i = $p$sroa$8$05195 & 1;
         $lnot5$i6$i = ($and4$i5$i|0)==(0);
         if ($lnot5$i6$i) {
          $nTrailingZeros$07$i8$i = 0;$x$addr$06$i9$i = $p$sroa$8$05195;
         } else {
          $5 = $p$sroa$0$05394;$6 = $p$sroa$8$05195;$call293040 = 0;$n$addr$0$i = 0;
          break;
         }
         while(1) {
          $inc$i10$i = (($nTrailingZeros$07$i8$i) + 1)|0;
          $shr$i11$i = $x$addr$06$i9$i >>> 1;
          $and$i12$i = $shr$i11$i & 1;
          $lnot$i13$i = ($and$i12$i|0)==(0);
          if ($lnot$i13$i) {
           $nTrailingZeros$07$i8$i = $inc$i10$i;$x$addr$06$i9$i = $shr$i11$i;
          } else {
           $retval$0$i15$i$ph = $inc$i10$i;
           break;
          }
         }
        }
        $add$i47 = (($retval$0$i15$i$ph) + 32)|0;
        $call2930 = $add$i47;
       }
       $cmp$i = ($call2930>>>0)>(31);
       $sub$i31 = (($call2930) + -32)|0;
       if ($cmp$i) {
        $call293041 = $call2930;$sub$i3142 = $sub$i31;
        label = 15;
       } else {
        $5 = $p$sroa$0$05394;$6 = $p$sroa$8$05195;$call293040 = $call2930;$n$addr$0$i = $call2930;
       }
      }
     } while(0);
     if ((label|0) == 15) {
      label = 0;
      $5 = $p$sroa$8$05195;$6 = 0;$call293040 = $call293041;$n$addr$0$i = $sub$i3142;
     }
     $shr$i = $5 >>> $n$addr$0$i;
     $sub5$i = (32 - ($n$addr$0$i))|0;
     $shl$i = $6 << $sub5$i;
     $or$i = $shl$i | $shr$i;
     $shr8$i = $6 >>> $n$addr$0$i;
     $add = (($call293040) + ($pshift$addr$05592))|0;
     $cmp6 = ($or$i|0)!=(1);
     $cmp8 = ($shr8$i|0)!=(0);
     $7 = $cmp8 | $cmp6;
     if (!($7)) {
      $head$addr$0$lcssa76 = $add$ptr96;$i$0$lcssa75 = $inc;$pshift$addr$0$lcssa74 = $add;
      label = 19;
      break L1;
     }
     $$pre = load4($ar);
     $arrayidx9 = (($lp) + ($add<<2)|0);
     $8 = load4($arrayidx9);
     $idx$neg = (0 - ($8))|0;
     $add$ptr = (($add$ptr96) + ($idx$neg)|0);
     $call = (FUNCTION_TABLE_iii[$cmp & 15]($add$ptr,$$pre)|0);
     $cmp11 = ($call|0)<(1);
     if ($cmp11) {
      $head$addr$0$lcssa = $add$ptr96;$i$0$lcssa = $inc;$pshift$addr$0$lcssa = $add;$trusty$addr$0$lcssa = 0;
      label = 18;
      break;
     } else {
      $head$addr$05790$phi = $add$ptr96;$add$ptr96 = $add$ptr;$i$05691 = $inc;$p$sroa$0$05394 = $or$i;$p$sroa$8$05195 = $shr8$i;$pshift$addr$05592 = $add;$trusty$addr$05493 = 1;$head$addr$05790 = $head$addr$05790$phi;
     }
    }
   }
  } else {
   $head$addr$0$lcssa = $head;$i$0$lcssa = 1;$pshift$addr$0$lcssa = $pshift;$trusty$addr$0$lcssa = $trusty;
   label = 18;
  }
 } while(0);
 if ((label|0) == 18) {
  $tobool31 = ($trusty$addr$0$lcssa|0)==(0);
  if ($tobool31) {
   $head$addr$0$lcssa76 = $head$addr$0$lcssa;$i$0$lcssa75 = $i$0$lcssa;$pshift$addr$0$lcssa74 = $pshift$addr$0$lcssa;
   label = 19;
  }
 }
 if ((label|0) == 19) {
  _cycle($width,$ar,$i$0$lcssa75);
  _sift($head$addr$0$lcssa76,$width,$cmp,$pshift$addr$0$lcssa74,$lp);
 }
 STACKTOP = sp;return;
}
function _cycle($width,$ar,$n) {
 $width = $width|0;
 $ar = $ar|0;
 $n = $n|0;
 var $$pre = 0, $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $add = 0, $add$ptr = 0, $arrayidx = 0, $arrayidx7 = 0, $arrayidx8 = 0, $cmp = 0, $cmp3 = 0, $cond = 0, $exitcond = 0, $i$022 = 0, $sub = 0, $tmp = 0, $tobool = 0, $tobool23 = 0;
 var $width$addr$024 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 256|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(256|0);
 $tmp = sp;
 $cmp = ($n|0)<(2);
 L1: do {
  if (!($cmp)) {
   $arrayidx = (($ar) + ($n<<2)|0);
   store4($arrayidx,$tmp);
   $tobool23 = ($width|0)==(0);
   if (!($tobool23)) {
    $1 = $tmp;$width$addr$024 = $width;
    while(1) {
     $cmp3 = ($width$addr$024>>>0)>(256);
     $cond = $cmp3 ? 256 : $width$addr$024;
     $0 = load4($ar);
     _memcpy(($1|0),($0|0),($cond|0))|0;
     $i$022 = 0;
     while(1) {
      $arrayidx7 = (($ar) + ($i$022<<2)|0);
      $2 = load4($arrayidx7);
      $add = (($i$022) + 1)|0;
      $arrayidx8 = (($ar) + ($add<<2)|0);
      $3 = load4($arrayidx8);
      _memcpy(($2|0),($3|0),($cond|0))|0;
      $4 = load4($arrayidx7);
      $add$ptr = (($4) + ($cond)|0);
      store4($arrayidx7,$add$ptr);
      $exitcond = ($add|0)==($n|0);
      if ($exitcond) {
       break;
      } else {
       $i$022 = $add;
      }
     }
     $sub = (($width$addr$024) - ($cond))|0;
     $tobool = ($sub|0)==(0);
     if ($tobool) {
      break L1;
     }
     $$pre = load4($arrayidx);
     $1 = $$pre;$width$addr$024 = $sub;
    }
   }
  }
 } while(0);
 STACKTOP = sp;return;
}
function _close($fd) {
 $fd = $fd|0;
 var $$call = 0, $call = 0, $call1 = 0, $cmp = 0, $vararg_buffer = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $vararg_buffer = sp;
 store4($vararg_buffer,$fd);
 $call = (___syscall6(6,($vararg_buffer|0))|0);
 $cmp = ($call|0)==(-4);
 $$call = $cmp ? -115 : $call;
 $call1 = (___syscall_ret($$call)|0);
 STACKTOP = sp;return ($call1|0);
}
function _readdir_r($dir,$buf,$result) {
 $dir = $dir|0;
 $buf = $buf|0;
 $result = $result|0;
 var $0 = 0, $1 = 0, $2 = 0, $arraydecay = 0, $buf$addr$0 = 0, $call = 0, $call2 = 0, $conv = 0, $d_reclen = 0, $retval$0 = 0, $tobool = 0, $tobool7 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $call = (___errno_location()|0);
 $0 = load4($call);
 $arraydecay = ((($dir)) + 16|0);
 ___lock(($arraydecay|0));
 store4($call,0);
 $call2 = (_readdir($dir)|0);
 $1 = load4($call);
 $tobool = ($1|0)==(0);
 if ($tobool) {
  store4($call,$0);
  $tobool7 = ($call2|0)==(0|0);
  if ($tobool7) {
   $buf$addr$0 = 0;
  } else {
   $d_reclen = ((($call2)) + 8|0);
   $2 = load2($d_reclen);
   $conv = $2&65535;
   _memcpy(($buf|0),($call2|0),($conv|0))|0;
   $buf$addr$0 = $buf;
  }
  ___unlock(($arraydecay|0));
  store4($result,$buf$addr$0);
  $retval$0 = 0;
 } else {
  ___unlock(($arraydecay|0));
  $retval$0 = $1;
 }
 return ($retval$0|0);
}
function ___strchrnul($s,$c) {
 $s = $s|0;
 $c = $c|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $add$ptr = 0, $and = 0, $and14 = 0, $and15 = 0, $and29 = 0, $and9 = 0, $and930 = 0, $call = 0, $cmp = 0, $cmp26 = 0, $conv1 = 0;
 var $incdec$ptr = 0, $incdec$ptr19 = 0, $incdec$ptr31 = 0, $lnot = 0, $mul = 0, $neg = 0, $neg13 = 0, $neg28 = 0, $or$cond = 0, $or$cond24 = 0, $rem = 0, $rem34 = 0, $retval$0 = 0, $s$addr$0$lcssa = 0, $s$addr$036 = 0, $s$addr$1 = 0, $sub = 0, $sub11 = 0, $sub27 = 0, $tobool = 0;
 var $tobool10 = 0, $tobool1031 = 0, $tobool2 = 0, $tobool23 = 0, $tobool235 = 0, $tobool3 = 0, $w$0$lcssa = 0, $w$032 = 0, $xor = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $conv1 = $c & 255;
 $tobool = ($conv1|0)==(0);
 L1: do {
  if ($tobool) {
   $call = (_strlen($s)|0);
   $add$ptr = (($s) + ($call)|0);
   $retval$0 = $add$ptr;
  } else {
   $0 = $s;
   $rem34 = $0 & 3;
   $tobool235 = ($rem34|0)==(0);
   if ($tobool235) {
    $s$addr$0$lcssa = $s;
   } else {
    $1 = $c&255;
    $s$addr$036 = $s;
    while(1) {
     $2 = load1($s$addr$036);
     $tobool3 = ($2<<24>>24)==(0);
     $cmp = ($2<<24>>24)==($1<<24>>24);
     $or$cond = $tobool3 | $cmp;
     if ($or$cond) {
      $retval$0 = $s$addr$036;
      break L1;
     }
     $incdec$ptr = ((($s$addr$036)) + 1|0);
     $3 = $incdec$ptr;
     $rem = $3 & 3;
     $tobool2 = ($rem|0)==(0);
     if ($tobool2) {
      $s$addr$0$lcssa = $incdec$ptr;
      break;
     } else {
      $s$addr$036 = $incdec$ptr;
     }
    }
   }
   $mul = Math_imul($conv1, 16843009)|0;
   $4 = load4($s$addr$0$lcssa);
   $sub27 = (($4) + -16843009)|0;
   $neg28 = $4 & -2139062144;
   $and29 = $neg28 ^ -2139062144;
   $and930 = $and29 & $sub27;
   $tobool1031 = ($and930|0)==(0);
   L10: do {
    if ($tobool1031) {
     $5 = $4;$w$032 = $s$addr$0$lcssa;
     while(1) {
      $xor = $5 ^ $mul;
      $sub11 = (($xor) + -16843009)|0;
      $neg13 = $xor & -2139062144;
      $and14 = $neg13 ^ -2139062144;
      $and15 = $and14 & $sub11;
      $lnot = ($and15|0)==(0);
      if (!($lnot)) {
       $w$0$lcssa = $w$032;
       break L10;
      }
      $incdec$ptr19 = ((($w$032)) + 4|0);
      $6 = load4($incdec$ptr19);
      $sub = (($6) + -16843009)|0;
      $neg = $6 & -2139062144;
      $and = $neg ^ -2139062144;
      $and9 = $and & $sub;
      $tobool10 = ($and9|0)==(0);
      if ($tobool10) {
       $5 = $6;$w$032 = $incdec$ptr19;
      } else {
       $w$0$lcssa = $incdec$ptr19;
       break;
      }
     }
    } else {
     $w$0$lcssa = $s$addr$0$lcssa;
    }
   } while(0);
   $7 = $c&255;
   $s$addr$1 = $w$0$lcssa;
   while(1) {
    $8 = load1($s$addr$1);
    $tobool23 = ($8<<24>>24)==(0);
    $cmp26 = ($8<<24>>24)==($7<<24>>24);
    $or$cond24 = $tobool23 | $cmp26;
    $incdec$ptr31 = ((($s$addr$1)) + 1|0);
    if ($or$cond24) {
     $retval$0 = $s$addr$1;
     break;
    } else {
     $s$addr$1 = $incdec$ptr31;
    }
   }
  }
 } while(0);
 return ($retval$0|0);
}
function _memchr($src,$c,$n) {
 $src = $src|0;
 $c = $c|0;
 $n = $n|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $and = 0, $and15 = 0, $and16 = 0, $and39 = 0, $cmp = 0, $cmp11 = 0, $cmp1132 = 0, $cmp28 = 0, $cmp8 = 0, $cond = 0, $conv1 = 0, $dec = 0;
 var $dec34 = 0, $incdec$ptr = 0, $incdec$ptr21 = 0, $incdec$ptr33 = 0, $lnot = 0, $mul = 0, $n$addr$0$lcssa = 0, $n$addr$0$lcssa52 = 0, $n$addr$043 = 0, $n$addr$1$lcssa = 0, $n$addr$133 = 0, $n$addr$227 = 0, $n$addr$3 = 0, $neg = 0, $or$cond = 0, $or$cond42 = 0, $s$0$lcssa = 0, $s$0$lcssa53 = 0, $s$044 = 0, $s$128 = 0;
 var $s$2 = 0, $sub = 0, $sub22 = 0, $tobool = 0, $tobool2 = 0, $tobool2$lcssa = 0, $tobool241 = 0, $tobool25 = 0, $tobool2526 = 0, $tobool36 = 0, $tobool40 = 0, $w$0$lcssa = 0, $w$034 = 0, $xor = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $conv1 = $c & 255;
 $0 = $src;
 $and39 = $0 & 3;
 $tobool40 = ($and39|0)!=(0);
 $tobool241 = ($n|0)!=(0);
 $or$cond42 = $tobool241 & $tobool40;
 L1: do {
  if ($or$cond42) {
   $1 = $c&255;
   $n$addr$043 = $n;$s$044 = $src;
   while(1) {
    $2 = load1($s$044);
    $cmp = ($2<<24>>24)==($1<<24>>24);
    if ($cmp) {
     $n$addr$0$lcssa52 = $n$addr$043;$s$0$lcssa53 = $s$044;
     label = 6;
     break L1;
    }
    $incdec$ptr = ((($s$044)) + 1|0);
    $dec = (($n$addr$043) + -1)|0;
    $3 = $incdec$ptr;
    $and = $3 & 3;
    $tobool = ($and|0)!=(0);
    $tobool2 = ($dec|0)!=(0);
    $or$cond = $tobool2 & $tobool;
    if ($or$cond) {
     $n$addr$043 = $dec;$s$044 = $incdec$ptr;
    } else {
     $n$addr$0$lcssa = $dec;$s$0$lcssa = $incdec$ptr;$tobool2$lcssa = $tobool2;
     label = 5;
     break;
    }
   }
  } else {
   $n$addr$0$lcssa = $n;$s$0$lcssa = $src;$tobool2$lcssa = $tobool241;
   label = 5;
  }
 } while(0);
 if ((label|0) == 5) {
  if ($tobool2$lcssa) {
   $n$addr$0$lcssa52 = $n$addr$0$lcssa;$s$0$lcssa53 = $s$0$lcssa;
   label = 6;
  } else {
   $n$addr$3 = 0;$s$2 = $s$0$lcssa;
  }
 }
 L8: do {
  if ((label|0) == 6) {
   $4 = load1($s$0$lcssa53);
   $5 = $c&255;
   $cmp8 = ($4<<24>>24)==($5<<24>>24);
   if ($cmp8) {
    $n$addr$3 = $n$addr$0$lcssa52;$s$2 = $s$0$lcssa53;
   } else {
    $mul = Math_imul($conv1, 16843009)|0;
    $cmp1132 = ($n$addr$0$lcssa52>>>0)>(3);
    L11: do {
     if ($cmp1132) {
      $n$addr$133 = $n$addr$0$lcssa52;$w$034 = $s$0$lcssa53;
      while(1) {
       $6 = load4($w$034);
       $xor = $6 ^ $mul;
       $sub = (($xor) + -16843009)|0;
       $neg = $xor & -2139062144;
       $and15 = $neg ^ -2139062144;
       $and16 = $and15 & $sub;
       $lnot = ($and16|0)==(0);
       if (!($lnot)) {
        break;
       }
       $incdec$ptr21 = ((($w$034)) + 4|0);
       $sub22 = (($n$addr$133) + -4)|0;
       $cmp11 = ($sub22>>>0)>(3);
       if ($cmp11) {
        $n$addr$133 = $sub22;$w$034 = $incdec$ptr21;
       } else {
        $n$addr$1$lcssa = $sub22;$w$0$lcssa = $incdec$ptr21;
        label = 11;
        break L11;
       }
      }
      $n$addr$227 = $n$addr$133;$s$128 = $w$034;
     } else {
      $n$addr$1$lcssa = $n$addr$0$lcssa52;$w$0$lcssa = $s$0$lcssa53;
      label = 11;
     }
    } while(0);
    if ((label|0) == 11) {
     $tobool2526 = ($n$addr$1$lcssa|0)==(0);
     if ($tobool2526) {
      $n$addr$3 = 0;$s$2 = $w$0$lcssa;
      break;
     } else {
      $n$addr$227 = $n$addr$1$lcssa;$s$128 = $w$0$lcssa;
     }
    }
    while(1) {
     $7 = load1($s$128);
     $cmp28 = ($7<<24>>24)==($5<<24>>24);
     if ($cmp28) {
      $n$addr$3 = $n$addr$227;$s$2 = $s$128;
      break L8;
     }
     $incdec$ptr33 = ((($s$128)) + 1|0);
     $dec34 = (($n$addr$227) + -1)|0;
     $tobool25 = ($dec34|0)==(0);
     if ($tobool25) {
      $n$addr$3 = 0;$s$2 = $incdec$ptr33;
      break;
     } else {
      $n$addr$227 = $dec34;$s$128 = $incdec$ptr33;
     }
    }
   }
  }
 } while(0);
 $tobool36 = ($n$addr$3|0)!=(0);
 $cond = $tobool36 ? $s$2 : 0;
 return ($cond|0);
}
function _strchr($s,$c) {
 $s = $s|0;
 $c = $c|0;
 var $0 = 0, $1 = 0, $call = 0, $cmp = 0, $cond = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $call = (___strchrnul($s,$c)|0);
 $0 = load1($call);
 $1 = $c&255;
 $cmp = ($0<<24>>24)==($1<<24>>24);
 $cond = $cmp ? $call : 0;
 return ($cond|0);
}
function ___lockfile($f) {
 $f = $f|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0;
}
function _fflush($f) {
 $f = $f|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $call = 0, $call1 = 0, $call118 = 0, $call16 = 0, $call22 = 0, $call7 = 0, $cmp = 0, $cmp14 = 0, $cmp20 = 0, $cond10 = 0, $cond19 = 0, $f$addr$0 = 0, $f$addr$019 = 0, $f$addr$022 = 0;
 var $lock = 0, $lock13 = 0, $next = 0, $or = 0, $phitmp = 0, $r$0$lcssa = 0, $r$021 = 0, $r$1 = 0, $retval$0 = 0, $tobool = 0, $tobool11 = 0, $tobool1120 = 0, $tobool24 = 0, $tobool5 = 0, $wbase = 0, $wpos = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $tobool = ($f|0)==(0|0);
 do {
  if ($tobool) {
   $1 = load4(1340);
   $tobool5 = ($1|0)==(0|0);
   if ($tobool5) {
    $cond10 = 0;
   } else {
    $2 = load4(1340);
    $call7 = (_fflush($2)|0);
    $cond10 = $call7;
   }
   ___lock(((8424)|0));
   $f$addr$019 = load4((8420));
   $tobool1120 = ($f$addr$019|0)==(0|0);
   if ($tobool1120) {
    $r$0$lcssa = $cond10;
   } else {
    $f$addr$022 = $f$addr$019;$r$021 = $cond10;
    while(1) {
     $lock13 = ((($f$addr$022)) + 76|0);
     $3 = load4($lock13);
     $cmp14 = ($3|0)>(-1);
     if ($cmp14) {
      $call16 = (___lockfile($f$addr$022)|0);
      $cond19 = $call16;
     } else {
      $cond19 = 0;
     }
     $wpos = ((($f$addr$022)) + 20|0);
     $4 = load4($wpos);
     $wbase = ((($f$addr$022)) + 28|0);
     $5 = load4($wbase);
     $cmp20 = ($4>>>0)>($5>>>0);
     if ($cmp20) {
      $call22 = (___fflush_unlocked($f$addr$022)|0);
      $or = $call22 | $r$021;
      $r$1 = $or;
     } else {
      $r$1 = $r$021;
     }
     $tobool24 = ($cond19|0)==(0);
     if (!($tobool24)) {
      ___unlockfile($f$addr$022);
     }
     $next = ((($f$addr$022)) + 56|0);
     $f$addr$0 = load4($next);
     $tobool11 = ($f$addr$0|0)==(0|0);
     if ($tobool11) {
      $r$0$lcssa = $r$1;
      break;
     } else {
      $f$addr$022 = $f$addr$0;$r$021 = $r$1;
     }
    }
   }
   ___unlock(((8424)|0));
   $retval$0 = $r$0$lcssa;
  } else {
   $lock = ((($f)) + 76|0);
   $0 = load4($lock);
   $cmp = ($0|0)>(-1);
   if (!($cmp)) {
    $call118 = (___fflush_unlocked($f)|0);
    $retval$0 = $call118;
    break;
   }
   $call = (___lockfile($f)|0);
   $phitmp = ($call|0)==(0);
   $call1 = (___fflush_unlocked($f)|0);
   if ($phitmp) {
    $retval$0 = $call1;
   } else {
    ___unlockfile($f);
    $retval$0 = $call1;
   }
  }
 } while(0);
 return ($retval$0|0);
}
function ___fflush_unlocked($f) {
 $f = $f|0;
 var $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $cmp = 0, $cmp4 = 0, $rend = 0, $retval$0 = 0, $rpos = 0, $seek = 0, $sub$ptr$lhs$cast = 0, $sub$ptr$rhs$cast = 0, $sub$ptr$sub = 0, $tobool = 0, $wbase = 0, $wend = 0, $wpos = 0;
 var $write = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $wpos = ((($f)) + 20|0);
 $0 = load4($wpos);
 $wbase = ((($f)) + 28|0);
 $1 = load4($wbase);
 $cmp = ($0>>>0)>($1>>>0);
 if ($cmp) {
  $write = ((($f)) + 36|0);
  $2 = load4($write);
  (FUNCTION_TABLE_iiii[$2 & 7]($f,0,0)|0);
  $3 = load4($wpos);
  $tobool = ($3|0)==(0|0);
  if ($tobool) {
   $retval$0 = -1;
  } else {
   label = 3;
  }
 } else {
  label = 3;
 }
 if ((label|0) == 3) {
  $rpos = ((($f)) + 4|0);
  $4 = load4($rpos);
  $rend = ((($f)) + 8|0);
  $5 = load4($rend);
  $cmp4 = ($4>>>0)<($5>>>0);
  if ($cmp4) {
   $seek = ((($f)) + 40|0);
   $6 = load4($seek);
   $sub$ptr$lhs$cast = $4;
   $sub$ptr$rhs$cast = $5;
   $sub$ptr$sub = (($sub$ptr$lhs$cast) - ($sub$ptr$rhs$cast))|0;
   (FUNCTION_TABLE_iiii[$6 & 7]($f,$sub$ptr$sub,1)|0);
  }
  $wend = ((($f)) + 16|0);
  store4($wend,0);
  store4($wbase,0);
  store4($wpos,0);
  store4($rend,0);
  store4($rpos,0);
  $retval$0 = 0;
 }
 return ($retval$0|0);
}
function _strcpy($dest,$src) {
 $dest = $dest|0;
 $src = $src|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 (___stpcpy($dest,$src)|0);
 return ($dest|0);
}
function ___stpcpy($d,$s) {
 $d = $d|0;
 $s = $s|0;
 var $0 = 0, $1 = 0, $10 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $and = 0, $and28 = 0, $and7 = 0, $and729 = 0, $cmp = 0, $d$addr$0$lcssa = 0, $d$addr$037 = 0, $d$addr$1$ph = 0, $d$addr$124 = 0;
 var $incdec$ptr = 0, $incdec$ptr11 = 0, $incdec$ptr12 = 0, $incdec$ptr19 = 0, $incdec$ptr20 = 0, $incdec$ptr5 = 0, $lnot = 0, $lnot30 = 0, $neg = 0, $neg27 = 0, $rem2 = 0, $rem235 = 0, $retval$0 = 0, $s$addr$0$lcssa = 0, $s$addr$038 = 0, $s$addr$1$ph = 0, $s$addr$125 = 0, $sub = 0, $sub26 = 0, $tobool = 0;
 var $tobool16 = 0, $tobool1623 = 0, $tobool3 = 0, $tobool36 = 0, $wd$0$lcssa = 0, $wd$031 = 0, $ws$0$lcssa = 0, $ws$032 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = $s;
 $1 = $d;
 $2 = $0 ^ $1;
 $3 = $2 & 3;
 $cmp = ($3|0)==(0);
 L1: do {
  if ($cmp) {
   $rem235 = $0 & 3;
   $tobool36 = ($rem235|0)==(0);
   if ($tobool36) {
    $d$addr$0$lcssa = $d;$s$addr$0$lcssa = $s;
   } else {
    $d$addr$037 = $d;$s$addr$038 = $s;
    while(1) {
     $4 = load1($s$addr$038);
     store1($d$addr$037,$4);
     $tobool3 = ($4<<24>>24)==(0);
     if ($tobool3) {
      $retval$0 = $d$addr$037;
      break L1;
     }
     $incdec$ptr = ((($s$addr$038)) + 1|0);
     $incdec$ptr5 = ((($d$addr$037)) + 1|0);
     $5 = $incdec$ptr;
     $rem2 = $5 & 3;
     $tobool = ($rem2|0)==(0);
     if ($tobool) {
      $d$addr$0$lcssa = $incdec$ptr5;$s$addr$0$lcssa = $incdec$ptr;
      break;
     } else {
      $d$addr$037 = $incdec$ptr5;$s$addr$038 = $incdec$ptr;
     }
    }
   }
   $6 = load4($s$addr$0$lcssa);
   $sub26 = (($6) + -16843009)|0;
   $neg27 = $6 & -2139062144;
   $and28 = $neg27 ^ -2139062144;
   $and729 = $and28 & $sub26;
   $lnot30 = ($and729|0)==(0);
   if ($lnot30) {
    $7 = $6;$wd$031 = $d$addr$0$lcssa;$ws$032 = $s$addr$0$lcssa;
    while(1) {
     $incdec$ptr11 = ((($ws$032)) + 4|0);
     $incdec$ptr12 = ((($wd$031)) + 4|0);
     store4($wd$031,$7);
     $8 = load4($incdec$ptr11);
     $sub = (($8) + -16843009)|0;
     $neg = $8 & -2139062144;
     $and = $neg ^ -2139062144;
     $and7 = $and & $sub;
     $lnot = ($and7|0)==(0);
     if ($lnot) {
      $7 = $8;$wd$031 = $incdec$ptr12;$ws$032 = $incdec$ptr11;
     } else {
      $wd$0$lcssa = $incdec$ptr12;$ws$0$lcssa = $incdec$ptr11;
      break;
     }
    }
   } else {
    $wd$0$lcssa = $d$addr$0$lcssa;$ws$0$lcssa = $s$addr$0$lcssa;
   }
   $d$addr$1$ph = $wd$0$lcssa;$s$addr$1$ph = $ws$0$lcssa;
   label = 8;
  } else {
   $d$addr$1$ph = $d;$s$addr$1$ph = $s;
   label = 8;
  }
 } while(0);
 if ((label|0) == 8) {
  $9 = load1($s$addr$1$ph);
  store1($d$addr$1$ph,$9);
  $tobool1623 = ($9<<24>>24)==(0);
  if ($tobool1623) {
   $retval$0 = $d$addr$1$ph;
  } else {
   $d$addr$124 = $d$addr$1$ph;$s$addr$125 = $s$addr$1$ph;
   while(1) {
    $incdec$ptr19 = ((($s$addr$125)) + 1|0);
    $incdec$ptr20 = ((($d$addr$124)) + 1|0);
    $10 = load1($incdec$ptr19);
    store1($incdec$ptr20,$10);
    $tobool16 = ($10<<24>>24)==(0);
    if ($tobool16) {
     $retval$0 = $incdec$ptr20;
     break;
    } else {
     $d$addr$124 = $incdec$ptr20;$s$addr$125 = $incdec$ptr19;
    }
   }
  }
 }
 return ($retval$0|0);
}
function _strnlen($s,$n) {
 $s = $s|0;
 $n = $n|0;
 var $call = 0, $cond = 0, $sub$ptr$lhs$cast = 0, $sub$ptr$rhs$cast = 0, $sub$ptr$sub = 0, $tobool = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $call = (_memchr($s,0,$n)|0);
 $tobool = ($call|0)==(0|0);
 $sub$ptr$lhs$cast = $call;
 $sub$ptr$rhs$cast = $s;
 $sub$ptr$sub = (($sub$ptr$lhs$cast) - ($sub$ptr$rhs$cast))|0;
 $cond = $tobool ? $n : $sub$ptr$sub;
 return ($cond|0);
}
function _wctype($s) {
 $s = $s|0;
 var $0 = 0, $1 = 0, $2 = 0, $add$ptr = 0, $call = 0, $cmp = 0, $i$08 = 0, $inc = 0, $p$09 = 0, $retval$0 = 0, $tobool = 0, $tobool3 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = load1($s);
 $1 = 97;$i$08 = 1;$p$09 = 5148;
 while(1) {
  $cmp = ($0<<24>>24)==($1<<24>>24);
  if ($cmp) {
   $call = (_strcmp($s,$p$09)|0);
   $tobool3 = ($call|0)==(0);
   if ($tobool3) {
    $retval$0 = $i$08;
    break;
   }
  }
  $inc = (($i$08) + 1)|0;
  $add$ptr = ((($p$09)) + 6|0);
  $2 = load1($add$ptr);
  $tobool = ($2<<24>>24)==(0);
  if ($tobool) {
   $retval$0 = 0;
   break;
  } else {
   $1 = $2;$i$08 = $inc;$p$09 = $add$ptr;
  }
 }
 return ($retval$0|0);
}
function _iswlower($wc) {
 $wc = $wc|0;
 var $0 = 0, $call = 0, $cmp = 0, $cmp1 = 0, $lor$ext = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $call = (_towupper($wc)|0);
 $cmp = ($call|0)!=($wc|0);
 $cmp1 = ($wc|0)==(223);
 $0 = $cmp1 | $cmp;
 $lor$ext = $0&1;
 return ($lor$ext|0);
}
function _towupper($wc) {
 $wc = $wc|0;
 var $call = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $call = (___towcase($wc,0)|0);
 return ($call|0);
}
function _iswupper($wc) {
 $wc = $wc|0;
 var $call = 0, $cmp = 0, $conv = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $call = (_towlower($wc)|0);
 $cmp = ($call|0)!=($wc|0);
 $conv = $cmp&1;
 return ($conv|0);
}
function _towlower($wc) {
 $wc = $wc|0;
 var $call = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $call = (___towcase($wc,1)|0);
 return ($call|0);
}
function _iswxdigit($wc) {
 $wc = $wc|0;
 var $0 = 0, $cmp = 0, $cmp2 = 0, $lor$ext = 0, $or = 0, $sub = 0, $sub1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $sub = (($wc) + -48)|0;
 $cmp = ($sub>>>0)<(10);
 $or = $wc | 32;
 $sub1 = (($or) + -97)|0;
 $cmp2 = ($sub1>>>0)<(6);
 $0 = $cmp | $cmp2;
 $lor$ext = $0&1;
 return ($lor$ext|0);
}
function _iswdigit($wc) {
 $wc = $wc|0;
 var $cmp = 0, $conv = 0, $sub = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $sub = (($wc) + -48)|0;
 $cmp = ($sub>>>0)<(10);
 $conv = $cmp&1;
 return ($conv|0);
}
function ___towcase($wc,$lower) {
 $wc = $wc|0;
 $lower = $lower|0;
 var $$neg = 0, $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $add41$neg = 0, $add55 = 0, $add67 = 0, $add97 = 0, $add97$wc = 0, $and = 0, $and60 = 0, $arrayidx72 = 0, $arrayidx7254 = 0, $arrayidx83 = 0, $call = 0, $cmp = 0;
 var $cmp11 = 0, $cmp13 = 0, $cmp24 = 0, $cmp26 = 0, $cmp46 = 0, $cmp5 = 0, $cmp52 = 0, $cmp79 = 0, $cmp8 = 0, $cmp92 = 0, $conv = 0, $conv40 = 0, $conv45 = 0, $conv78 = 0, $conv84 = 0, $i$057 = 0, $i$156 = 0, $inc = 0, $inc87 = 0, $len = 0;
 var $lower39 = 0, $mul = 0, $mul66 = 0, $mul96 = 0, $or$cond = 0, $or$cond48 = 0, $or$cond49 = 0, $or$cond50 = 0, $or$cond51 = 0, $retval$2 = 0, $sub = 0, $sub1 = 0, $sub10 = 0, $sub19 = 0, $sub2 = 0, $sub23 = 0, $sub34 = 0, $sub4 = 0, $sub42 = 0, $sub61 = 0;
 var $sub7 = 0, $sub70 = 0, $sub90$neg = 0, $sub91 = 0, $sub95 = 0, $tobool = 0, $tobool36 = 0, $tobool73 = 0, $tobool7355 = 0, $tobool9 = 0, $tobool9$not = 0, $upper = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $mul = $lower << 1;
 $sub = (($mul) + -1)|0;
 $sub1 = (($lower) + -1)|0;
 $call = (_iswalpha($wc)|0);
 $tobool = ($call|0)==(0);
 $sub2 = (($wc) + -1536)|0;
 $cmp = ($sub2>>>0)<(2560);
 $or$cond48 = $cmp | $tobool;
 $sub4 = (($wc) + -11776)|0;
 $cmp5 = ($sub4>>>0)<(30784);
 $or$cond49 = $cmp5 | $or$cond48;
 $sub7 = (($wc) + -43008)|0;
 $cmp8 = ($sub7>>>0)<(22272);
 $or$cond50 = $cmp8 | $or$cond49;
 L1: do {
  if ($or$cond50) {
   $retval$2 = $wc;
  } else {
   $tobool9 = ($lower|0)!=(0);
   $sub10 = (($wc) + -4256)|0;
   $cmp11 = ($sub10>>>0)<(46);
   $or$cond51 = $tobool9 & $cmp11;
   if ($or$cond51) {
    $cmp13 = ($wc|0)>(4293);
    if ($cmp13) {
     switch ($wc|0) {
     case 4295: case 4301:  {
      break;
     }
     default: {
      $retval$2 = $wc;
      break L1;
     }
     }
    }
    $sub19 = (($wc) + 7264)|0;
    $retval$2 = $sub19;
    break;
   }
   $tobool9$not = $tobool9 ^ 1;
   $sub23 = (($wc) + -11520)|0;
   $cmp24 = ($sub23>>>0)<(38);
   $or$cond = $cmp24 & $tobool9$not;
   if ($or$cond) {
    $cmp26 = ($wc|0)>(11557);
    if ($cmp26) {
     switch ($wc|0) {
     case 11559: case 11565:  {
      break;
     }
     default: {
      $retval$2 = $wc;
      break L1;
     }
     }
    }
    $sub34 = (($wc) + -7264)|0;
    $retval$2 = $sub34;
    break;
   } else {
    $i$057 = 0;
   }
   while(1) {
    $len = (((1924 + ($i$057<<2)|0)) + 3|0);
    $1 = load1($len);
    $upper = (1924 + ($i$057<<2)|0);
    $2 = load2($upper);
    $conv = $2&65535;
    $lower39 = (((1924 + ($i$057<<2)|0)) + 2|0);
    $3 = load1($lower39);
    $conv40 = $3 << 24 >> 24;
    $and = $conv40 & $sub1;
    $add41$neg = (($wc) - ($conv))|0;
    $sub42 = (($add41$neg) - ($and))|0;
    $conv45 = $1&255;
    $cmp46 = ($sub42>>>0)<($conv45>>>0);
    $inc = (($i$057) + 1)|0;
    if ($cmp46) {
     label = 13;
     break;
    }
    $tobool36 = ($inc|0)==(61);
    if ($tobool36) {
     break;
    } else {
     $i$057 = $inc;
    }
   }
   if ((label|0) == 13) {
    $cmp52 = ($3<<24>>24)==(1);
    if ($cmp52) {
     $add55 = (($lower) + ($wc))|0;
     $and60 = $add41$neg & 1;
     $sub61 = (($add55) - ($and60))|0;
     $retval$2 = $sub61;
     break;
    } else {
     $mul66 = Math_imul($conv40, $sub)|0;
     $add67 = (($mul66) + ($wc))|0;
     $retval$2 = $add67;
     break;
    }
   }
   $sub70 = (1 - ($lower))|0;
   $arrayidx7254 = (1432 + ($sub70<<1)|0);
   $0 = load2($arrayidx7254);
   $tobool7355 = ($0<<16>>16)==(0);
   L23: do {
    if (!($tobool7355)) {
     $4 = $0;$i$156 = 0;
     while(1) {
      $conv78 = $4&65535;
      $cmp79 = ($conv78|0)==($wc|0);
      if ($cmp79) {
       break;
      }
      $inc87 = (($i$156) + 1)|0;
      $arrayidx72 = ((1432 + ($inc87<<2)|0) + ($sub70<<1)|0);
      $6 = load2($arrayidx72);
      $tobool73 = ($6<<16>>16)==(0);
      if ($tobool73) {
       break L23;
      } else {
       $4 = $6;$i$156 = $inc87;
      }
     }
     $arrayidx83 = ((1432 + ($i$156<<2)|0) + ($lower<<1)|0);
     $5 = load2($arrayidx83);
     $conv84 = $5&65535;
     $retval$2 = $conv84;
     break L1;
    }
   } while(0);
   $$neg = ($lower*40)|0;
   $sub90$neg = (($wc) + -66600)|0;
   $sub91 = (($sub90$neg) + ($$neg))|0;
   $cmp92 = ($sub91>>>0)<(40);
   $sub95 = (($wc) + -40)|0;
   $mul96 = ($lower*80)|0;
   $add97 = (($sub95) + ($mul96))|0;
   $add97$wc = $cmp92 ? $add97 : $wc;
   return ($add97$wc|0);
  }
 } while(0);
 return ($retval$2|0);
}
function _iswalpha($wc) {
 $wc = $wc|0;
 var $$ = 0, $0 = 0, $1 = 0, $add = 0, $and = 0, $and4 = 0, $and6 = 0, $arrayidx = 0, $arrayidx2 = 0, $cmp = 0, $cmp7 = 0, $conv = 0, $conv3 = 0, $mul = 0, $retval$0 = 0, $shr = 0, $shr1 = 0, $shr5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $cmp = ($wc>>>0)<(131072);
 if ($cmp) {
  $shr = $wc >>> 8;
  $arrayidx = (2172 + ($shr)|0);
  $0 = load1($arrayidx);
  $conv = $0&255;
  $mul = $conv << 5;
  $and = $wc >>> 3;
  $shr1 = $and & 31;
  $add = $mul | $shr1;
  $arrayidx2 = (2172 + ($add)|0);
  $1 = load1($arrayidx2);
  $conv3 = $1&255;
  $and4 = $wc & 7;
  $shr5 = $conv3 >>> $and4;
  $and6 = $shr5 & 1;
  $retval$0 = $and6;
 } else {
  $cmp7 = ($wc>>>0)<(196606);
  $$ = $cmp7&1;
  $retval$0 = $$;
 }
 return ($retval$0|0);
}
function _fnmatch($pat,$str,$flags) {
 $pat = $pat|0;
 $str = $str|0;
 $flags = $flags|0;
 var $$mux = 0, $0 = 0, $1 = 0, $2 = 0, $3 = 0, $4 = 0, $add$ptr = 0, $add$ptr32 = 0, $add$ptr33 = 0, $and = 0, $and34 = 0, $brmerge = 0, $call = 0, $call25 = 0, $call48 = 0, $call57 = 0, $cmp16 = 0, $cmp6$not = 0, $conv15 = 0, $inc = 0;
 var $incdec$ptr = 0, $incdec$ptr53 = 0, $or$cond = 0, $or$cond36 = 0, $p$0 = 0, $pat$addr$0 = 0, $retval$0 = 0, $s$0 = 0, $s$1 = 0, $str$addr$0 = 0, $sub$ptr$lhs$cast = 0, $sub$ptr$lhs$cast22 = 0, $sub$ptr$lhs$cast45 = 0, $sub$ptr$rhs$cast = 0, $sub$ptr$rhs$cast23 = 0, $sub$ptr$rhs$cast46 = 0, $sub$ptr$sub = 0, $sub$ptr$sub24 = 0, $sub$ptr$sub47 = 0, $tobool = 0;
 var $tobool18 = 0, $tobool26$not = 0, $tobool35 = 0, $tobool49 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $inc = sp;
 $and = $flags & 1;
 $tobool = ($and|0)==(0);
 $and34 = $flags & 8;
 $tobool35 = ($and34|0)==(0);
 L1: do {
  if ($tobool) {
   L3: do {
    if (!($tobool35)) {
     $sub$ptr$rhs$cast46 = $str;
     $s$1 = $str;
     while(1) {
      $4 = load1($s$1);
      switch ($4<<24>>24) {
      case 0:  {
       break L3;
       break;
      }
      case 47:  {
       $sub$ptr$lhs$cast45 = $s$1;
       $sub$ptr$sub47 = (($sub$ptr$lhs$cast45) - ($sub$ptr$rhs$cast46))|0;
       $call48 = (_fnmatch_internal($pat,-1,$str,$sub$ptr$sub47,$flags)|0);
       $tobool49 = ($call48|0)==(0);
       if ($tobool49) {
        $retval$0 = 0;
        break L1;
       }
       break;
      }
      default: {
      }
      }
      $incdec$ptr53 = ((($s$1)) + 1|0);
      $s$1 = $incdec$ptr53;
     }
    }
   } while(0);
   $call57 = (_fnmatch_internal($pat,-1,$str,-1,$flags)|0);
   $retval$0 = $call57;
  } else {
   $pat$addr$0 = $pat;$str$addr$0 = $str;
   while(1) {
    $s$0 = $str$addr$0;
    L13: while(1) {
     $0 = load1($s$0);
     switch ($0<<24>>24) {
     case 47: case 0:  {
      $p$0 = $pat$addr$0;
      break L13;
      break;
     }
     default: {
     }
     }
     $incdec$ptr = ((($s$0)) + 1|0);
     $s$0 = $incdec$ptr;
    }
    L16: while(1) {
     $call = (_pat_next($p$0,-1,$inc,$flags)|0);
     switch ($call|0) {
     case 0: case 47:  {
      break L16;
      break;
     }
     default: {
     }
     }
     $1 = load4($inc);
     $add$ptr = (($p$0) + ($1)|0);
     $p$0 = $add$ptr;
    }
    $2 = load1($s$0);
    $conv15 = $2 << 24 >> 24;
    $cmp16 = ($call|0)!=($conv15|0);
    $tobool18 = ($2<<24>>24)==(0);
    $or$cond = $tobool35 | $tobool18;
    $or$cond36 = $cmp16 & $or$cond;
    if ($or$cond36) {
     $retval$0 = 1;
     break L1;
    }
    $sub$ptr$lhs$cast = $p$0;
    $sub$ptr$rhs$cast = $pat$addr$0;
    $sub$ptr$sub = (($sub$ptr$lhs$cast) - ($sub$ptr$rhs$cast))|0;
    $sub$ptr$lhs$cast22 = $s$0;
    $sub$ptr$rhs$cast23 = $str$addr$0;
    $sub$ptr$sub24 = (($sub$ptr$lhs$cast22) - ($sub$ptr$rhs$cast23))|0;
    $call25 = (_fnmatch_internal($pat$addr$0,$sub$ptr$sub,$str$addr$0,$sub$ptr$sub24,$flags)|0);
    $tobool26$not = ($call25|0)!=(0);
    $cmp6$not = ($call|0)==(0);
    $brmerge = $cmp6$not | $tobool26$not;
    $$mux = $tobool26$not&1;
    if ($brmerge) {
     $retval$0 = $$mux;
     break L1;
    }
    $add$ptr32 = ((($s$0)) + 1|0);
    $3 = load4($inc);
    $add$ptr33 = (($p$0) + ($3)|0);
    $pat$addr$0 = $add$ptr33;$str$addr$0 = $add$ptr32;
   }
  }
 } while(0);
 STACKTOP = sp;return ($retval$0|0);
}
function _pat_next($pat,$m,$step,$flags) {
 $pat = $pat|0;
 $m = $m|0;
 $step = $step|0;
 $flags = $flags|0;
 var $$ = 0, $$add128 = 0, $$pre = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $add = 0, $add128 = 0;
 var $add153 = 0, $add85 = 0, $add85$inc93 = 0, $and = 0, $arrayidx102 = 0, $arrayidx115 = 0, $arrayidx124 = 0, $arrayidx18 = 0, $arrayidx3 = 0, $arrayidx33 = 0, $arrayidx44 = 0, $arrayidx55 = 0, $arrayidx89 = 0, $arrayidx98 = 0, $call = 0, $cmp108 = 0, $cmp108$ = 0, $cmp112 = 0, $cmp121 = 0, $cmp145 = 0;
 var $cmp149 = 0, $cmp15 = 0, $cmp30 = 0, $cmp35 = 0, $cmp41 = 0, $cmp4184 = 0, $cmp51 = 0, $cmp61 = 0, $cmp86 = 0, $cmp95 = 0, $cmp9580 = 0, $conv144 = 0, $esc$0 = 0, $inc111 = 0, $inc120 = 0, $inc38 = 0, $inc38$k$0 = 0, $inc93 = 0, $k$0 = 0, $k$1$ph = 0;
 var $k$185 = 0, $k$2$lcssa = 0, $k$2$ph = 0, $k$281 = 0, $k$3 = 0, $k$4 = 0, $not$cmp104 = 0, $or$cond = 0, $or$cond78 = 0, $pat$addr$0 = 0, $retval$0 = 0, $retval$1 = 0, $retval$2 = 0, $storemerge = 0, $sub = 0, $tobool = 0, $tobool1 = 0, $tobool100 = 0, $tobool116 = 0, $tobool125 = 0;
 var $tobool5 = 0, $tobool57 = 0, $tobool7 = 0, $tobool91 = 0, $wc = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $wc = sp;
 $tobool = ($m|0)==(0);
 L1: do {
  if ($tobool) {
   label = 3;
  } else {
   $0 = load1($pat);
   $tobool1 = ($0<<24>>24)==(0);
   if ($tobool1) {
    label = 3;
   } else {
    store4($step,1);
    $1 = load1($pat);
    switch ($1<<24>>24) {
    case 42:  {
     $retval$2 = -5;
     break L1;
     break;
    }
    case 92:  {
     $arrayidx3 = ((($pat)) + 1|0);
     $2 = load1($arrayidx3);
     $tobool5 = ($2<<24>>24)!=(0);
     $and = $flags & 2;
     $tobool7 = ($and|0)==(0);
     $or$cond = $tobool7 & $tobool5;
     if ($or$cond) {
      store4($step,2);
      $$pre = load1($arrayidx3);
      $12 = $$pre;$esc$0 = 1;$pat$addr$0 = $arrayidx3;
      label = 30;
     } else {
      $14 = 92;
     }
     break;
    }
    case 91:  {
     $cmp15 = ($m>>>0)>(1);
     L8: do {
      if ($cmp15) {
       $arrayidx18 = ((($pat)) + 1|0);
       $3 = load1($arrayidx18);
       switch ($3<<24>>24) {
       case 33: case 94:  {
        break;
       }
       default: {
        $k$0 = 1;
        break L8;
       }
       }
       $k$0 = 2;
      } else {
       $k$0 = 1;
      }
     } while(0);
     $cmp30 = ($k$0>>>0)<($m>>>0);
     if ($cmp30) {
      $arrayidx33 = (($pat) + ($k$0)|0);
      $4 = load1($arrayidx33);
      $cmp35 = ($4<<24>>24)==(93);
      $inc38 = $cmp35&1;
      $inc38$k$0 = (($inc38) + ($k$0))|0;
      $k$1$ph = $inc38$k$0;
     } else {
      $k$1$ph = $k$0;
     }
     $cmp4184 = ($k$1$ph>>>0)<($m>>>0);
     L15: do {
      if ($cmp4184) {
       $k$185 = $k$1$ph;
       while(1) {
        $arrayidx44 = (($pat) + ($k$185)|0);
        $5 = load1($arrayidx44);
        switch ($5<<24>>24) {
        case 93: case 0:  {
         $k$4 = $k$185;
         label = 26;
         break L15;
         break;
        }
        default: {
        }
        }
        $add = (($k$185) + 1)|0;
        $cmp51 = ($add>>>0)<($m>>>0);
        L19: do {
         if ($cmp51) {
          $arrayidx55 = (($pat) + ($add)|0);
          $6 = load1($arrayidx55);
          $tobool57 = ($6<<24>>24)!=(0);
          $cmp61 = ($5<<24>>24)==(91);
          $or$cond78 = $cmp61 & $tobool57;
          if ($or$cond78) {
           switch ($6<<24>>24) {
           case 61: case 46: case 58:  {
            break;
           }
           default: {
            $k$3 = $k$185;
            break L19;
           }
           }
           $add85 = (($k$185) + 2)|0;
           $cmp86 = ($add85>>>0)<($m>>>0);
           if ($cmp86) {
            $inc93 = (($k$185) + 3)|0;
            $arrayidx89 = (($pat) + ($add85)|0);
            $7 = load1($arrayidx89);
            $tobool91 = ($7<<24>>24)==(0);
            $add85$inc93 = $tobool91 ? $add85 : $inc93;
            $k$2$ph = $add85$inc93;
           } else {
            $k$2$ph = $add85;
           }
           $cmp9580 = ($k$2$ph>>>0)<($m>>>0);
           L26: do {
            if ($cmp9580) {
             $k$281 = $k$2$ph;
             while(1) {
              $arrayidx98 = (($pat) + ($k$281)|0);
              $8 = load1($arrayidx98);
              $tobool100 = ($8<<24>>24)==(0);
              if ($tobool100) {
               $k$2$lcssa = $k$281;
               break L26;
              }
              $sub = (($k$281) + -1)|0;
              $arrayidx102 = (($pat) + ($sub)|0);
              $9 = load1($arrayidx102);
              $cmp108 = ($8<<24>>24)!=(93);
              $not$cmp104 = ($9<<24>>24)!=($6<<24>>24);
              $cmp108$ = $cmp108 | $not$cmp104;
              if (!($cmp108$)) {
               $k$2$lcssa = $k$281;
               break L26;
              }
              $inc111 = (($k$281) + 1)|0;
              $cmp95 = ($inc111>>>0)<($m>>>0);
              if ($cmp95) {
               $k$281 = $inc111;
              } else {
               $k$2$lcssa = $inc111;
               break;
              }
             }
            } else {
             $k$2$lcssa = $k$2$ph;
            }
           } while(0);
           $cmp112 = ($k$2$lcssa|0)==($m|0);
           if ($cmp112) {
            $retval$0 = 91;$storemerge = 1;
            break L15;
           }
           $arrayidx115 = (($pat) + ($k$2$lcssa)|0);
           $10 = load1($arrayidx115);
           $tobool116 = ($10<<24>>24)==(0);
           if ($tobool116) {
            $k$4 = $k$2$lcssa;
            label = 26;
            break L15;
           } else {
            $k$3 = $k$2$lcssa;
           }
          } else {
           $k$3 = $k$185;
          }
         } else {
          $k$3 = $k$185;
         }
        } while(0);
        $inc120 = (($k$3) + 1)|0;
        $cmp41 = ($inc120>>>0)<($m>>>0);
        if ($cmp41) {
         $k$185 = $inc120;
        } else {
         $k$4 = $inc120;
         label = 26;
         break L15;
        }
       }
      } else {
       $k$4 = $k$1$ph;
       label = 26;
      }
     } while(0);
     if ((label|0) == 26) {
      $cmp121 = ($k$4|0)==($m|0);
      if ($cmp121) {
       $retval$0 = 91;$storemerge = 1;
      } else {
       $add128 = (($k$4) + 1)|0;
       $arrayidx124 = (($pat) + ($k$4)|0);
       $11 = load1($arrayidx124);
       $tobool125 = ($11<<24>>24)==(0);
       $$add128 = $tobool125 ? 1 : $add128;
       $$ = $tobool125 ? 91 : -3;
       $retval$0 = $$;$storemerge = $$add128;
      }
     }
     store4($step,$storemerge);
     $retval$2 = $retval$0;
     break L1;
     break;
    }
    case 63:  {
     $retval$2 = -4;
     break L1;
     break;
    }
    default: {
     $12 = $1;$esc$0 = 0;$pat$addr$0 = $pat;
     label = 30;
    }
    }
    if ((label|0) == 30) {
     $cmp145 = ($12<<24>>24)<(0);
     if ($cmp145) {
      $call = (_mbtowc($wc,$pat$addr$0,$m)|0);
      $cmp149 = ($call|0)<(0);
      if ($cmp149) {
       store4($step,0);
       $retval$1 = -2;
      } else {
       $add153 = (($call) + ($esc$0))|0;
       store4($step,$add153);
       $13 = load4($wc);
       $retval$1 = $13;
      }
      $retval$2 = $retval$1;
      break;
     } else {
      $14 = $12;
     }
    }
    $conv144 = $14 << 24 >> 24;
    $retval$2 = $conv144;
   }
  }
 } while(0);
 if ((label|0) == 3) {
  store4($step,0);
  $retval$2 = 0;
 }
 STACKTOP = sp;return ($retval$2|0);
}
function _fnmatch_internal($pat,$m,$str,$n,$flags) {
 $pat = $pat|0;
 $m = $m|0;
 $str = $str|0;
 $n = $n|0;
 $flags = $flags|0;
 var $$pre = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0;
 var $8 = 0, $9 = 0, $add$ptr = 0, $add$ptr100 = 0, $add$ptr124 = 0, $add$ptr124$lcssa = 0, $add$ptr124131 = 0, $add$ptr124131242 = 0, $add$ptr124131246 = 0, $add$ptr124135 = 0, $add$ptr140 = 0, $add$ptr154 = 0, $add$ptr167 = 0, $add$ptr30 = 0, $add$ptr33$ptr = 0, $add$ptr46 = 0, $add$ptr83 = 0, $add$ptr83147 = 0, $add$ptr83154 = 0, $add$ptr96 = 0;
 var $and = 0, $arrayidx = 0, $call = 0, $call101 = 0, $call123 = 0, $call123130 = 0, $call123130241 = 0, $call123130245 = 0, $call123134 = 0, $call132 = 0, $call141 = 0, $call163 = 0, $call174 = 0, $call18 = 0, $call32 = 0, $call37 = 0, $call45 = 0, $call8 = 0, $call82 = 0, $call82$lcssa = 0;
 var $call82146 = 0, $call82153 = 0, $call87 = 0, $call87150 = 0, $call87155 = 0, $cmp = 0, $cmp109 = 0, $cmp116 = 0, $cmp116140 = 0, $cmp125 = 0, $cmp125132 = 0, $cmp125132243 = 0, $cmp149 = 0, $cmp164 = 0, $cmp175 = 0, $cmp25 = 0, $cmp3 = 0, $cmp35 = 0, $cmp35163 = 0, $cmp47 = 0;
 var $cmp52 = 0, $cmp52157 = 0, $cmp57103 = 0, $cmp65 = 0, $cmp65249 = 0, $cmp68 = 0, $cmp68250 = 0, $cmp88 = 0, $cmp88151 = 0, $cmp9 = 0, $cmp91 = 0, $cond = 0, $dec = 0, $dec73 = 0, $idx$neg = 0, $idx$neg139 = 0, $inc = 0, $incdec$ptr$add = 0, $incdec$ptr$ptr$ptr = 0, $incdec$ptr62 = 0;
 var $incdec$ptr62$phi$trans$insert = 0, $incdec$ptr62248 = 0, $incdec$ptr62253 = 0, $m$addr$0 = 0, $n$addr$0 = 0, $not$cmp12 = 0, $or$cond = 0, $or$cond251 = 0, $p$0164$add = 0, $p$0164$add169 = 0, $p$0164$idx = 0, $p$0164$ptr = 0, $pat$addr$0 = 0, $pat$addr$1$ph142 = 0, $pinc = 0, $ptail$0$lcssa$idx = 0, $ptail$0$lcssa$ptr = 0, $ptail$0165$idx = 0, $ptail$1$idx = 0, $retval$0 = 0;
 var $s$0$lcssa = 0, $s$0159 = 0, $s$1252 = 0, $s$1252$phi = 0, $s$2 = 0, $s$3152 = 0, $s$4$lcssa = 0, $s$4133 = 0, $sinc = 0, $str$addr$0 = 0, $str$addr$1$ph141 = 0, $str$addr$1139$be = 0, $str$addr$1139244 = 0, $str$addr$2$pn = 0, $str$addr$3 = 0, $sub = 0, $sub$ptr$lhs$cast = 0, $sub$ptr$lhs$cast79 = 0, $sub$ptr$lhs$cast84 = 0, $sub$ptr$rhs$cast = 0;
 var $sub$ptr$rhs$cast121 = 0, $sub$ptr$rhs$cast121128 = 0, $sub$ptr$rhs$cast130 = 0, $sub$ptr$rhs$cast161 = 0, $sub$ptr$rhs$cast172 = 0, $sub$ptr$rhs$cast80 = 0, $sub$ptr$rhs$cast80144 = 0, $sub$ptr$rhs$cast85 = 0, $sub$ptr$rhs$cast85148 = 0, $sub$ptr$sub = 0, $sub$ptr$sub122 = 0, $sub$ptr$sub122129 = 0, $sub$ptr$sub131 = 0, $sub$ptr$sub162 = 0, $sub$ptr$sub173 = 0, $sub$ptr$sub81 = 0, $sub$ptr$sub81145 = 0, $sub$ptr$sub86 = 0, $sub$ptr$sub86149 = 0, $sub31 = 0;
 var $tailcnt$0$lcssa = 0, $tailcnt$0166 = 0, $tailcnt$1 = 0, $tailcnt$2160 = 0, $tobool = 0, $tobool102 = 0, $tobool133 = 0, $tobool142 = 0, $tobool19 = 0, $tobool54 = 0, $tobool54$lcssa = 0, $tobool54158 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $pinc = sp + 4|0;
 $sinc = sp;
 $and = $flags & 4;
 $tobool = ($and|0)==(0);
 if ($tobool) {
  $m$addr$0 = $m;$n$addr$0 = $n;$pat$addr$0 = $pat;$str$addr$0 = $str;
  label = 4;
 } else {
  $0 = load1($str);
  $cmp = ($0<<24>>24)==(46);
  if ($cmp) {
   $1 = load1($pat);
   $cmp3 = ($1<<24>>24)==(46);
   if ($cmp3) {
    $m$addr$0 = $m;$n$addr$0 = $n;$pat$addr$0 = $pat;$str$addr$0 = $str;
    label = 4;
   } else {
    $retval$0 = 1;
   }
  } else {
   $m$addr$0 = $m;$n$addr$0 = $n;$pat$addr$0 = $pat;$str$addr$0 = $str;
   label = 4;
  }
 }
 L4: do {
  if ((label|0) == 4) {
   L5: while(1) {
    label = 0;
    $call = (_pat_next($pat$addr$0,$m$addr$0,$pinc,$flags)|0);
    switch ($call|0) {
    case -2:  {
     $retval$0 = 1;
     break L4;
     break;
    }
    case -5:  {
     break L5;
     break;
    }
    default: {
    }
    }
    $call8 = (_str_next($str$addr$0,$n$addr$0,$sinc)|0);
    $cmp9 = ($call8|0)<(1);
    if ($cmp9) {
     label = 8;
     break;
    }
    $2 = load4($sinc);
    $add$ptr = (($str$addr$0) + ($2)|0);
    $sub = (($n$addr$0) - ($2))|0;
    switch ($call|0) {
    case -3:  {
     $call18 = (_match_bracket($pat$addr$0,$call8)|0);
     $tobool19 = ($call18|0)==(0);
     if ($tobool19) {
      $retval$0 = 1;
      break L4;
     }
     break;
    }
    case -4:  {
     break;
    }
    default: {
     $cmp25 = ($call8|0)==($call|0);
     if (!($cmp25)) {
      $retval$0 = 1;
      break L4;
     }
    }
    }
    $3 = load4($pinc);
    $add$ptr30 = (($pat$addr$0) + ($3)|0);
    $sub31 = (($m$addr$0) - ($3))|0;
    $m$addr$0 = $sub31;$n$addr$0 = $sub;$pat$addr$0 = $add$ptr30;$str$addr$0 = $add$ptr;
    label = 4;
   }
   if ((label|0) == 8) {
    $not$cmp12 = ($call|0)!=(0);
    $cond = $not$cmp12&1;
    $retval$0 = $cond;
    break;
   }
   $incdec$ptr$ptr$ptr = ((($pat$addr$0)) + 1|0);
   $dec = (($m$addr$0) + -1)|0;
   $call32 = (_strnlen($incdec$ptr$ptr$ptr,$dec)|0);
   $incdec$ptr$add = (($call32) + 1)|0;
   $add$ptr33$ptr = (($pat$addr$0) + ($incdec$ptr$add)|0);
   $cmp35163 = ($call32|0)>(0);
   L16: do {
    if ($cmp35163) {
     $sub$ptr$lhs$cast = $add$ptr33$ptr;
     $p$0164$idx = 1;$ptail$0165$idx = 1;$tailcnt$0166 = 0;
     while(1) {
      $p$0164$ptr = (($pat$addr$0) + ($p$0164$idx)|0);
      $sub$ptr$rhs$cast = $p$0164$ptr;
      $sub$ptr$sub = (($sub$ptr$lhs$cast) - ($sub$ptr$rhs$cast))|0;
      $call37 = (_pat_next($p$0164$ptr,$sub$ptr$sub,$pinc,$flags)|0);
      switch ($call37|0) {
      case -2:  {
       $retval$0 = 1;
       break L4;
       break;
      }
      case -5:  {
       $p$0164$add = (($p$0164$idx) + 1)|0;
       $ptail$1$idx = $p$0164$add;$tailcnt$1 = 0;
       break;
      }
      default: {
       $inc = (($tailcnt$0166) + 1)|0;
       $ptail$1$idx = $ptail$0165$idx;$tailcnt$1 = $inc;
      }
      }
      $4 = load4($pinc);
      $p$0164$add169 = (($p$0164$idx) + ($4))|0;
      $cmp35 = ($p$0164$add169|0)>($call32|0);
      if ($cmp35) {
       $ptail$0$lcssa$idx = $ptail$1$idx;$tailcnt$0$lcssa = $tailcnt$1;
       break L16;
      } else {
       $p$0164$idx = $p$0164$add169;$ptail$0165$idx = $ptail$1$idx;$tailcnt$0166 = $tailcnt$1;
      }
     }
    } else {
     $ptail$0$lcssa$idx = 1;$tailcnt$0$lcssa = 0;
    }
   } while(0);
   $ptail$0$lcssa$ptr = (($pat$addr$0) + ($ptail$0$lcssa$idx)|0);
   $call45 = (_strnlen($str$addr$0,$n$addr$0)|0);
   $add$ptr46 = (($str$addr$0) + ($call45)|0);
   $cmp47 = ($call45>>>0)<($tailcnt$0$lcssa>>>0);
   if ($cmp47) {
    $retval$0 = 1;
   } else {
    $cmp52157 = ($call45|0)>(0);
    $tobool54158 = ($tailcnt$0$lcssa|0)!=(0);
    $5 = $cmp52157 & $tobool54158;
    if ($5) {
     $s$0159 = $add$ptr46;$tailcnt$2160 = $tailcnt$0$lcssa;
     while(1) {
      $arrayidx = ((($s$0159)) + -1|0);
      $6 = load1($arrayidx);
      $cmp57103 = ($6<<24>>24)>(-1);
      if ($cmp57103) {
       $s$2 = $arrayidx;
      } else {
       $incdec$ptr62248 = ((($s$0159)) + -1|0);
       $7 = $6 & -64;
       $cmp65249 = ($7<<24>>24)==(-128);
       $cmp68250 = ($incdec$ptr62248>>>0)>($str$addr$0>>>0);
       $or$cond251 = $cmp68250 & $cmp65249;
       if ($or$cond251) {
        $incdec$ptr62253 = $incdec$ptr62248;$s$1252 = $s$0159;
        while(1) {
         $incdec$ptr62$phi$trans$insert = ((($s$1252)) + -2|0);
         $$pre = load1($incdec$ptr62$phi$trans$insert);
         $incdec$ptr62 = ((($incdec$ptr62253)) + -1|0);
         $8 = $$pre & -64;
         $cmp65 = ($8<<24>>24)==(-128);
         $cmp68 = ($incdec$ptr62>>>0)>($str$addr$0>>>0);
         $or$cond = $cmp68 & $cmp65;
         if ($or$cond) {
          $s$1252$phi = $incdec$ptr62253;$incdec$ptr62253 = $incdec$ptr62;$s$1252 = $s$1252$phi;
         } else {
          $s$2 = $incdec$ptr62;
          break;
         }
        }
       } else {
        $s$2 = $incdec$ptr62248;
       }
      }
      $dec73 = (($tailcnt$2160) + -1)|0;
      $cmp52 = ($s$2>>>0)>($str$addr$0>>>0);
      $tobool54 = ($dec73|0)!=(0);
      $9 = $cmp52 & $tobool54;
      if ($9) {
       $s$0159 = $s$2;$tailcnt$2160 = $dec73;
      } else {
       $s$0$lcssa = $s$2;$tobool54$lcssa = $tobool54;
       break;
      }
     }
    } else {
     $s$0$lcssa = $add$ptr46;$tobool54$lcssa = $tobool54158;
    }
    if ($tobool54$lcssa) {
     $retval$0 = 1;
    } else {
     $sub$ptr$lhs$cast79 = $add$ptr33$ptr;
     $sub$ptr$rhs$cast80144 = $ptail$0$lcssa$ptr;
     $sub$ptr$sub81145 = (($sub$ptr$lhs$cast79) - ($sub$ptr$rhs$cast80144))|0;
     $call82146 = (_pat_next($ptail$0$lcssa$ptr,$sub$ptr$sub81145,$pinc,$flags)|0);
     $10 = load4($pinc);
     $sub$ptr$lhs$cast84 = $add$ptr46;
     $sub$ptr$rhs$cast85148 = $s$0$lcssa;
     $sub$ptr$sub86149 = (($sub$ptr$lhs$cast84) - ($sub$ptr$rhs$cast85148))|0;
     $call87150 = (_str_next($s$0$lcssa,$sub$ptr$sub86149,$sinc)|0);
     $cmp88151 = ($call87150|0)<(1);
     L36: do {
      if ($cmp88151) {
       $call82$lcssa = $call82146;
      } else {
       $add$ptr83147 = (($ptail$0$lcssa$ptr) + ($10)|0);
       $12 = $10;$add$ptr83154 = $add$ptr83147;$call82153 = $call82146;$call87155 = $call87150;$s$3152 = $s$0$lcssa;
       while(1) {
        $11 = load4($sinc);
        $add$ptr96 = (($s$3152) + ($11)|0);
        switch ($call82153|0) {
        case -3:  {
         $idx$neg = (0 - ($12))|0;
         $add$ptr100 = (($add$ptr83154) + ($idx$neg)|0);
         $call101 = (_match_bracket($add$ptr100,$call87155)|0);
         $tobool102 = ($call101|0)==(0);
         if ($tobool102) {
          $retval$0 = 1;
          break L4;
         }
         break;
        }
        case -4:  {
         break;
        }
        default: {
         $cmp109 = ($call87155|0)==($call82153|0);
         if (!($cmp109)) {
          $retval$0 = 1;
          break L4;
         }
        }
        }
        $sub$ptr$rhs$cast80 = $add$ptr83154;
        $sub$ptr$sub81 = (($sub$ptr$lhs$cast79) - ($sub$ptr$rhs$cast80))|0;
        $call82 = (_pat_next($add$ptr83154,$sub$ptr$sub81,$pinc,$flags)|0);
        $13 = load4($pinc);
        $add$ptr83 = (($add$ptr83154) + ($13)|0);
        $sub$ptr$rhs$cast85 = $add$ptr96;
        $sub$ptr$sub86 = (($sub$ptr$lhs$cast84) - ($sub$ptr$rhs$cast85))|0;
        $call87 = (_str_next($add$ptr96,$sub$ptr$sub86,$sinc)|0);
        $cmp88 = ($call87|0)<(1);
        if ($cmp88) {
         $call82$lcssa = $call82;
         break L36;
        } else {
         $12 = $13;$add$ptr83154 = $add$ptr83;$call82153 = $call82;$call87155 = $call87;$s$3152 = $add$ptr96;
        }
       }
      }
     } while(0);
     $cmp91 = ($call82$lcssa|0)==(0);
     if ($cmp91) {
      $cmp116140 = ($ptail$0$lcssa$idx|0)>(1);
      if ($cmp116140) {
       $pat$addr$1$ph142 = $incdec$ptr$ptr$ptr;$str$addr$1$ph141 = $str$addr$0;
       while(1) {
        $sub$ptr$rhs$cast121128 = $pat$addr$1$ph142;
        $sub$ptr$sub122129 = (($sub$ptr$rhs$cast80144) - ($sub$ptr$rhs$cast121128))|0;
        $call123130241 = (_pat_next($pat$addr$1$ph142,$sub$ptr$sub122129,$pinc,$flags)|0);
        $14 = load4($pinc);
        $add$ptr124131242 = (($pat$addr$1$ph142) + ($14)|0);
        $cmp125132243 = ($call123130241|0)==(-5);
        L48: do {
         if ($cmp125132243) {
          $add$ptr124$lcssa = $add$ptr124131242;$s$4$lcssa = $str$addr$1$ph141;
         } else {
          $20 = $14;$add$ptr124131246 = $add$ptr124131242;$call123130245 = $call123130241;$str$addr$1139244 = $str$addr$1$ph141;
          while(1) {
           $15 = $20;$add$ptr124135 = $add$ptr124131246;$call123134 = $call123130245;$s$4133 = $str$addr$1139244;
           L51: while(1) {
            $sub$ptr$rhs$cast130 = $s$4133;
            $sub$ptr$sub131 = (($sub$ptr$rhs$cast85148) - ($sub$ptr$rhs$cast130))|0;
            $call132 = (_str_next($s$4133,$sub$ptr$sub131,$sinc)|0);
            $tobool133 = ($call132|0)==(0);
            if ($tobool133) {
             $retval$0 = 1;
             break L4;
            }
            switch ($call123134|0) {
            case -3:  {
             $idx$neg139 = (0 - ($15))|0;
             $add$ptr140 = (($add$ptr124135) + ($idx$neg139)|0);
             $call141 = (_match_bracket($add$ptr140,$call132)|0);
             $tobool142 = ($call141|0)==(0);
             if ($tobool142) {
              break L51;
             }
             break;
            }
            case -4:  {
             break;
            }
            default: {
             $cmp149 = ($call132|0)==($call123134|0);
             if (!($cmp149)) {
              break L51;
             }
            }
            }
            $16 = load4($sinc);
            $add$ptr154 = (($s$4133) + ($16)|0);
            $sub$ptr$rhs$cast121 = $add$ptr124135;
            $sub$ptr$sub122 = (($sub$ptr$rhs$cast80144) - ($sub$ptr$rhs$cast121))|0;
            $call123 = (_pat_next($add$ptr124135,$sub$ptr$sub122,$pinc,$flags)|0);
            $17 = load4($pinc);
            $add$ptr124 = (($add$ptr124135) + ($17)|0);
            $cmp125 = ($call123|0)==(-5);
            if ($cmp125) {
             $add$ptr124$lcssa = $add$ptr124;$s$4$lcssa = $add$ptr154;
             break L48;
            } else {
             $15 = $17;$add$ptr124135 = $add$ptr124;$call123134 = $call123;$s$4133 = $add$ptr154;
            }
           }
           $sub$ptr$rhs$cast161 = $str$addr$1139244;
           $sub$ptr$sub162 = (($sub$ptr$rhs$cast85148) - ($sub$ptr$rhs$cast161))|0;
           $call163 = (_str_next($str$addr$1139244,$sub$ptr$sub162,$sinc)|0);
           $cmp164 = ($call163|0)>(0);
           if ($cmp164) {
            $18 = load4($sinc);
            $add$ptr167 = (($str$addr$1139244) + ($18)|0);
            $str$addr$1139$be = $add$ptr167;
           } else {
            $str$addr$2$pn = $str$addr$1139244;
            while(1) {
             $str$addr$3 = ((($str$addr$2$pn)) + 1|0);
             $sub$ptr$rhs$cast172 = $str$addr$3;
             $sub$ptr$sub173 = (($sub$ptr$rhs$cast85148) - ($sub$ptr$rhs$cast172))|0;
             $call174 = (_str_next($str$addr$3,$sub$ptr$sub173,$sinc)|0);
             $cmp175 = ($call174|0)<(0);
             if ($cmp175) {
              $str$addr$2$pn = $str$addr$3;
             } else {
              $str$addr$1139$be = $str$addr$3;
              break;
             }
            }
           }
           $call123130 = (_pat_next($pat$addr$1$ph142,$sub$ptr$sub122129,$pinc,$flags)|0);
           $19 = load4($pinc);
           $add$ptr124131 = (($pat$addr$1$ph142) + ($19)|0);
           $cmp125132 = ($call123130|0)==(-5);
           if ($cmp125132) {
            $add$ptr124$lcssa = $add$ptr124131;$s$4$lcssa = $str$addr$1139$be;
            break;
           } else {
            $20 = $19;$add$ptr124131246 = $add$ptr124131;$call123130245 = $call123130;$str$addr$1139244 = $str$addr$1139$be;
           }
          }
         }
        } while(0);
        $cmp116 = ($add$ptr124$lcssa>>>0)<($ptail$0$lcssa$ptr>>>0);
        if ($cmp116) {
         $pat$addr$1$ph142 = $add$ptr124$lcssa;$str$addr$1$ph141 = $s$4$lcssa;
        } else {
         $retval$0 = 0;
         break;
        }
       }
      } else {
       $retval$0 = 0;
      }
     } else {
      $retval$0 = 1;
     }
    }
   }
  }
 } while(0);
 STACKTOP = sp;return ($retval$0|0);
}
function _str_next($str,$n,$step) {
 $str = $str|0;
 $n = $n|0;
 $step = $step|0;
 var $0 = 0, $1 = 0, $2 = 0, $call = 0, $cmp = 0, $cmp3 = 0, $conv10 = 0, $retval$0 = 0, $retval$1 = 0, $tobool = 0, $wc = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $wc = sp;
 $tobool = ($n|0)==(0);
 do {
  if ($tobool) {
   store4($step,0);
   $retval$1 = 0;
  } else {
   $0 = load1($str);
   $cmp = ($0<<24>>24)<(0);
   if (!($cmp)) {
    store4($step,1);
    $2 = load1($str);
    $conv10 = $2 << 24 >> 24;
    $retval$1 = $conv10;
    break;
   }
   $call = (_mbtowc($wc,$str,$n)|0);
   $cmp3 = ($call|0)<(0);
   if ($cmp3) {
    store4($step,1);
    $retval$0 = -1;
   } else {
    store4($step,$call);
    $1 = load4($wc);
    $retval$0 = $1;
   }
   $retval$1 = $retval$0;
  }
 } while(0);
 STACKTOP = sp;return ($retval$1|0);
}
function _match_bracket($p,$k) {
 $p = $p|0;
 $k = $k|0;
 var $$pre = 0, $$pre61 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $2 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $add$ptr139 = 0, $add$ptr58 = 0, $add$ptr81 = 0, $add$ptr84 = 0;
 var $arrayidx = 0, $arrayidx109 = 0, $arrayidx37 = 0, $arrayidx66 = 0, $arrayidx85 = 0, $buf = 0, $call = 0, $call111 = 0, $call112 = 0, $call133 = 0, $cmp10 = 0, $cmp12758 = 0, $cmp134 = 0, $cmp144 = 0, $cmp19 = 0, $cmp39 = 0, $cmp42 = 0, $cmp46 = 0, $cmp50 = 0, $cmp87 = 0;
 var $cmp91 = 0, $cmp94 = 0, $cmp98 = 0, $conv130 = 0, $conv29 = 0, $incdec$ptr = 0, $incdec$ptr14 = 0, $incdec$ptr151 = 0, $incdec$ptr26 = 0, $incdec$ptr5 = 0, $incdec$ptr93 = 0, $inv$0 = 0, $p$addr$0 = 0, $p$addr$1 = 0, $p$addr$2 = 0, $p$addr$4 = 0, $p$addr$6 = 0, $p$addr$7 = 0, $retval$1$ph = 0, $retval$8 = 0;
 var $sub = 0, $sub$ptr$lhs$cast = 0, $sub$ptr$rhs$cast = 0, $sub$ptr$sub = 0, $sub138 = 0, $sub49 = 0, $sub57 = 0, $tobool113 = 0, $wc = 0, $wc2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 32|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(32|0);
 $wc = sp + 4|0;
 $wc2 = sp;
 $buf = sp + 8|0;
 $incdec$ptr = ((($p)) + 1|0);
 $0 = load1($incdec$ptr);
 switch ($0<<24>>24) {
 case 33: case 94:  {
  $incdec$ptr5 = ((($p)) + 2|0);
  $$pre = load1($incdec$ptr5);
  $1 = $$pre;$inv$0 = 1;$p$addr$0 = $incdec$ptr5;
  break;
 }
 default: {
  $1 = $0;$inv$0 = 0;$p$addr$0 = $incdec$ptr;
 }
 }
 L4: do {
  switch ($1<<24>>24) {
  case 93:  {
   $cmp10 = ($k|0)==(93);
   if ($cmp10) {
    $2 = $inv$0 ^ 1;
    $retval$8 = $2;
    break L4;
   } else {
    $incdec$ptr14 = ((($p$addr$0)) + 1|0);
    $p$addr$1 = $incdec$ptr14;
    label = 10;
    break L4;
   }
   break;
  }
  case 45:  {
   $cmp19 = ($k|0)==(45);
   if ($cmp19) {
    $3 = $inv$0 ^ 1;
    $retval$8 = $3;
    break L4;
   } else {
    $incdec$ptr26 = ((($p$addr$0)) + 1|0);
    $p$addr$1 = $incdec$ptr26;
    label = 10;
    break L4;
   }
   break;
  }
  default: {
   $p$addr$1 = $p$addr$0;
   label = 10;
  }
  }
 } while(0);
 L13: do {
  if ((label|0) == 10) {
   $arrayidx = ((($p$addr$1)) + -1|0);
   $4 = load1($arrayidx);
   $conv29 = $4 << 24 >> 24;
   store4($wc,$conv29);
   $5 = $inv$0 ^ 1;
   $p$addr$2 = $p$addr$1;
   L15: while(1) {
    $6 = load1($p$addr$2);
    L17: do {
     switch ($6<<24>>24) {
     case 93:  {
      $retval$8 = $inv$0;
      break L13;
      break;
     }
     case 45:  {
      $arrayidx37 = ((($p$addr$2)) + 1|0);
      $7 = load1($arrayidx37);
      $cmp39 = ($7<<24>>24)==(93);
      if ($cmp39) {
       label = 27;
      } else {
       $call = (_mbtowc($wc2,$arrayidx37,4)|0);
       $cmp42 = ($call|0)<(0);
       if ($cmp42) {
        $retval$1$ph = 0;
        break L15;
       }
       $8 = load4($wc);
       $9 = load4($wc2);
       $cmp46 = ($9|0)<($8|0);
       if (!($cmp46)) {
        $sub = (($k) - ($8))|0;
        $sub49 = (($9) - ($8))|0;
        $cmp50 = ($sub>>>0)>($sub49>>>0);
        if (!($cmp50)) {
         $retval$1$ph = $5;
         break L15;
        }
       }
       $sub57 = (($call) + -1)|0;
       $add$ptr58 = (($p$addr$2) + ($sub57)|0);
       $p$addr$7 = $add$ptr58;
      }
      break;
     }
     case 91:  {
      $arrayidx66 = ((($p$addr$2)) + 1|0);
      $10 = load1($arrayidx66);
      switch ($10<<24>>24) {
      case 61: case 46: case 58:  {
       break;
      }
      default: {
       label = 27;
       break L17;
      }
      }
      $add$ptr84 = ((($p$addr$2)) + 3|0);
      $p$addr$4 = $add$ptr84;
      while(1) {
       $arrayidx85 = ((($p$addr$4)) + -1|0);
       $11 = load1($arrayidx85);
       $cmp87 = ($11<<24>>24)==($10<<24>>24);
       if ($cmp87) {
        $12 = load1($p$addr$4);
        $cmp91 = ($12<<24>>24)==(93);
        if ($cmp91) {
         break;
        }
       }
       $incdec$ptr93 = ((($p$addr$4)) + 1|0);
       $p$addr$4 = $incdec$ptr93;
      }
      $add$ptr81 = ((($p$addr$2)) + 2|0);
      $cmp94 = ($10<<24>>24)==(58);
      if ($cmp94) {
       $sub$ptr$lhs$cast = $arrayidx85;
       $sub$ptr$rhs$cast = $add$ptr81;
       $sub$ptr$sub = (($sub$ptr$lhs$cast) - ($sub$ptr$rhs$cast))|0;
       $cmp98 = ($sub$ptr$sub|0)<(16);
       if ($cmp98) {
        _memcpy(($buf|0),($add$ptr81|0),($sub$ptr$sub|0))|0;
        $arrayidx109 = (($buf) + ($sub$ptr$sub)|0);
        store1($arrayidx109,0);
        $call111 = (_wctype($buf)|0);
        $call112 = (_iswctype($k,$call111)|0);
        $tobool113 = ($call112|0)==(0);
        if ($tobool113) {
         $p$addr$7 = $p$addr$4;
        } else {
         $retval$8 = $5;
         break L13;
        }
       } else {
        $p$addr$7 = $p$addr$4;
       }
      } else {
       $p$addr$7 = $p$addr$4;
      }
      break;
     }
     default: {
      $cmp12758 = ($6<<24>>24)>(-1);
      if ($cmp12758) {
       label = 27;
      } else {
       $call133 = (_mbtowc($wc,$p$addr$2,4)|0);
       $cmp134 = ($call133|0)<(0);
       if ($cmp134) {
        $retval$8 = 0;
        break L13;
       }
       $sub138 = (($call133) + -1)|0;
       $add$ptr139 = (($p$addr$2) + ($sub138)|0);
       $$pre61 = load4($wc);
       $13 = $$pre61;$p$addr$6 = $add$ptr139;
       label = 30;
      }
     }
     }
    } while(0);
    if ((label|0) == 27) {
     label = 0;
     $conv130 = $6&255;
     store4($wc,$conv130);
     $13 = $conv130;$p$addr$6 = $p$addr$2;
     label = 30;
    }
    if ((label|0) == 30) {
     label = 0;
     $cmp144 = ($13|0)==($k|0);
     if ($cmp144) {
      $retval$8 = $5;
      break L13;
     } else {
      $p$addr$7 = $p$addr$6;
     }
    }
    $incdec$ptr151 = ((($p$addr$7)) + 1|0);
    $p$addr$2 = $incdec$ptr151;
   }
   $retval$8 = $retval$1$ph;
  }
 } while(0);
 STACKTOP = sp;return ($retval$8|0);
}
function _iswctype($wc,$type) {
 $wc = $wc|0;
 $type = $type|0;
 var $call = 0, $call10 = 0, $call12 = 0, $call14 = 0, $call16 = 0, $call18 = 0, $call2 = 0, $call20 = 0, $call22 = 0, $call4 = 0, $call6 = 0, $call8 = 0, $retval$0 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 do {
  switch ($type|0) {
  case 1:  {
   $call = (_iswalnum($wc)|0);
   $retval$0 = $call;
   break;
  }
  case 2:  {
   $call2 = (_iswalpha($wc)|0);
   $retval$0 = $call2;
   break;
  }
  case 3:  {
   $call4 = (_iswblank($wc)|0);
   $retval$0 = $call4;
   break;
  }
  case 4:  {
   $call6 = (_iswcntrl($wc)|0);
   $retval$0 = $call6;
   break;
  }
  case 5:  {
   $call8 = (_iswdigit($wc)|0);
   $retval$0 = $call8;
   break;
  }
  case 6:  {
   $call10 = (_iswgraph($wc)|0);
   $retval$0 = $call10;
   break;
  }
  case 7:  {
   $call12 = (_iswlower($wc)|0);
   $retval$0 = $call12;
   break;
  }
  case 8:  {
   $call14 = (_iswprint($wc)|0);
   $retval$0 = $call14;
   break;
  }
  case 9:  {
   $call16 = (_iswpunct($wc)|0);
   $retval$0 = $call16;
   break;
  }
  case 10:  {
   $call18 = (_iswspace($wc)|0);
   $retval$0 = $call18;
   break;
  }
  case 11:  {
   $call20 = (_iswupper($wc)|0);
   $retval$0 = $call20;
   break;
  }
  case 12:  {
   $call22 = (_iswxdigit($wc)|0);
   $retval$0 = $call22;
   break;
  }
  default: {
   $retval$0 = 0;
  }
  }
 } while(0);
 return ($retval$0|0);
}
function _iswalnum($wc) {
 $wc = $wc|0;
 var $0 = 0, $call = 0, $call1 = 0, $lor$ext = 0, $tobool = 0, $tobool2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $call = (_iswdigit($wc)|0);
 $tobool = ($call|0)==(0);
 if ($tobool) {
  $call1 = (_iswalpha($wc)|0);
  $tobool2 = ($call1|0)!=(0);
  $0 = $tobool2;
 } else {
  $0 = 1;
 }
 $lor$ext = $0&1;
 return ($lor$ext|0);
}
function _iswblank($wc) {
 $wc = $wc|0;
 var $call = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $call = (_isblank($wc)|0);
 return ($call|0);
}
function _iswcntrl($wc) {
 $wc = $wc|0;
 var $0 = 0, $1 = 0, $cmp = 0, $cmp1 = 0, $cmp4 = 0, $cmp6 = 0, $lor$ext = 0, $or$cond = 0, $or$cond4 = 0, $sub = 0, $sub5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $cmp = ($wc>>>0)<(32);
 $sub = (($wc) + -127)|0;
 $cmp1 = ($sub>>>0)<(33);
 $or$cond = $cmp | $cmp1;
 $0 = $wc & -2;
 $cmp4 = ($0|0)==(8232);
 $or$cond4 = $cmp4 | $or$cond;
 if ($or$cond4) {
  $1 = 1;
 } else {
  $sub5 = (($wc) + -65529)|0;
  $cmp6 = ($sub5>>>0)<(3);
  $1 = $cmp6;
 }
 $lor$ext = $1&1;
 return ($lor$ext|0);
}
function _iswgraph($wc) {
 $wc = $wc|0;
 var $0 = 0, $call = 0, $call1 = 0, $land$ext = 0, $tobool = 0, $tobool2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $call = (_iswspace($wc)|0);
 $tobool = ($call|0)==(0);
 if ($tobool) {
  $call1 = (_iswprint($wc)|0);
  $tobool2 = ($call1|0)!=(0);
  $0 = $tobool2;
 } else {
  $0 = 0;
 }
 $land$ext = $0&1;
 return ($land$ext|0);
}
function _iswprint($wc) {
 $wc = $wc|0;
 var $$ = 0, $0 = 0, $add = 0, $and = 0, $and16 = 0, $cmp = 0, $cmp1 = 0, $cmp13 = 0, $cmp17 = 0, $cmp2 = 0, $cmp4 = 0, $cmp8 = 0, $conv = 0, $or$cond = 0, $or$cond6 = 0, $or$cond7 = 0, $retval$0 = 0, $sub = 0, $sub12 = 0, $sub7 = 0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 $cmp = ($wc>>>0)<(255);
 if ($cmp) {
  $add = (($wc) + 1)|0;
  $and = $add & 127;
  $cmp1 = ($and>>>0)>(32);
  $conv = $cmp1&1;
  $retval$0 = $conv;
 } else {
  $cmp2 = ($wc>>>0)<(8232);
  $sub = (($wc) + -8234)|0;
  $cmp4 = ($sub>>>0)<(47062);
  $or$cond = $cmp2 | $cmp4;
  $sub7 = (($wc) + -57344)|0;
  $cmp8 = ($sub7>>>0)<(8185);
  $or$cond6 = $cmp8 | $or$cond;
  if ($or$cond6) {
   $retval$0 = 1;
  } else {
   $sub12 = (($wc) + -65532)|0;
   $cmp13 = ($sub12>>>0)>(1048579);
   $and16 = $wc & 65534;
   $cmp17 = ($and16|0)==(65534);
   $or$cond7 = $cmp13 | $cmp17;
   $0 = $or$cond7&1;
   $$ = $0 ^ 1;
   return ($$|0);
  }
 }
 return ($retval$0|0);
}
function _iswpunct($wc) {
 $wc = $wc|0;
 var $0 = 0, $1 = 0, $add = 0, $and = 0, $and4 = 0, $and6 = 0, $arrayidx = 0, $arrayidx2 = 0, $cmp = 0, $conv = 0, $conv3 = 0, $mul = 0, $retval$0 = 0, $shr = 0, $shr1 = 0, $shr5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $cmp = ($wc>>>0)<(131072);
 if ($cmp) {
  $shr = $wc >>> 8;
  $arrayidx = (5221 + ($shr)|0);
  $0 = load1($arrayidx);
  $conv = $0&255;
  $mul = $conv << 5;
  $and = $wc >>> 3;
  $shr1 = $and & 31;
  $add = $mul | $shr1;
  $arrayidx2 = (5221 + ($add)|0);
  $1 = load1($arrayidx2);
  $conv3 = $1&255;
  $and4 = $wc & 7;
  $shr5 = $conv3 >>> $and4;
  $and6 = $shr5 & 1;
  $retval$0 = $and6;
 } else {
  $retval$0 = 0;
 }
 return ($retval$0|0);
}
function _iswspace($wc) {
 $wc = $wc|0;
 var $0 = 0, $call = 0, $land$ext = 0, $tobool = 0, $tobool1 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $tobool = ($wc|0)==(0);
 if ($tobool) {
  $0 = 0;
 } else {
  $call = (_wcschr(1344,$wc)|0);
  $tobool1 = ($call|0)!=(0|0);
  $0 = $tobool1;
 }
 $land$ext = $0&1;
 return ($land$ext|0);
}
function _wcschr($s,$c) {
 $s = $s|0;
 $c = $c|0;
 var $0 = 0, $add$ptr = 0, $call = 0, $cmp = 0, $cond = 0, $incdec$ptr = 0, $or$cond = 0, $retval$0 = 0, $s$addr$0 = 0, $tobool = 0, $tobool1 = 0, $tobool2 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $tobool = ($c|0)==(0);
 if ($tobool) {
  $call = (_wcslen($s)|0);
  $add$ptr = (($s) + ($call<<2)|0);
  $retval$0 = $add$ptr;
 } else {
  $s$addr$0 = $s;
  while(1) {
   $0 = load4($s$addr$0);
   $tobool1 = ($0|0)==(0);
   $cmp = ($0|0)==($c|0);
   $or$cond = $tobool1 | $cmp;
   $incdec$ptr = ((($s$addr$0)) + 4|0);
   if ($or$cond) {
    break;
   } else {
    $s$addr$0 = $incdec$ptr;
   }
  }
  $tobool2 = ($0|0)!=(0);
  $cond = $tobool2 ? $s$addr$0 : 0;
  $retval$0 = $cond;
 }
 return ($retval$0|0);
}
function _wcslen($s) {
 $s = $s|0;
 var $0 = 0, $incdec$ptr = 0, $s$addr$0 = 0, $sub$ptr$div = 0, $sub$ptr$lhs$cast = 0, $sub$ptr$rhs$cast = 0, $sub$ptr$sub = 0, $tobool = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $s$addr$0 = $s;
 while(1) {
  $0 = load4($s$addr$0);
  $tobool = ($0|0)==(0);
  $incdec$ptr = ((($s$addr$0)) + 4|0);
  if ($tobool) {
   break;
  } else {
   $s$addr$0 = $incdec$ptr;
  }
 }
 $sub$ptr$lhs$cast = $s$addr$0;
 $sub$ptr$rhs$cast = $s;
 $sub$ptr$sub = (($sub$ptr$lhs$cast) - ($sub$ptr$rhs$cast))|0;
 $sub$ptr$div = $sub$ptr$sub >> 2;
 return ($sub$ptr$div|0);
}
function _isblank($c) {
 $c = $c|0;
 var $0 = 0, $cmp = 0, $cmp1 = 0, $lor$ext = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $cmp = ($c|0)==(32);
 $cmp1 = ($c|0)==(9);
 $0 = $cmp | $cmp1;
 $lor$ext = $0&1;
 return ($lor$ext|0);
}
function _glob($pat,$flags,$errfunc,$g) {
 $pat = $pat|0;
 $flags = $flags|0;
 $errfunc = $errfunc|0;
 $g = $g|0;
 var $$cast = 0, $$in = 0, $$pre = 0, $$pre$phi9297Z2D = 0, $$pre$phi9298Z2D = 0, $$pre87 = 0, $$pre88 = 0, $$sink82 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0;
 var $2 = 0, $20 = 0, $21 = 0, $3 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $add = 0, $add$ptr = 0, $add50 = 0, $add51 = 0, $add58 = 0, $add60 = 0, $add61 = 0, $add83 = 0, $add90 = 0, $add94 = 0;
 var $and = 0, $and12 = 0, $and33 = 0, $and95 = 0, $arraydecay = 0, $arrayidx85 = 0, $arrayidx92 = 0, $call = 0, $call19 = 0, $call36 = 0, $call37 = 0, $call52 = 0, $call63 = 0, $cmp = 0, $cmp21 = 0, $cmp3 = 0, $cmp5 = 0, $cmp7079 = 0, $cmp80 = 0, $cnt$083 = 0;
 var $cnt$1 = 0, $cond = 0, $d$0 = 0, $error$0749395 = 0, $error$0749396 = 0, $gl_offs = 0, $gl_offs15 = 0, $gl_pathv = 0, $gl_pathv48 = 0, $gl_pathv64 = 0, $gl_pathv84 = 0, $head = 0, $i$178 = 0, $ignore_err$errfunc = 0, $inc = 0, $inc88 = 0, $incdec$ptr104 = 0, $match$06$i = 0, $match$06$i61 = 0, $match$06$i68 = 0;
 var $mul = 0, $mul62 = 0, $offs$1 = 0, $p$1 = 0, $pat$pn = 0, $retval$1 = 0, $tail = 0, $tobool = 0, $tobool$i = 0, $tobool$i63 = 0, $tobool$i70 = 0, $tobool13 = 0, $tobool17 = 0, $tobool26 = 0, $tobool2681 = 0, $tobool31 = 0, $tobool34 = 0, $tobool38 = 0, $tobool5$i = 0, $tobool5$i60 = 0;
 var $tobool5$i67 = 0, $tobool53 = 0, $tobool66 = 0, $tobool9 = 0, $tobool96 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $head = sp;
 $tail = sp + 8|0;
 store8($head,i64_const(0,0));
 store4($tail,$head);
 $and = $flags & 8;
 $tobool = ($and|0)==(0);
 if ($tobool) {
  $cond = 0;
 } else {
  $gl_offs = ((($g)) + 8|0);
  $0 = load4($gl_offs);
  $cond = $0;
 }
 $1 = load1($pat);
 $cmp = ($1<<24>>24)==(47);
 if ($cmp) {
  $pat$pn = $pat;
  while(1) {
   $incdec$ptr104 = ((($pat$pn)) + 1|0);
   $$pre = load1($incdec$ptr104);
   $cmp3 = ($$pre<<24>>24)==(47);
   if ($cmp3) {
    $pat$pn = $incdec$ptr104;
   } else {
    $20 = $$pre;$d$0 = 8389;$p$1 = $incdec$ptr104;
    break;
   }
  }
 } else {
  $20 = $1;$d$0 = 9972;$p$1 = $pat;
 }
 $call = (_strlen($p$1)|0);
 $cmp5 = ($call>>>0)>(4096);
 L8: do {
  if ($cmp5) {
   $retval$1 = 1;
  } else {
   $tobool9 = ($errfunc|0)==(0|0);
   $ignore_err$errfunc = $tobool9 ? 7 : $errfunc;
   $and12 = $flags & 32;
   $tobool13 = ($and12|0)!=(0);
   if ($tobool13) {
    $2 = $20;
   } else {
    $gl_offs15 = ((($g)) + 8|0);
    store4($gl_offs15,$cond);
    store4($g,0);
    $gl_pathv = ((($g)) + 4|0);
    store4($gl_pathv,0);
    $$pre87 = load1($p$1);
    $2 = $$pre87;
   }
   $tobool17 = ($2<<24>>24)==(0);
   if ($tobool17) {
    store4($tail,0);
    $$pre$phi9298Z2D = $head;$21 = $tail;$error$0749396 = 0;
    label = 16;
   } else {
    $call19 = (_match_in_dir($d$0,$p$1,$flags,$ignore_err$errfunc,$tail)|0);
    $cmp21 = ($call19|0)==(1);
    if ($cmp21) {
     $3 = load4($head);
     $tobool5$i = ($3|0)==(0|0);
     if ($tobool5$i) {
      $retval$1 = 1;
      break;
     } else {
      $match$06$i = $3;
     }
     while(1) {
      $4 = load4($match$06$i);
      _free($match$06$i);
      $tobool$i = ($4|0)==(0|0);
      if ($tobool$i) {
       $retval$1 = 1;
       break L8;
      } else {
       $match$06$i = $4;
      }
     }
    }
    $$pre88 = load4($head);
    store4($tail,$$pre88);
    $tobool2681 = ($$pre88|0)==(0);
    if ($tobool2681) {
     $$pre$phi9298Z2D = $head;$21 = $tail;$error$0749396 = $call19;
     label = 16;
    } else {
     $$sink82 = $$pre88;$cnt$083 = 0;
     while(1) {
      $5 = $$sink82;
      $6 = load4($5);
      store4($tail,$6);
      $inc = (($cnt$083) + 1)|0;
      $tobool26 = ($6|0)==(0);
      if ($tobool26) {
       break;
      } else {
       $$sink82 = $6;$cnt$083 = $inc;
      }
     }
     $tobool31 = ($inc|0)==(0);
     if ($tobool31) {
      $$pre$phi9298Z2D = $head;$21 = $tail;$error$0749396 = $call19;
      label = 16;
     } else {
      $$pre$phi9297Z2D = $head;$15 = $tail;$cnt$1 = $inc;$error$0749395 = $call19;
     }
    }
   }
   if ((label|0) == 16) {
    $and33 = $flags & 16;
    $tobool34 = ($and33|0)==(0);
    if ($tobool34) {
     $retval$1 = 3;
     break;
    }
    store4($tail,$head);
    $call36 = (_strlen($pat)|0);
    $call37 = (_append($tail,$pat,$call36,0)|0);
    $tobool38 = ($call37|0)==(0);
    if ($tobool38) {
     $$pre$phi9297Z2D = $$pre$phi9298Z2D;$15 = $21;$cnt$1 = 1;$error$0749395 = $error$0749396;
    } else {
     $retval$1 = 1;
     break;
    }
   }
   do {
    if ($tobool13) {
     $gl_pathv48 = ((($g)) + 4|0);
     $7 = load4($gl_pathv48);
     $8 = load4($g);
     $add = (($cnt$1) + ($cond))|0;
     $add50 = (($add) + ($8))|0;
     $add51 = $add50 << 2;
     $mul = (($add51) + 4)|0;
     $call52 = (_realloc($7,$mul)|0);
     $tobool53 = ($call52|0)==(0|0);
     if (!($tobool53)) {
      store4($gl_pathv48,$call52);
      $add58 = (($8) + ($cond))|0;
      $offs$1 = $add58;
      break;
     }
     $9 = load4($head);
     $tobool5$i60 = ($9|0)==(0|0);
     if ($tobool5$i60) {
      $retval$1 = 1;
      break L8;
     } else {
      $match$06$i61 = $9;
     }
     while(1) {
      $10 = load4($match$06$i61);
      _free($match$06$i61);
      $tobool$i63 = ($10|0)==(0|0);
      if ($tobool$i63) {
       $retval$1 = 1;
       break L8;
      } else {
       $match$06$i61 = $10;
      }
     }
    } else {
     $add60 = (($cnt$1) + ($cond))|0;
     $add61 = $add60 << 2;
     $mul62 = (($add61) + 4)|0;
     $call63 = (_malloc($mul62)|0);
     $gl_pathv64 = ((($g)) + 4|0);
     store4($gl_pathv64,$call63);
     $tobool66 = ($call63|0)==(0|0);
     if ($tobool66) {
      $12 = load4($head);
      $tobool5$i67 = ($12|0)==(0|0);
      if ($tobool5$i67) {
       $retval$1 = 1;
       break L8;
      } else {
       $match$06$i68 = $12;
      }
      while(1) {
       $13 = load4($match$06$i68);
       _free($match$06$i68);
       $tobool$i70 = ($13|0)==(0|0);
       if ($tobool$i70) {
        $retval$1 = 1;
        break L8;
       } else {
        $match$06$i68 = $13;
       }
      }
     } else {
      $cmp7079 = ($cond|0)==(0);
      if ($cmp7079) {
       $offs$1 = 0;
       break;
      }
      $11 = $cond << 2;
      _memset(($call63|0),0,($11|0))|0;
      $offs$1 = $cond;
      break;
     }
    }
   } while(0);
   $14 = load4($$pre$phi9297Z2D);
   store4($15,$14);
   $gl_pathv84 = ((($g)) + 4|0);
   $16 = load4($gl_pathv84);
   $$in = $14;$i$178 = 0;
   while(1) {
    $17 = $$in;
    $arraydecay = ((($17)) + 4|0);
    $add83 = (($i$178) + ($offs$1))|0;
    $arrayidx85 = (($16) + ($add83<<2)|0);
    store4($arrayidx85,$arraydecay);
    $$cast = $$in;
    $18 = load4($$cast);
    store4($15,$18);
    $inc88 = (($i$178) + 1)|0;
    $cmp80 = ($inc88>>>0)<($cnt$1>>>0);
    if ($cmp80) {
     $$in = $18;$i$178 = $inc88;
    } else {
     break;
    }
   }
   $add90 = (($cnt$1) + ($offs$1))|0;
   $arrayidx92 = (($16) + ($add90<<2)|0);
   store4($arrayidx92,0);
   $19 = load4($g);
   $add94 = (($19) + ($cnt$1))|0;
   store4($g,$add94);
   $and95 = $flags & 4;
   $tobool96 = ($and95|0)==(0);
   if ($tobool96) {
    $add$ptr = (($16) + ($offs$1<<2)|0);
    _qsort($add$ptr,$cnt$1,4,8);
    $retval$1 = $error$0749395;
   } else {
    $retval$1 = $error$0749395;
   }
  }
 } while(0);
 STACKTOP = sp;return ($retval$1|0);
}
function _ignore_err($path,$err) {
 $path = $path|0;
 $err = $err|0;
 var label = 0, sp = 0;
 sp = STACKTOP;
 return 0;
}
function _match_in_dir($d,$p,$flags,$errfunc,$tail) {
 $d = $d|0;
 $p = $p|0;
 $flags = $flags|0;
 $errfunc = $errfunc|0;
 $tail = $tail|0;
 var $$ = 0, $$74 = 0, $$call1 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0;
 var $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $add = 0;
 var $add$ptr = 0, $add$ptr107 = 0, $add153 = 0, $add154 = 0, $add66 = 0, $add67 = 0, $and = 0, $and122 = 0, $and132 = 0, $and146 = 0, $and174 = 0, $and2 = 0, $and38 = 0, $and50 = 0, $arraydecay109 = 0, $arraydecay112 = 0, $arraydecay79 = 0, $arrayidx = 0, $arrayidx105 = 0, $bracket$06$i = 0;
 var $bracket$1$i = 0, $call = 0, $call1 = 0, $call116 = 0, $call155 = 0, $call171 = 0, $call22 = 0, $call23 = 0, $call35 = 0, $call42 = 0, $call48 = 0, $call5 = 0, $call57 = 0, $call62 = 0, $call62$lcssa = 0, $call6281 = 0, $call72 = 0, $call80 = 0, $cmp = 0, $cmp133 = 0;
 var $cmp14 = 0, $cmp140 = 0, $cmp147 = 0, $cmp39 = 0, $cond21 = 0, $cond59 = 0, $conv$i = 0, $conv126 = 0, $conv152 = 0, $conv65 = 0, $conv86 = 0, $d_reclen = 0, $d_reclen151 = 0, $d_type = 0, $d_type125 = 0, $de = 0, $de_buf = 0, $incdec$ptr = 0, $incdec$ptr$i = 0, $l$0 = 0;
 var $mark$0 = 0, $mark$0$shrunk = 0, $name$0 = 0, $not$tobool43 = 0, $not$tobool63 = 0, $not$tobool6384 = 0, $or = 0, $p$addr$0 = 0, $p$addr$05$i = 0, $p2$0 = 0, $p2$1 = 0, $retval$0$i = 0, $retval$4 = 0, $retval$5 = 0, $shl = 0, $shl131 = 0, $st = 0, $st143 = 0, $st_mode = 0, $st_mode145 = 0;
 var $sub$ptr$lhs$cast = 0, $sub$ptr$rhs$cast = 0, $sub$ptr$sub = 0, $switch$split2D = 0, $tobool$i = 0, $tobool1$i = 0, $tobool103 = 0, $tobool117 = 0, $tobool123 = 0, $tobool127 = 0, $tobool156 = 0, $tobool16 = 0, $tobool20 = 0, $tobool24 = 0, $tobool33 = 0, $tobool36 = 0, $tobool4$i = 0, $tobool5$i = 0, $tobool55 = 0, $tobool58 = 0;
 var $tobool6 = 0, $tobool63 = 0, $tobool63$lcssa = 0, $tobool6382 = 0, $tobool64 = 0, $tobool6483 = 0, $tobool70 = 0, $tobool73 = 0, $tobool81 = 0, $tobool84 = 0, $tobool87 = 0, $trunc = 0, $vla = 0, $vla$alloca_mul = 0, $vla69 = 0, $vla69$alloca_mul = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 432|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(432|0);
 $de_buf = sp + 156|0;
 $de = sp + 152|0;
 $st = sp + 76|0;
 $st143 = sp;
 $call = (_strlen($p)|0);
 $add = (($call) + 1)|0;
 $0 = (_llvm_stacksave()|0);
 $vla$alloca_mul = $add;
 $vla = STACKTOP; STACKTOP = STACKTOP + ((((1*$vla$alloca_mul)|0)+15)&-16)|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(((((1*$vla$alloca_mul)|0)+15)&-16)|0);;
 $call1 = (_strlen($d)|0);
 $and = $flags & 64;
 $1 = $and >>> 5;
 $and2 = $flags >>> 5;
 $2 = $and2 & 4;
 $3 = $2 | $1;
 $or = $3 ^ 4;
 $call5 = (_strchr($p,47)|0);
 $tobool6 = ($call5|0)==(0|0);
 if ($tobool6) {
  $p$addr$0 = $p;$p2$1 = 0;
 } else {
  (_strcpy($vla,$p)|0);
  $sub$ptr$lhs$cast = $call5;
  $sub$ptr$rhs$cast = $p;
  $sub$ptr$sub = (($sub$ptr$lhs$cast) - ($sub$ptr$rhs$cast))|0;
  $arrayidx = (($vla) + ($sub$ptr$sub)|0);
  store1($arrayidx,0);
  $p2$0 = $call5;
  while(1) {
   $4 = load1($p2$0);
   $cmp = ($4<<24>>24)==(47);
   $incdec$ptr = ((($p2$0)) + 1|0);
   if ($cmp) {
    $p2$0 = $incdec$ptr;
   } else {
    $p$addr$0 = $vla;$p2$1 = $p2$0;
    break;
   }
  }
 }
 $5 = load1($p$addr$0);
 $tobool4$i = ($5<<24>>24)==(0);
 L6: do {
  if ($tobool4$i) {
   $retval$0$i = 1;
  } else {
   $tobool1$i = ($and|0)==(0);
   $6 = $5;$bracket$06$i = 0;$p$addr$05$i = $p$addr$0;
   while(1) {
    $conv$i = $6 << 24 >> 24;
    switch ($conv$i|0) {
    case 42: case 63:  {
     $retval$0$i = 0;
     break L6;
     break;
    }
    case 92:  {
     if ($tobool1$i) {
      $retval$0$i = 0;
      break L6;
     } else {
      $bracket$1$i = $bracket$06$i;
     }
     break;
    }
    case 91:  {
     $bracket$1$i = 1;
     break;
    }
    case 93:  {
     $tobool5$i = ($bracket$06$i|0)==(0);
     if ($tobool5$i) {
      $bracket$1$i = 0;
     } else {
      $retval$0$i = 0;
      break L6;
     }
     break;
    }
    default: {
     $bracket$1$i = $bracket$06$i;
    }
    }
    $incdec$ptr$i = ((($p$addr$05$i)) + 1|0);
    $7 = load1($incdec$ptr$i);
    $tobool$i = ($7<<24>>24)==(0);
    if ($tobool$i) {
     $retval$0$i = 1;
     break L6;
    } else {
     $6 = $7;$bracket$06$i = $bracket$1$i;$p$addr$05$i = $incdec$ptr$i;
    }
   }
  }
 } while(0);
 $8 = load1($d);
 $cmp14 = ($8<<24>>24)==(47);
 if ($cmp14) {
  $add$ptr = ((($d)) + 1|0);
  $9 = load1($add$ptr);
  $tobool16 = ($9<<24>>24)==(0);
  $$call1 = $tobool16 ? 0 : $call1;
  $l$0 = $$call1;
 } else {
  $l$0 = $call1;
 }
 $tobool20 = ($8<<24>>24)!=(0);
 $cond21 = $tobool20 ? $d : 8391;
 $call22 = (_opendir($cond21)|0);
 $call23 = (___errno_location()|0);
 $10 = load4($call23);
 $tobool24 = ($call22|0)==(0|0);
 L19: do {
  if ($tobool24) {
   switch ($10|0) {
   case 20:  {
    $retval$5 = 0;
    break L19;
    break;
   }
   case 13:  {
    $11 = load1($p$addr$0);
    $tobool33 = ($11<<24>>24)==(0);
    if ($tobool33) {
     $call35 = (_stat($d,$st)|0);
     $tobool36 = ($call35|0)==(0);
     if ($tobool36) {
      $st_mode = ((($st)) + 12|0);
      $12 = load4($st_mode);
      $and38 = $12 & 61440;
      $cmp39 = ($and38|0)==(16384);
      if ($cmp39) {
       $call42 = (_append($tail,$d,$l$0,$l$0)|0);
       $not$tobool43 = ($call42|0)!=(0);
       $$ = $not$tobool43&1;
       $retval$5 = $$;
       break L19;
      }
     }
    }
    break;
   }
   default: {
   }
   }
   $call48 = (FUNCTION_TABLE_iii[$errfunc & 15]($d,$10)|0);
   $and50 = $flags & 1;
   $13 = $call48 | $and50;
   $14 = ($13|0)==(0);
   $$74 = $14 ? 0 : 2;
   $retval$5 = $$74;
  } else {
   $15 = load1($p$addr$0);
   $tobool55 = ($15<<24>>24)==(0);
   if ($tobool55) {
    $call57 = (_append($tail,$d,$l$0,$l$0)|0);
    $tobool58 = ($call57|0)!=(0);
    $cond59 = $tobool58&1;
    (_closedir($call22)|0);
    $retval$5 = $cond59;
    break;
   }
   $call6281 = (_readdir_r($call22,$de_buf,$de)|0);
   $tobool6382 = ($call6281|0)!=(0);
   $16 = load4($de);
   $tobool6483 = ($16|0)!=(0|0);
   $not$tobool6384 = $tobool6382 ^ 1;
   $17 = $tobool6483 & $not$tobool6384;
   L33: do {
    if ($17) {
     $add66 = (($l$0) + 2)|0;
     $tobool70 = ($retval$0$i|0)==(0);
     $tobool84 = ($p2$1|0)!=(0|0);
     $and122 = $flags & 2;
     $tobool123 = ($and122|0)==(0);
     $add153 = (($l$0) + 1)|0;
     $st_mode145 = ((($st143)) + 12|0);
     $18 = $16;
     L35: while(1) {
      $d_reclen = ((($18)) + 8|0);
      $19 = load2($d_reclen);
      $conv65 = $19&65535;
      $add67 = (($add66) + ($conv65))|0;
      $20 = (_llvm_stacksave()|0);
      $vla69$alloca_mul = $add67;
      $vla69 = STACKTOP; STACKTOP = STACKTOP + ((((1*$vla69$alloca_mul)|0)+15)&-16)|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(((((1*$vla69$alloca_mul)|0)+15)&-16)|0);;
      $21 = load4($de);
      $arraydecay79 = ((($21)) + 11|0);
      if ($tobool70) {
       $call72 = (_fnmatch($p$addr$0,$arraydecay79,$or)|0);
       $tobool73 = ($call72|0)==(0);
       if ($tobool73) {
        label = 28;
       }
      } else {
       $call80 = (_strcmp($p$addr$0,$arraydecay79)|0);
       $tobool81 = ($call80|0)==(0);
       if ($tobool81) {
        label = 28;
       }
      }
      L40: do {
       if ((label|0) == 28) {
        label = 0;
        L42: do {
         if ($tobool84) {
          $22 = load4($de);
          $d_type = ((($22)) + 10|0);
          $23 = load1($d_type);
          $tobool87 = ($23<<24>>24)==(0);
          if (!($tobool87)) {
           $conv86 = $23&255;
           $shl = $conv86 << 12;
           $trunc = $shl&65535;
           $switch$split2D = ($trunc<<16>>16)<(16384);
           if ($switch$split2D) {
            switch ($trunc<<16>>16) {
            case -24576:  {
             break L42;
             break;
            }
            default: {
             break L40;
            }
            }
           } else {
            switch ($trunc<<16>>16) {
            case 16384:  {
             break L42;
             break;
            }
            default: {
             break L40;
            }
            }
           }
          }
         }
        } while(0);
        $24 = load1($d);
        $tobool103 = ($24<<24>>24)==(0);
        if ($tobool103) {
         $26 = load4($de);
         $arraydecay112 = ((($26)) + 11|0);
         $name$0 = $arraydecay112;
        } else {
         _memcpy(($vla69|0),($d|0),($l$0|0))|0;
         $arrayidx105 = (($vla69) + ($l$0)|0);
         store1($arrayidx105,47);
         $add$ptr107 = ((($arrayidx105)) + 1|0);
         $25 = load4($de);
         $arraydecay109 = ((($25)) + 11|0);
         (_strcpy($add$ptr107,$arraydecay109)|0);
         $name$0 = $vla69;
        }
        if ($tobool84) {
         $call116 = (_match_in_dir($name$0,$p2$1,$flags,$errfunc,$tail)|0);
         $tobool117 = ($call116|0)==(0);
         if ($tobool117) {
          break;
         } else {
          label = 36;
          break L35;
         }
        }
        do {
         if ($tobool123) {
          $mark$0$shrunk = 0;
         } else {
          $27 = load4($de);
          $d_type125 = ((($27)) + 10|0);
          $28 = load1($d_type125);
          $tobool127 = ($28<<24>>24)==(0);
          if (!($tobool127)) {
           $conv126 = $28&255;
           $shl131 = $conv126 << 12;
           $and132 = $shl131 & 61440;
           $cmp133 = ($and132|0)==(40960);
           if (!($cmp133)) {
            $cmp140 = ($and132|0)==(16384);
            $mark$0$shrunk = $cmp140;
            break;
           }
          }
          (_stat($name$0,$st143)|0);
          $29 = load4($st_mode145);
          $and146 = $29 & 61440;
          $cmp147 = ($and146|0)==(16384);
          $mark$0$shrunk = $cmp147;
         }
        } while(0);
        $mark$0 = $mark$0$shrunk&1;
        $30 = load4($de);
        $d_reclen151 = ((($30)) + 8|0);
        $31 = load2($d_reclen151);
        $conv152 = $31&65535;
        $add154 = (($add153) + ($conv152))|0;
        $call155 = (_append($tail,$name$0,$add154,$mark$0)|0);
        $tobool156 = ($call155|0)==(0);
        if (!($tobool156)) {
         label = 43;
         break L35;
        }
       }
      } while(0);
      _llvm_stackrestore(($20|0));
      $call62 = (_readdir_r($call22,$de_buf,$de)|0);
      $tobool63 = ($call62|0)!=(0);
      $32 = load4($de);
      $tobool64 = ($32|0)!=(0|0);
      $not$tobool63 = $tobool63 ^ 1;
      $33 = $tobool64 & $not$tobool63;
      if ($33) {
       $18 = $32;
      } else {
       $call62$lcssa = $call62;$tobool63$lcssa = $tobool63;
       break L33;
      }
     }
     if ((label|0) == 36) {
      (_closedir($call22)|0);
      $retval$4 = $call116;
     }
     else if ((label|0) == 43) {
      (_closedir($call22)|0);
      $retval$4 = 1;
     }
     _llvm_stackrestore(($20|0));
     $retval$5 = $retval$4;
     break L19;
    } else {
     $call62$lcssa = $call6281;$tobool63$lcssa = $tobool6382;
    }
   } while(0);
   (_closedir($call22)|0);
   if ($tobool63$lcssa) {
    $call171 = (FUNCTION_TABLE_iii[$errfunc & 15]($d,$call62$lcssa)|0);
    $and174 = $flags & 1;
    $34 = $call171 | $and174;
    $35 = ($34|0)==(0);
    if (!($35)) {
     $retval$5 = 2;
     break;
    }
   }
   $retval$5 = 0;
  }
 } while(0);
 _llvm_stackrestore(($0|0));
 STACKTOP = sp;return ($retval$5|0);
}
function _append($tail,$name,$len,$mark) {
 $tail = $tail|0;
 $name = $name|0;
 $len = $len|0;
 $mark = $mark|0;
 var $0 = 0, $add1 = 0, $call = 0, $endptr = 0, $name3 = 0, $retval$0 = 0, $strlen = 0, $tobool = 0, $tobool5 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $add1 = (($len) + 9)|0;
 $call = (_malloc($add1)|0);
 $tobool = ($call|0)==(0|0);
 if ($tobool) {
  $retval$0 = -1;
 } else {
  $0 = load4($tail);
  store4($0,$call);
  store4($call,0);
  $name3 = ((($call)) + 4|0);
  (_strcpy($name3,$name)|0);
  $tobool5 = ($mark|0)==(0);
  if (!($tobool5)) {
   $strlen = (_strlen($name3)|0);
   $endptr = (($name3) + ($strlen)|0);
   store2($endptr,47,1);
  }
  store4($tail,$call);
  $retval$0 = 0;
 }
 return ($retval$0|0);
}
function _sort($a,$b) {
 $a = $a|0;
 $b = $b|0;
 var $0 = 0, $1 = 0, $call = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $0 = load4($a);
 $1 = load4($b);
 $call = (_strcmp($0,$1)|0);
 return ($call|0);
}
function _malloc($bytes) {
 $bytes = $bytes|0;
 var $$pre = 0, $$pre$i = 0, $$pre$i$i = 0, $$pre$i177 = 0, $$pre$i180 = 0, $$pre$i45$i = 0, $$pre$phi$i$iZ2D = 0, $$pre$phi$i178Z2D = 0, $$pre$phi$i46$iZ2D = 0, $$pre$phi$iZ2D = 0, $$pre$phiZ2D = 0, $$pre5$i$i = 0, $0 = 0, $1 = 0, $10 = 0, $100 = 0, $101 = 0, $102 = 0, $103 = 0, $104 = 0;
 var $105 = 0, $106 = 0, $107 = 0, $108 = 0, $109 = 0, $11 = 0, $110 = 0, $111 = 0, $112 = 0, $113 = 0, $114 = 0, $115 = 0, $116 = 0, $117 = 0, $118 = 0, $119 = 0, $12 = 0, $120 = 0, $121 = 0, $122 = 0;
 var $123 = 0, $124 = 0, $125 = 0, $126 = 0, $127 = 0, $128 = 0, $129 = 0, $13 = 0, $130 = 0, $131 = 0, $132 = 0, $133 = 0, $134 = 0, $135 = 0, $136 = 0, $137 = 0, $138 = 0, $139 = 0, $14 = 0, $140 = 0;
 var $141 = 0, $142 = 0, $143 = 0, $144 = 0, $145 = 0, $146 = 0, $147 = 0, $148 = 0, $149 = 0, $15 = 0, $150 = 0, $151 = 0, $152 = 0, $153 = 0, $154 = 0, $155 = 0, $156 = 0, $157 = 0, $158 = 0, $159 = 0;
 var $16 = 0, $160 = 0, $161 = 0, $162 = 0, $163 = 0, $164 = 0, $165 = 0, $166 = 0, $167 = 0, $168 = 0, $169 = 0, $17 = 0, $170 = 0, $171 = 0, $172 = 0, $173 = 0, $174 = 0, $175 = 0, $176 = 0, $177 = 0;
 var $178 = 0, $179 = 0, $18 = 0, $180 = 0, $181 = 0, $182 = 0, $183 = 0, $184 = 0, $185 = 0, $186 = 0, $187 = 0, $188 = 0, $189 = 0, $19 = 0, $190 = 0, $191 = 0, $192 = 0, $193 = 0, $194 = 0, $195 = 0;
 var $196 = 0, $197 = 0, $198 = 0, $199 = 0, $2 = 0, $20 = 0, $200 = 0, $201 = 0, $202 = 0, $203 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0;
 var $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0, $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0;
 var $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0, $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0;
 var $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $75 = 0, $76 = 0, $77 = 0, $78 = 0, $79 = 0, $8 = 0, $80 = 0, $81 = 0, $82 = 0, $83 = 0, $84 = 0;
 var $85 = 0, $86 = 0, $87 = 0, $88 = 0, $89 = 0, $9 = 0, $90 = 0, $91 = 0, $92 = 0, $93 = 0, $94 = 0, $95 = 0, $96 = 0, $97 = 0, $98 = 0, $99 = 0, $F$0$i$i = 0, $F104$0 = 0, $F197$0$i = 0, $F224$0$i$i = 0;
 var $F290$0$i = 0, $I252$0$i$i = 0, $I316$0$i = 0, $I57$0$i$i = 0, $K105$0$i$i = 0, $K305$0$i$i = 0, $K373$0$i = 0, $R$1$i = 0, $R$1$i$i = 0, $R$1$i168 = 0, $R$3$i = 0, $R$3$i$i = 0, $R$3$i171 = 0, $RP$1$i = 0, $RP$1$i$i = 0, $RP$1$i167 = 0, $T$0$i = 0, $T$0$i$i = 0, $T$0$i47$i = 0, $add$i = 0;
 var $add$i$i = 0, $add$i146 = 0, $add$i181 = 0, $add$ptr = 0, $add$ptr$i = 0, $add$ptr$i$i = 0, $add$ptr$i$i$i = 0, $add$ptr$i1$i$i = 0, $add$ptr$i16$i = 0, $add$ptr$i161 = 0, $add$ptr$i194 = 0, $add$ptr$i21$i = 0, $add$ptr$i49$i = 0, $add$ptr14$i$i = 0, $add$ptr15$i$i = 0, $add$ptr16$i$i = 0, $add$ptr166 = 0, $add$ptr169 = 0, $add$ptr17$i$i = 0, $add$ptr178 = 0;
 var $add$ptr181$i = 0, $add$ptr182 = 0, $add$ptr189$i = 0, $add$ptr190$i = 0, $add$ptr193 = 0, $add$ptr199 = 0, $add$ptr2$i$i = 0, $add$ptr205$i$i = 0, $add$ptr212$i$i = 0, $add$ptr225$i = 0, $add$ptr227$i = 0, $add$ptr24$i$i = 0, $add$ptr262$i = 0, $add$ptr269$i = 0, $add$ptr273$i = 0, $add$ptr282$i = 0, $add$ptr3$i$i = 0, $add$ptr30$i$i = 0, $add$ptr369$i$i = 0, $add$ptr4$i$i = 0;
 var $add$ptr4$i$i$i = 0, $add$ptr4$i26$i = 0, $add$ptr4$i54$i = 0, $add$ptr441$i = 0, $add$ptr5$i$i = 0, $add$ptr6$i$i = 0, $add$ptr6$i$i$i = 0, $add$ptr6$i58$i = 0, $add$ptr7$i$i = 0, $add$ptr8$i118$i = 0, $add$ptr95 = 0, $add$ptr98 = 0, $add10$i = 0, $add101$i = 0, $add110$i = 0, $add13$i = 0, $add14$i = 0, $add140$i = 0, $add144 = 0, $add150$i = 0;
 var $add17$i = 0, $add17$i184 = 0, $add177$i = 0, $add18$i = 0, $add19$i = 0, $add2 = 0, $add20$i = 0, $add206$i$i = 0, $add212$i = 0, $add215$i = 0, $add22$i = 0, $add246$i = 0, $add26$i$i = 0, $add268$i = 0, $add269$i$i = 0, $add274$i$i = 0, $add278$i$i = 0, $add280$i$i = 0, $add283$i$i = 0, $add337$i = 0;
 var $add342$i = 0, $add346$i = 0, $add348$i = 0, $add351$i = 0, $add46$i = 0, $add50 = 0, $add51$i = 0, $add54 = 0, $add54$i = 0, $add58 = 0, $add62 = 0, $add64 = 0, $add74$i$i = 0, $add77$i = 0, $add78$i = 0, $add79$i$i = 0, $add8 = 0, $add82$i = 0, $add83$i$i = 0, $add85$i$i = 0;
 var $add86$i = 0, $add88$i$i = 0, $add9$i = 0, $add90$i = 0, $add92$i = 0, $and = 0, $and$i = 0, $and$i$i = 0, $and$i$i$i = 0, $and$i143 = 0, $and$i17$i = 0, $and$i22$i = 0, $and$i50$i = 0, $and100$i = 0, $and103$i = 0, $and104$i = 0, $and106 = 0, $and11$add51$i = 0, $and11$i = 0, $and119$i$i = 0;
 var $and12$i = 0, $and13$i = 0, $and13$i$i = 0, $and133$i$i = 0, $and14 = 0, $and145 = 0, $and17$i = 0, $and194$i = 0, $and194$i205 = 0, $and199$i = 0, $and209$i$i = 0, $and21$i = 0, $and21$i149 = 0, $and227$i$i = 0, $and236$i = 0, $and264$i$i = 0, $and268$i$i = 0, $and273$i$i = 0, $and282$i$i = 0, $and29$i = 0;
 var $and292$i = 0, $and295$i$i = 0, $and3$i = 0, $and3$i$i = 0, $and3$i$i$i = 0, $and3$i24$i = 0, $and3$i52$i = 0, $and30$i = 0, $and318$i$i = 0, $and32$i = 0, $and32$i$i = 0, $and33$i$i = 0, $and331$i = 0, $and336$i = 0, $and341$i = 0, $and350$i = 0, $and363$i = 0, $and37$i$i = 0, $and387$i = 0, $and4 = 0;
 var $and40$i$i = 0, $and41 = 0, $and42$i = 0, $and43 = 0, $and46 = 0, $and49 = 0, $and49$i = 0, $and49$i$i = 0, $and53 = 0, $and57 = 0, $and6$i = 0, $and6$i$i = 0, $and6$i10$i = 0, $and6$i27$i = 0, $and61 = 0, $and64$i = 0, $and68$i = 0, $and69$i$i = 0, $and7 = 0, $and73$i = 0;
 var $and73$i$i = 0, $and74 = 0, $and77$i = 0, $and78$i$i = 0, $and8$i = 0, $and80$i = 0, $and81$i = 0, $and85$i = 0, $and87$i$i = 0, $and89$i = 0, $and9$i = 0, $and96$i$i = 0, $arrayidx = 0, $arrayidx$i = 0, $arrayidx$i$i = 0, $arrayidx$i14$i = 0, $arrayidx$i150 = 0, $arrayidx$i37$i = 0, $arrayidx103 = 0, $arrayidx103$i$i = 0;
 var $arrayidx106$i = 0, $arrayidx107$i$i = 0, $arrayidx113$i = 0, $arrayidx113$i159 = 0, $arrayidx121$i = 0, $arrayidx123$i$i = 0, $arrayidx126$i$i = 0, $arrayidx137$i = 0, $arrayidx143$i$i = 0, $arrayidx148$i = 0, $arrayidx151$i = 0, $arrayidx151$i$i = 0, $arrayidx154$i = 0, $arrayidx155$i = 0, $arrayidx161$i = 0, $arrayidx165$i = 0, $arrayidx165$i169 = 0, $arrayidx178$i$i = 0, $arrayidx184$i = 0, $arrayidx184$i$i = 0;
 var $arrayidx195$i$i = 0, $arrayidx196$i = 0, $arrayidx204$i = 0, $arrayidx212$i = 0, $arrayidx223$i$i = 0, $arrayidx228$i = 0, $arrayidx23$i = 0, $arrayidx239$i = 0, $arrayidx245$i = 0, $arrayidx256$i = 0, $arrayidx27$i = 0, $arrayidx287$i$i = 0, $arrayidx289$i = 0, $arrayidx290$i$i = 0, $arrayidx325$i$i = 0, $arrayidx355$i = 0, $arrayidx358$i = 0, $arrayidx394$i = 0, $arrayidx40$i = 0, $arrayidx44$i = 0;
 var $arrayidx61$i = 0, $arrayidx65$i = 0, $arrayidx66 = 0, $arrayidx71$i = 0, $arrayidx75$i = 0, $arrayidx91$i$i = 0, $arrayidx92$i$i = 0, $arrayidx94$i = 0, $arrayidx94$i156 = 0, $arrayidx96$i$i = 0, $bk = 0, $bk$i = 0, $bk$i$i = 0, $bk$i163 = 0, $bk$i35$i = 0, $bk102$i$i = 0, $bk122 = 0, $bk124 = 0, $bk136$i = 0, $bk139$i$i = 0;
 var $bk158$i$i = 0, $bk161$i$i = 0, $bk218$i = 0, $bk220$i = 0, $bk246$i$i = 0, $bk248$i$i = 0, $bk302$i$i = 0, $bk311$i = 0, $bk313$i = 0, $bk338$i$i = 0, $bk357$i$i = 0, $bk360$i$i = 0, $bk370$i = 0, $bk407$i = 0, $bk429$i = 0, $bk43$i$i = 0, $bk432$i = 0, $bk47$i = 0, $bk55$i$i = 0, $bk67$i$i = 0;
 var $bk74$i$i = 0, $bk78 = 0, $bk82$i$i = 0, $br$2$ph$i = 0, $call107$i = 0, $call131$i = 0, $call132$i = 0, $call275$i = 0, $call37$i = 0, $call68$i = 0, $call83$i = 0, $child$i$i = 0, $child166$i$i = 0, $child289$i$i = 0, $child357$i = 0, $cmp = 0, $cmp$i = 0, $cmp$i$i$i = 0, $cmp$i11$i = 0, $cmp$i140 = 0;
 var $cmp$i179 = 0, $cmp$i18$i = 0, $cmp$i2$i$i = 0, $cmp$i23$i = 0, $cmp$i51$i = 0, $cmp$i9$i = 0, $cmp1 = 0, $cmp1$i = 0, $cmp10 = 0, $cmp100$i$i = 0, $cmp102$i = 0, $cmp104$i$i = 0, $cmp105$i = 0, $cmp106$i$i = 0, $cmp107$i = 0, $cmp107$i157 = 0, $cmp108$i = 0, $cmp108$i$i = 0, $cmp112$i$i = 0, $cmp113 = 0;
 var $cmp114$i = 0, $cmp116$i = 0, $cmp118$i = 0, $cmp119$i = 0, $cmp12$i = 0, $cmp120$i$i = 0, $cmp120$i42$i = 0, $cmp121$i = 0, $cmp123$i = 0, $cmp124$i$i = 0, $cmp126$i = 0, $cmp127$i = 0, $cmp128 = 0, $cmp128$i = 0, $cmp128$i$i = 0, $cmp130$i = 0, $cmp133$i = 0, $cmp133$i$i = 0, $cmp133$i197 = 0, $cmp135$i = 0;
 var $cmp137$i = 0, $cmp137$i$i = 0, $cmp137$i198 = 0, $cmp138$i = 0, $cmp139 = 0, $cmp140$i = 0, $cmp141$not$i = 0, $cmp142$i = 0, $cmp144$i$i = 0, $cmp146 = 0, $cmp15 = 0, $cmp15$i = 0, $cmp151$i = 0, $cmp152$i = 0, $cmp153$i$i = 0, $cmp155$i = 0, $cmp156 = 0, $cmp156$i = 0, $cmp156$i$i = 0, $cmp157$i = 0;
 var $cmp159$i = 0, $cmp159$i200 = 0, $cmp16 = 0, $cmp160$i$i = 0, $cmp162 = 0, $cmp162$i = 0, $cmp162$i201 = 0, $cmp166$i = 0, $cmp168$i$i = 0, $cmp171$i = 0, $cmp172$i$i = 0, $cmp174$i = 0, $cmp180$i = 0, $cmp185$i = 0, $cmp185$i$i = 0, $cmp186 = 0, $cmp186$i = 0, $cmp189$i$i = 0, $cmp19$i = 0, $cmp190$i = 0;
 var $cmp191$i = 0, $cmp198$i = 0, $cmp2$i$i = 0, $cmp2$i$i$i = 0, $cmp20$i$i = 0, $cmp203$i = 0, $cmp205$i = 0, $cmp208$i = 0, $cmp209$i = 0, $cmp21$i = 0, $cmp215$i$i = 0, $cmp217$i = 0, $cmp218$i = 0, $cmp221$i = 0, $cmp224$i = 0, $cmp228$i = 0, $cmp229$i = 0, $cmp233$i = 0, $cmp236$i$i = 0, $cmp24$i = 0;
 var $cmp24$i$i = 0, $cmp246$i = 0, $cmp250$i = 0, $cmp254$i$i = 0, $cmp257$i = 0, $cmp258$i$i = 0, $cmp26$i = 0, $cmp265$i = 0, $cmp27$i$i = 0, $cmp28$i = 0, $cmp28$i$i = 0, $cmp284$i = 0, $cmp29 = 0, $cmp3$i$i = 0, $cmp301$i = 0, $cmp306$i$i = 0, $cmp31 = 0, $cmp319$i = 0, $cmp319$i$i = 0, $cmp32$i = 0;
 var $cmp32$i186 = 0, $cmp323$i = 0, $cmp327$i$i = 0, $cmp33$i = 0, $cmp332$i$i = 0, $cmp34$i = 0, $cmp34$i$i = 0, $cmp35$i = 0, $cmp350$i$i = 0, $cmp36$i = 0, $cmp36$i$i = 0, $cmp374$i = 0, $cmp38$i = 0, $cmp38$i$i = 0, $cmp388$i = 0, $cmp396$i = 0, $cmp40$i = 0, $cmp401$i = 0, $cmp41$i$i = 0, $cmp42$i$i = 0;
 var $cmp422$i = 0, $cmp43$i = 0, $cmp44$i$i = 0, $cmp45$i = 0, $cmp45$i155 = 0, $cmp46$i = 0, $cmp46$i$i = 0, $cmp46$i38$i = 0, $cmp48$i = 0, $cmp49$i = 0, $cmp5 = 0, $cmp51$i = 0, $cmp54$i$i = 0, $cmp55$i = 0, $cmp55$i187 = 0, $cmp57$i = 0, $cmp57$i$i = 0, $cmp57$i188 = 0, $cmp59$i$i = 0, $cmp60$i = 0;
 var $cmp60$i$i = 0, $cmp62$i = 0, $cmp63$i = 0, $cmp63$i$i = 0, $cmp65$i = 0, $cmp66$i = 0, $cmp66$i191 = 0, $cmp69$i = 0, $cmp7$i$i = 0, $cmp70 = 0, $cmp72$i = 0, $cmp75$i$i = 0, $cmp76 = 0, $cmp76$i = 0, $cmp79 = 0, $cmp81$i = 0, $cmp81$i$i = 0, $cmp81$i192 = 0, $cmp83$i$i = 0, $cmp85$i = 0;
 var $cmp86$i$i = 0, $cmp89$i = 0, $cmp9$i$i = 0, $cmp90$i = 0, $cmp91$i = 0, $cmp93$i = 0, $cmp95$i = 0, $cmp96$i = 0, $cmp97$i = 0, $cmp97$i$i = 0, $cmp977$i = 0, $cmp99 = 0, $cond = 0, $cond$i = 0, $cond$i$i = 0, $cond$i$i$i = 0, $cond$i19$i = 0, $cond$i25$i = 0, $cond$i53$i = 0, $cond$v$0$i = 0;
 var $cond115$i$i = 0, $cond13$i$i = 0, $cond15$i$i = 0, $cond2$i = 0, $cond2$i$i = 0, $cond3$i = 0, $cond315$i$i = 0, $cond383$i = 0, $cond4$i = 0, $exitcond$i$i = 0, $fd$i = 0, $fd$i$i = 0, $fd$i164 = 0, $fd103$i$i = 0, $fd123 = 0, $fd139$i = 0, $fd140$i$i = 0, $fd148$i$i = 0, $fd160$i$i = 0, $fd219$i = 0;
 var $fd247$i$i = 0, $fd303$i$i = 0, $fd312$i = 0, $fd339$i$i = 0, $fd344$i$i = 0, $fd359$i$i = 0, $fd371$i = 0, $fd408$i = 0, $fd416$i = 0, $fd431$i = 0, $fd50$i = 0, $fd54$i$i = 0, $fd59$i$i = 0, $fd68$pre$phi$i$iZ2D = 0, $fd69 = 0, $fd78$i$i = 0, $fd85$i$i = 0, $fd9 = 0, $head = 0, $head$i = 0;
 var $head$i$i = 0, $head$i$i$i = 0, $head$i154 = 0, $head$i20$i = 0, $head$i31$i = 0, $head$i57$i = 0, $head118$i$i = 0, $head168 = 0, $head173 = 0, $head177 = 0, $head179 = 0, $head179$i = 0, $head182$i = 0, $head187$i = 0, $head189$i = 0, $head195 = 0, $head198 = 0, $head208$i$i = 0, $head211$i$i = 0, $head23$i$i = 0;
 var $head25 = 0, $head265$i = 0, $head268$i = 0, $head271$i = 0, $head274$i = 0, $head279$i = 0, $head281$i = 0, $head29$i = 0, $head29$i$i = 0, $head317$i$i = 0, $head32$i$i = 0, $head34$i$i = 0, $head386$i = 0, $head7$i$i = 0, $head7$i$i$i = 0, $head7$i59$i = 0, $head94 = 0, $head97 = 0, $head99$i = 0, $i$01$i$i = 0;
 var $idx$0$i = 0, $inc$i$i = 0, $index$i = 0, $index$i$i = 0, $index$i172 = 0, $index$i43$i = 0, $index288$i$i = 0, $index356$i = 0, $magic$i$i = 0, $nb$0 = 0, $neg = 0, $neg$i = 0, $neg$i$i = 0, $neg$i173 = 0, $neg$i183 = 0, $neg103$i = 0, $neg13 = 0, $neg132$i$i = 0, $neg48$i = 0, $neg73 = 0;
 var $next$i = 0, $next$i$i = 0, $next$i$i$i = 0, $next231$i = 0, $not$cmp150$i$i = 0, $not$cmp346$i$i = 0, $not$cmp418$i = 0, $oldfirst$0$i$i = 0, $or$cond$i = 0, $or$cond$i189 = 0, $or$cond1$i = 0, $or$cond1$i185 = 0, $or$cond2$i = 0, $or$cond3$i = 0, $or$cond4$i = 0, $or$cond5$i = 0, $or$cond7$i = 0, $or$cond8$i = 0, $or$cond95$i = 0, $or$i = 0;
 var $or$i$i = 0, $or$i$i$i = 0, $or$i196 = 0, $or$i56$i = 0, $or101$i$i = 0, $or110 = 0, $or167 = 0, $or172 = 0, $or176 = 0, $or178$i = 0, $or180 = 0, $or183$i = 0, $or186$i = 0, $or188$i = 0, $or19$i$i = 0, $or194 = 0, $or197 = 0, $or204$i = 0, $or210$i$i = 0, $or22$i$i = 0;
 var $or23 = 0, $or232$i$i = 0, $or26 = 0, $or264$i = 0, $or267$i = 0, $or270$i = 0, $or275$i = 0, $or278$i = 0, $or28$i$i = 0, $or280$i = 0, $or297$i = 0, $or300$i$i = 0, $or33$i$i = 0, $or368$i = 0, $or40 = 0, $or44$i$i = 0, $or93 = 0, $or96 = 0, $p$0$i$i = 0, $parent$i = 0;
 var $parent$i$i = 0, $parent$i162 = 0, $parent$i40$i = 0, $parent135$i = 0, $parent138$i$i = 0, $parent149$i = 0, $parent162$i$i = 0, $parent165$i$i = 0, $parent166$i = 0, $parent179$i$i = 0, $parent196$i$i = 0, $parent226$i = 0, $parent240$i = 0, $parent257$i = 0, $parent301$i$i = 0, $parent337$i$i = 0, $parent361$i$i = 0, $parent369$i = 0, $parent406$i = 0, $parent433$i = 0;
 var $qsize$0$i$i = 0, $retval$0 = 0, $rsize$0$i = 0, $rsize$0$i152 = 0, $rsize$1$i = 0, $rsize$3$i = 0, $rsize$4$lcssa$i = 0, $rsize$49$i = 0, $rst$0$i = 0, $rst$1$i = 0, $sflags193$i = 0, $sflags235$i = 0, $shl = 0, $shl$i = 0, $shl$i$i = 0, $shl$i13$i = 0, $shl$i144 = 0, $shl$i36$i = 0, $shl102 = 0, $shl105 = 0;
 var $shl116$i$i = 0, $shl12 = 0, $shl127$i$i = 0, $shl131$i$i = 0, $shl15$i = 0, $shl18$i = 0, $shl192$i = 0, $shl195$i = 0, $shl198$i = 0, $shl22 = 0, $shl221$i$i = 0, $shl226$i$i = 0, $shl265$i$i = 0, $shl270$i$i = 0, $shl276$i$i = 0, $shl279$i$i = 0, $shl288$i = 0, $shl291$i = 0, $shl294$i$i = 0, $shl31$i = 0;
 var $shl316$i$i = 0, $shl326$i$i = 0, $shl333$i = 0, $shl338$i = 0, $shl344$i = 0, $shl347$i = 0, $shl35 = 0, $shl362$i = 0, $shl37 = 0, $shl384$i = 0, $shl39$i$i = 0, $shl395$i = 0, $shl48$i$i = 0, $shl52$i = 0, $shl60$i = 0, $shl65 = 0, $shl70$i$i = 0, $shl72 = 0, $shl75$i$i = 0, $shl81$i$i = 0;
 var $shl84$i$i = 0, $shl9$i = 0, $shl90 = 0, $shl95$i$i = 0, $shr = 0, $shr$i = 0, $shr$i$i = 0, $shr$i139 = 0, $shr$i34$i = 0, $shr101 = 0, $shr11$i = 0, $shr11$i147 = 0, $shr110$i$i = 0, $shr12$i = 0, $shr123$i$i = 0, $shr15$i = 0, $shr16$i = 0, $shr16$i148 = 0, $shr19$i = 0, $shr194$i = 0;
 var $shr20$i = 0, $shr214$i$i = 0, $shr253$i$i = 0, $shr263$i$i = 0, $shr267$i$i = 0, $shr27$i = 0, $shr272$i$i = 0, $shr277$i$i = 0, $shr281$i$i = 0, $shr283$i = 0, $shr3 = 0, $shr310$i$i = 0, $shr318$i = 0, $shr322$i$i = 0, $shr330$i = 0, $shr335$i = 0, $shr340$i = 0, $shr345$i = 0, $shr349$i = 0, $shr378$i = 0;
 var $shr391$i = 0, $shr4$i = 0, $shr41$i = 0, $shr45 = 0, $shr47 = 0, $shr48 = 0, $shr5$i = 0, $shr5$i142 = 0, $shr51 = 0, $shr52 = 0, $shr55 = 0, $shr56 = 0, $shr58$i$i = 0, $shr59 = 0, $shr60 = 0, $shr63 = 0, $shr68$i$i = 0, $shr7$i = 0, $shr7$i145 = 0, $shr72$i = 0;
 var $shr72$i$i = 0, $shr75$i = 0, $shr76$i = 0, $shr77$i$i = 0, $shr79$i = 0, $shr8$i = 0, $shr80$i = 0, $shr82$i$i = 0, $shr83$i = 0, $shr84$i = 0, $shr86$i$i = 0, $shr87$i = 0, $shr88$i = 0, $shr91$i = 0, $size$i$i = 0, $size$i$i$i = 0, $size188$i = 0, $size245$i = 0, $sizebits$0$i = 0, $sizebits$0$shl52$i = 0;
 var $sp$0$i$i = 0, $sp$0$i$i$i = 0, $sp$0104$i = 0, $sp$1103$i = 0, $ssize$2$ph$i = 0, $ssize$5$i = 0, $sub = 0, $sub$i = 0, $sub$i138 = 0, $sub$i182 = 0, $sub$ptr$lhs$cast$i = 0, $sub$ptr$lhs$cast$i$i = 0, $sub$ptr$lhs$cast$i28$i = 0, $sub$ptr$rhs$cast$i = 0, $sub$ptr$rhs$cast$i$i = 0, $sub$ptr$rhs$cast$i29$i = 0, $sub$ptr$sub$i = 0, $sub$ptr$sub$i$i = 0, $sub$ptr$sub$i30$i = 0, $sub10$i = 0;
 var $sub101$i = 0, $sub101$rsize$4$i = 0, $sub112$i = 0, $sub113$i$i = 0, $sub118$i = 0, $sub14$i = 0, $sub16$i$i = 0, $sub160 = 0, $sub172$i = 0, $sub18$i$i = 0, $sub190 = 0, $sub2$i = 0, $sub22$i = 0, $sub260$i = 0, $sub262$i$i = 0, $sub266$i$i = 0, $sub271$i$i = 0, $sub275$i$i = 0, $sub30$i = 0, $sub31$i = 0;
 var $sub31$rsize$0$i = 0, $sub313$i$i = 0, $sub329$i = 0, $sub33$i = 0, $sub334$i = 0, $sub339$i = 0, $sub343$i = 0, $sub381$i = 0, $sub4$i = 0, $sub41$i = 0, $sub42 = 0, $sub44 = 0, $sub5$i$i = 0, $sub5$i$i$i = 0, $sub5$i55$i = 0, $sub50$i = 0, $sub6$i = 0, $sub63$i = 0, $sub67$i = 0, $sub67$i$i = 0;
 var $sub70$i = 0, $sub71$i$i = 0, $sub76$i$i = 0, $sub80$i$i = 0, $sub91 = 0, $sub99$i = 0, $t$0$i = 0, $t$0$i151 = 0, $t$2$i = 0, $t$4$ph$i = 0, $t$4$v$4$i = 0, $t$48$i = 0, $tbase$793$i = 0, $tobool$i$i = 0, $tobool107 = 0, $tobool195$i = 0, $tobool200$i = 0, $tobool228$i$i = 0, $tobool237$i = 0, $tobool293$i = 0;
 var $tobool296$i$i = 0, $tobool30$i = 0, $tobool364$i = 0, $tobool97$i$i = 0, $tsize$792$i = 0, $v$0$i = 0, $v$0$i153 = 0, $v$1$i = 0, $v$3$i = 0, $v$4$lcssa$i = 0, $v$410$i = 0, $xor$i$i = 0, label = 0, sp = 0;
 sp = STACKTOP;
 STACKTOP = STACKTOP + 16|0; if ((STACKTOP|0) >= (STACK_MAX|0)) abortStackOverflow(16|0);
 $magic$i$i = sp;
 $cmp = ($bytes>>>0)<(245);
 do {
  if ($cmp) {
   $cmp1 = ($bytes>>>0)<(11);
   $add2 = (($bytes) + 11)|0;
   $and = $add2 & -8;
   $cond = $cmp1 ? 16 : $and;
   $shr = $cond >>> 3;
   $0 = load4(8444);
   $shr3 = $0 >>> $shr;
   $and4 = $shr3 & 3;
   $cmp5 = ($and4|0)==(0);
   if (!($cmp5)) {
    $neg = $shr3 & 1;
    $and7 = $neg ^ 1;
    $add8 = (($and7) + ($shr))|0;
    $shl = $add8 << 1;
    $arrayidx = (8484 + ($shl<<2)|0);
    $1 = ((($arrayidx)) + 8|0);
    $2 = load4($1);
    $fd9 = ((($2)) + 8|0);
    $3 = load4($fd9);
    $cmp10 = ($arrayidx|0)==($3|0);
    do {
     if ($cmp10) {
      $shl12 = 1 << $add8;
      $neg13 = $shl12 ^ -1;
      $and14 = $0 & $neg13;
      store4(8444,$and14);
     } else {
      $4 = load4((8460));
      $cmp15 = ($3>>>0)<($4>>>0);
      if ($cmp15) {
       _abort();
       // unreachable;
      }
      $bk = ((($3)) + 12|0);
      $5 = load4($bk);
      $cmp16 = ($5|0)==($2|0);
      if ($cmp16) {
       store4($bk,$arrayidx);
       store4($1,$3);
       break;
      } else {
       _abort();
       // unreachable;
      }
     }
    } while(0);
    $shl22 = $add8 << 3;
    $or23 = $shl22 | 3;
    $head = ((($2)) + 4|0);
    store4($head,$or23);
    $add$ptr = (($2) + ($shl22)|0);
    $head25 = ((($add$ptr)) + 4|0);
    $6 = load4($head25);
    $or26 = $6 | 1;
    store4($head25,$or26);
    $retval$0 = $fd9;
    STACKTOP = sp;return ($retval$0|0);
   }
   $7 = load4((8452));
   $cmp29 = ($cond>>>0)>($7>>>0);
   if ($cmp29) {
    $cmp31 = ($shr3|0)==(0);
    if (!($cmp31)) {
     $shl35 = $shr3 << $shr;
     $shl37 = 2 << $shr;
     $sub = (0 - ($shl37))|0;
     $or40 = $shl37 | $sub;
     $and41 = $shl35 & $or40;
     $sub42 = (0 - ($and41))|0;
     $and43 = $and41 & $sub42;
     $sub44 = (($and43) + -1)|0;
     $shr45 = $sub44 >>> 12;
     $and46 = $shr45 & 16;
     $shr47 = $sub44 >>> $and46;
     $shr48 = $shr47 >>> 5;
     $and49 = $shr48 & 8;
     $add50 = $and49 | $and46;
     $shr51 = $shr47 >>> $and49;
     $shr52 = $shr51 >>> 2;
     $and53 = $shr52 & 4;
     $add54 = $add50 | $and53;
     $shr55 = $shr51 >>> $and53;
     $shr56 = $shr55 >>> 1;
     $and57 = $shr56 & 2;
     $add58 = $add54 | $and57;
     $shr59 = $shr55 >>> $and57;
     $shr60 = $shr59 >>> 1;
     $and61 = $shr60 & 1;
     $add62 = $add58 | $and61;
     $shr63 = $shr59 >>> $and61;
     $add64 = (($add62) + ($shr63))|0;
     $shl65 = $add64 << 1;
     $arrayidx66 = (8484 + ($shl65<<2)|0);
     $8 = ((($arrayidx66)) + 8|0);
     $9 = load4($8);
     $fd69 = ((($9)) + 8|0);
     $10 = load4($fd69);
     $cmp70 = ($arrayidx66|0)==($10|0);
     do {
      if ($cmp70) {
       $shl72 = 1 << $add64;
       $neg73 = $shl72 ^ -1;
       $and74 = $0 & $neg73;
       store4(8444,$and74);
       $14 = $and74;
      } else {
       $11 = load4((8460));
       $cmp76 = ($10>>>0)<($11>>>0);
       if ($cmp76) {
        _abort();
        // unreachable;
       }
       $bk78 = ((($10)) + 12|0);
       $12 = load4($bk78);
       $cmp79 = ($12|0)==($9|0);
       if ($cmp79) {
        store4($bk78,$arrayidx66);
        store4($8,$10);
        $14 = $0;
        break;
       } else {
        _abort();
        // unreachable;
       }
      }
     } while(0);
     $shl90 = $add64 << 3;
     $sub91 = (($shl90) - ($cond))|0;
     $or93 = $cond | 3;
     $head94 = ((($9)) + 4|0);
     store4($head94,$or93);
     $add$ptr95 = (($9) + ($cond)|0);
     $or96 = $sub91 | 1;
     $head97 = ((($add$ptr95)) + 4|0);
     store4($head97,$or96);
     $add$ptr98 = (($add$ptr95) + ($sub91)|0);
     store4($add$ptr98,$sub91);
     $cmp99 = ($7|0)==(0);
     if (!($cmp99)) {
      $13 = load4((8464));
      $shr101 = $7 >>> 3;
      $shl102 = $shr101 << 1;
      $arrayidx103 = (8484 + ($shl102<<2)|0);
      $shl105 = 1 << $shr101;
      $and106 = $14 & $shl105;
      $tobool107 = ($and106|0)==(0);
      if ($tobool107) {
       $or110 = $14 | $shl105;
       store4(8444,$or110);
       $$pre = ((($arrayidx103)) + 8|0);
       $$pre$phiZ2D = $$pre;$F104$0 = $arrayidx103;
      } else {
       $15 = ((($arrayidx103)) + 8|0);
       $16 = load4($15);
       $17 = load4((8460));
       $cmp113 = ($16>>>0)<($17>>>0);
       if ($cmp113) {
        _abort();
        // unreachable;
       } else {
        $$pre$phiZ2D = $15;$F104$0 = $16;
       }
      }
      store4($$pre$phiZ2D,$13);
      $bk122 = ((($F104$0)) + 12|0);
      store4($bk122,$13);
      $fd123 = ((($13)) + 8|0);
      store4($fd123,$F104$0);
      $bk124 = ((($13)) + 12|0);
      store4($bk124,$arrayidx103);
     }
     store4((8452),$sub91);
     store4((8464),$add$ptr95);
     $retval$0 = $fd69;
     STACKTOP = sp;return ($retval$0|0);
    }
    $18 = load4((8448));
    $cmp128 = ($18|0)==(0);
    if ($cmp128) {
     $nb$0 = $cond;
    } else {
     $sub$i = (0 - ($18))|0;
     $and$i = $18 & $sub$i;
     $sub2$i = (($and$i) + -1)|0;
     $shr$i = $sub2$i >>> 12;
     $and3$i = $shr$i & 16;
     $shr4$i = $sub2$i >>> $and3$i;
     $shr5$i = $shr4$i >>> 5;
     $and6$i = $shr5$i & 8;
     $add$i = $and6$i | $and3$i;
     $shr7$i = $shr4$i >>> $and6$i;
     $shr8$i = $shr7$i >>> 2;
     $and9$i = $shr8$i & 4;
     $add10$i = $add$i | $and9$i;
     $shr11$i = $shr7$i >>> $and9$i;
     $shr12$i = $shr11$i >>> 1;
     $and13$i = $shr12$i & 2;
     $add14$i = $add10$i | $and13$i;
     $shr15$i = $shr11$i >>> $and13$i;
     $shr16$i = $shr15$i >>> 1;
     $and17$i = $shr16$i & 1;
     $add18$i = $add14$i | $and17$i;
     $shr19$i = $shr15$i >>> $and17$i;
     $add20$i = (($add18$i) + ($shr19$i))|0;
     $arrayidx$i = (8748 + ($add20$i<<2)|0);
     $19 = load4($arrayidx$i);
     $head$i = ((($19)) + 4|0);
     $20 = load4($head$i);
     $and21$i = $20 & -8;
     $sub22$i = (($and21$i) - ($cond))|0;
     $rsize$0$i = $sub22$i;$t$0$i = $19;$v$0$i = $19;
     while(1) {
      $arrayidx23$i = ((($t$0$i)) + 16|0);
      $21 = load4($arrayidx23$i);
      $cmp$i = ($21|0)==(0|0);
      if ($cmp$i) {
       $arrayidx27$i = ((($t$0$i)) + 20|0);
       $22 = load4($arrayidx27$i);
       $cmp28$i = ($22|0)==(0|0);
       if ($cmp28$i) {
        break;
       } else {
        $cond4$i = $22;
       }
      } else {
       $cond4$i = $21;
      }
      $head29$i = ((($cond4$i)) + 4|0);
      $23 = load4($head29$i);
      $and30$i = $23 & -8;
      $sub31$i = (($and30$i) - ($cond))|0;
      $cmp32$i = ($sub31$i>>>0)<($rsize$0$i>>>0);
      $sub31$rsize$0$i = $cmp32$i ? $sub31$i : $rsize$0$i;
      $cond$v$0$i = $cmp32$i ? $cond4$i : $v$0$i;
      $rsize$0$i = $sub31$rsize$0$i;$t$0$i = $cond4$i;$v$0$i = $cond$v$0$i;
     }
     $24 = load4((8460));
     $cmp33$i = ($v$0$i>>>0)<($24>>>0);
     if ($cmp33$i) {
      _abort();
      // unreachable;
     }
     $add$ptr$i = (($v$0$i) + ($cond)|0);
     $cmp35$i = ($v$0$i>>>0)<($add$ptr$i>>>0);
     if (!($cmp35$i)) {
      _abort();
      // unreachable;
     }
     $parent$i = ((($v$0$i)) + 24|0);
     $25 = load4($parent$i);
     $bk$i = ((($v$0$i)) + 12|0);
     $26 = load4($bk$i);
     $cmp40$i = ($26|0)==($v$0$i|0);
     do {
      if ($cmp40$i) {
       $arrayidx61$i = ((($v$0$i)) + 20|0);
       $30 = load4($arrayidx61$i);
       $cmp62$i = ($30|0)==(0|0);
       if ($cmp62$i) {
        $arrayidx65$i = ((($v$0$i)) + 16|0);
        $31 = load4($arrayidx65$i);
        $cmp66$i = ($31|0)==(0|0);
        if ($cmp66$i) {
         $R$3$i = 0;
         break;
        } else {
         $R$1$i = $31;$RP$1$i = $arrayidx65$i;
        }
       } else {
        $R$1$i = $30;$RP$1$i = $arrayidx61$i;
       }
       while(1) {
        $arrayidx71$i = ((($R$1$i)) + 20|0);
        $32 = load4($arrayidx71$i);
        $cmp72$i = ($32|0)==(0|0);
        if (!($cmp72$i)) {
         $R$1$i = $32;$RP$1$i = $arrayidx71$i;
         continue;
        }
        $arrayidx75$i = ((($R$1$i)) + 16|0);
        $33 = load4($arrayidx75$i);
        $cmp76$i = ($33|0)==(0|0);
        if ($cmp76$i) {
         break;
        } else {
         $R$1$i = $33;$RP$1$i = $arrayidx75$i;
        }
       }
       $cmp81$i = ($RP$1$i>>>0)<($24>>>0);
       if ($cmp81$i) {
        _abort();
        // unreachable;
       } else {
        store4($RP$1$i,0);
        $R$3$i = $R$1$i;
        break;
       }
      } else {
       $fd$i = ((($v$0$i)) + 8|0);
       $27 = load4($fd$i);
       $cmp45$i = ($27>>>0)<($24>>>0);
       if ($cmp45$i) {
        _abort();
        // unreachable;
       }
       $bk47$i = ((($27)) + 12|0);
       $28 = load4($bk47$i);
       $cmp48$i = ($28|0)==($v$0$i|0);
       if (!($cmp48$i)) {
        _abort();
        // unreachable;
       }
       $fd50$i = ((($26)) + 8|0);
       $29 = load4($fd50$i);
       $cmp51$i = ($29|0)==($v$0$i|0);
       if ($cmp51$i) {
        store4($bk47$i,$26);
        store4($fd50$i,$27);
        $R$3$i = $26;
        break;
       } else {
        _abort();
        // unreachable;
       }
      }
     } while(0);
     $cmp90$i = ($25|0)==(0|0);
     do {
      if (!($cmp90$i)) {
       $index$i = ((($v$0$i)) + 28|0);
       $34 = load4($index$i);
       $arrayidx94$i = (8748 + ($34<<2)|0);
       $35 = load4($arrayidx94$i);
       $cmp95$i = ($v$0$i|0)==($35|0);
       if ($cmp95$i) {
        store4($arrayidx94$i,$R$3$i);
        $cond2$i = ($R$3$i|0)==(0|0);
        if ($cond2$i) {
         $shl$i = 1 << $34;
         $neg$i = $shl$i ^ -1;
         $and103$i = $18 & $neg$i;
         store4((8448),$and103$i);
         break;
        }
       } else {
        $36 = load4((8460));
        $cmp107$i = ($25>>>0)<($36>>>0);
        if ($cmp107$i) {
         _abort();
         // unreachable;
        }
        $arrayidx113$i = ((($25)) + 16|0);
        $37 = load4($arrayidx113$i);
        $cmp114$i = ($37|0)==($v$0$i|0);
        if ($cmp114$i) {
         store4($arrayidx113$i,$R$3$i);
        } else {
         $arrayidx121$i = ((($25)) + 20|0);
         store4($arrayidx121$i,$R$3$i);
        }
        $cmp126$i = ($R$3$i|0)==(0|0);
        if ($cmp126$i) {
         break;
        }
       }
       $38 = load4((8460));
       $cmp130$i = ($R$3$i>>>0)<($38>>>0);
       if ($cmp130$i) {
        _abort();
        // unreachable;
       }
       $parent135$i = ((($R$3$i)) + 24|0);
       store4($parent135$i,$25);
       $arrayidx137$i = ((($v$0$i)) + 16|0);
       $39 = load4($arrayidx137$i);
       $cmp138$i = ($39|0)==(0|0);
       do {
        if (!($cmp138$i)) {
         $cmp142$i = ($39>>>0)<($38>>>0);
         if ($cmp142$i) {
          _abort();
          // unreachable;
         } else {
          $arrayidx148$i = ((($R$3$i)) + 16|0);
          store4($arrayidx148$i,$39);
          $parent149$i = ((($39)) + 24|0);
          store4($parent149$i,$R$3$i);
          break;
         }
        }
       } while(0);
       $arrayidx154$i = ((($v$0$i)) + 20|0);
       $40 = load4($arrayidx154$i);
       $cmp155$i = ($40|0)==(0|0);
       if (!($cmp155$i)) {
        $41 = load4((8460));
        $cmp159$i = ($40>>>0)<($41>>>0);
        if ($cmp159$i) {
         _abort();
         // unreachable;
        } else {
         $arrayidx165$i = ((($R$3$i)) + 20|0);
         store4($arrayidx165$i,$40);
         $parent166$i = ((($40)) + 24|0);
         store4($parent166$i,$R$3$i);
         break;
        }
       }
      }
     } while(0);
     $cmp174$i = ($rsize$0$i>>>0)<(16);
     if ($cmp174$i) {
      $add177$i = (($rsize$0$i) + ($cond))|0;
      $or178$i = $add177$i | 3;
      $head179$i = ((($v$0$i)) + 4|0);
      store4($head179$i,$or178$i);
      $add$ptr181$i = (($v$0$i) + ($add177$i)|0);
      $head182$i = ((($add$ptr181$i)) + 4|0);
      $42 = load4($head182$i);
      $or183$i = $42 | 1;
      store4($head182$i,$or183$i);
     } else {
      $or186$i = $cond | 3;
      $head187$i = ((($v$0$i)) + 4|0);
      store4($head187$i,$or186$i);
      $or188$i = $rsize$0$i | 1;
      $head189$i = ((($add$ptr$i)) + 4|0);
      store4($head189$i,$or188$i);
      $add$ptr190$i = (($add$ptr$i) + ($rsize$0$i)|0);
      store4($add$ptr190$i,$rsize$0$i);
      $cmp191$i = ($7|0)==(0);
      if (!($cmp191$i)) {
       $43 = load4((8464));
       $shr194$i = $7 >>> 3;
       $shl195$i = $shr194$i << 1;
       $arrayidx196$i = (8484 + ($shl195$i<<2)|0);
       $shl198$i = 1 << $shr194$i;
       $and199$i = $0 & $shl198$i;
       $tobool200$i = ($and199$i|0)==(0);
       if ($tobool200$i) {
        $or204$i = $0 | $shl198$i;
        store4(8444,$or204$i);
        $$pre$i = ((($arrayidx196$i)) + 8|0);
        $$pre$phi$iZ2D = $$pre$i;$F197$0$i = $arrayidx196$i;
       } else {
        $44 = ((($arrayidx196$i)) + 8|0);
        $45 = load4($44);
        $46 = load4((8460));
        $cmp208$i = ($45>>>0)<($46>>>0);
        if ($cmp208$i) {
         _abort();
         // unreachable;
        } else {
         $$pre$phi$iZ2D = $44;$F197$0$i = $45;
        }
       }
       store4($$pre$phi$iZ2D,$43);
       $bk218$i = ((($F197$0$i)) + 12|0);
       store4($bk218$i,$43);
       $fd219$i = ((($43)) + 8|0);
       store4($fd219$i,$F197$0$i);
       $bk220$i = ((($43)) + 12|0);
       store4($bk220$i,$arrayidx196$i);
      }
      store4((8452),$rsize$0$i);
      store4((8464),$add$ptr$i);
     }
     $add$ptr225$i = ((($v$0$i)) + 8|0);
     $retval$0 = $add$ptr225$i;
     STACKTOP = sp;return ($retval$0|0);
    }
   } else {
    $nb$0 = $cond;
   }
  } else {
   $cmp139 = ($bytes>>>0)>(4294967231);
   if ($cmp139) {
    $nb$0 = -1;
   } else {
    $add144 = (($bytes) + 11)|0;
    $and145 = $add144 & -8;
    $47 = load4((8448));
    $cmp146 = ($47|0)==(0);
    if ($cmp146) {
     $nb$0 = $and145;
    } else {
     $sub$i138 = (0 - ($and145))|0;
     $shr$i139 = $add144 >>> 8;
     $cmp$i140 = ($shr$i139|0)==(0);
     if ($cmp$i140) {
      $idx$0$i = 0;
     } else {
      $cmp1$i = ($and145>>>0)>(16777215);
      if ($cmp1$i) {
       $idx$0$i = 31;
      } else {
       $sub4$i = (($shr$i139) + 1048320)|0;
       $shr5$i142 = $sub4$i >>> 16;
       $and$i143 = $shr5$i142 & 8;
       $shl$i144 = $shr$i139 << $and$i143;
       $sub6$i = (($shl$i144) + 520192)|0;
       $shr7$i145 = $sub6$i >>> 16;
       $and8$i = $shr7$i145 & 4;
       $add$i146 = $and8$i | $and$i143;
       $shl9$i = $shl$i144 << $and8$i;
       $sub10$i = (($shl9$i) + 245760)|0;
       $shr11$i147 = $sub10$i >>> 16;
       $and12$i = $shr11$i147 & 2;
       $add13$i = $add$i146 | $and12$i;
       $sub14$i = (14 - ($add13$i))|0;
       $shl15$i = $shl9$i << $and12$i;
       $shr16$i148 = $shl15$i >>> 15;
       $add17$i = (($sub14$i) + ($shr16$i148))|0;
       $shl18$i = $add17$i << 1;
       $add19$i = (($add17$i) + 7)|0;
       $shr20$i = $and145 >>> $add19$i;
       $and21$i149 = $shr20$i & 1;
       $add22$i = $and21$i149 | $shl18$i;
       $idx$0$i = $add22$i;
      }
     }
     $arrayidx$i150 = (8748 + ($idx$0$i<<2)|0);
     $48 = load4($arrayidx$i150);
     $cmp24$i = ($48|0)==(0|0);
     L123: do {
      if ($cmp24$i) {
       $rsize$3$i = $sub$i138;$t$2$i = 0;$v$3$i = 0;
       label = 86;
      } else {
       $cmp26$i = ($idx$0$i|0)==(31);
       $shr27$i = $idx$0$i >>> 1;
       $sub30$i = (25 - ($shr27$i))|0;
       $cond$i = $cmp26$i ? 0 : $sub30$i;
       $shl31$i = $and145 << $cond$i;
       $rsize$0$i152 = $sub$i138;$rst$0$i = 0;$sizebits$0$i = $shl31$i;$t$0$i151 = $48;$v$0$i153 = 0;
       while(1) {
        $head$i154 = ((($t$0$i151)) + 4|0);
        $49 = load4($head$i154);
        $and32$i = $49 & -8;
        $sub33$i = (($and32$i) - ($and145))|0;
        $cmp34$i = ($sub33$i>>>0)<($rsize$0$i152>>>0);
        if ($cmp34$i) {
         $cmp36$i = ($sub33$i|0)==(0);
         if ($cmp36$i) {
          $rsize$49$i = 0;$t$48$i = $t$0$i151;$v$410$i = $t$0$i151;
          label = 90;
          break L123;
         } else {
          $rsize$1$i = $sub33$i;$v$1$i = $t$0$i151;
         }
        } else {
         $rsize$1$i = $rsize$0$i152;$v$1$i = $v$0$i153;
        }
        $arrayidx40$i = ((($t$0$i151)) + 20|0);
        $50 = load4($arrayidx40$i);
        $shr41$i = $sizebits$0$i >>> 31;
        $arrayidx44$i = (((($t$0$i151)) + 16|0) + ($shr41$i<<2)|0);
        $51 = load4($arrayidx44$i);
        $cmp45$i155 = ($50|0)==(0|0);
        $cmp46$i = ($50|0)==($51|0);
        $or$cond1$i = $cmp45$i155 | $cmp46$i;
        $rst$1$i = $or$cond1$i ? $rst$0$i : $50;
        $cmp49$i = ($51|0)==(0|0);
        $52 = $cmp49$i&1;
        $shl52$i = $52 ^ 1;
        $sizebits$0$shl52$i = $sizebits$0$i << $shl52$i;
        if ($cmp49$i) {
         $rsize$3$i = $rsize$1$i;$t$2$i = $rst$1$i;$v$3$i = $v$1$i;
         label = 86;
         break;
        } else {
         $rsize$0$i152 = $rsize$1$i;$rst$0$i = $rst$1$i;$sizebits$0$i = $sizebits$0$shl52$i;$t$0$i151 = $51;$v$0$i153 = $v$1$i;
        }
       }
      }
     } while(0);
     if ((label|0) == 86) {
      $cmp55$i = ($t$2$i|0)==(0|0);
      $cmp57$i = ($v$3$i|0)==(0|0);
      $or$cond$i = $cmp55$i & $cmp57$i;
      if ($or$cond$i) {
       $shl60$i = 2 << $idx$0$i;
       $sub63$i = (0 - ($shl60$i))|0;
       $or$i = $shl60$i | $sub63$i;
       $and64$i = $47 & $or$i;
       $cmp65$i = ($and64$i|0)==(0);
       if ($cmp65$i) {
        $nb$0 = $and145;
        break;
       }
       $sub67$i = (0 - ($and64$i))|0;
       $and68$i = $and64$i & $sub67$i;
       $sub70$i = (($and68$i) + -1)|0;
       $shr72$i = $sub70$i >>> 12;
       $and73$i = $shr72$i & 16;
       $shr75$i = $sub70$i >>> $and73$i;
       $shr76$i = $shr75$i >>> 5;
       $and77$i = $shr76$i & 8;
       $add78$i = $and77$i | $and73$i;
       $shr79$i = $shr75$i >>> $and77$i;
       $shr80$i = $shr79$i >>> 2;
       $and81$i = $shr80$i & 4;
       $add82$i = $add78$i | $and81$i;
       $shr83$i = $shr79$i >>> $and81$i;
       $shr84$i = $shr83$i >>> 1;
       $and85$i = $shr84$i & 2;
       $add86$i = $add82$i | $and85$i;
       $shr87$i = $shr83$i >>> $and85$i;
       $shr88$i = $shr87$i >>> 1;
       $and89$i = $shr88$i & 1;
       $add90$i = $add86$i | $and89$i;
       $shr91$i = $shr87$i >>> $and89$i;
       $add92$i = (($add90$i) + ($shr91$i))|0;
       $arrayidx94$i156 = (8748 + ($add92$i<<2)|0);
       $53 = load4($arrayidx94$i156);
       $t$4$ph$i = $53;
      } else {
       $t$4$ph$i = $t$2$i;
      }
      $cmp977$i = ($t$4$ph$i|0)==(0|0);
      if ($cmp977$i) {
       $rsize$4$lcssa$i = $rsize$3$i;$v$4$lcssa$i = $v$3$i;
      } else {
       $rsize$49$i = $rsize$3$i;$t$48$i = $t$4$ph$i;$v$410$i = $v$3$i;
       label = 90;
      }
     }
     if ((label|0) == 90) {
      while(1) {
       label = 0;
       $head99$i = ((($t$48$i)) + 4|0);
       $54 = load4($head99$i);
       $and100$i = $54 & -8;
       $sub101$i = (($and100$i) - ($and145))|0;
       $cmp102$i = ($sub101$i>>>0)<($rsize$49$i>>>0);
       $sub101$rsize$4$i = $cmp102$i ? $sub101$i : $rsize$49$i;
       $t$4$v$4$i = $cmp102$i ? $t$48$i : $v$410$i;
       $arrayidx106$i = ((($t$48$i)) + 16|0);
       $55 = load4($arrayidx106$i);
       $cmp107$i157 = ($55|0)==(0|0);
       if (!($cmp107$i157)) {
        $rsize$49$i = $sub101$rsize$4$i;$t$48$i = $55;$v$410$i = $t$4$v$4$i;
        label = 90;
        continue;
       }
       $arrayidx113$i159 = ((($t$48$i)) + 20|0);
       $56 = load4($arrayidx113$i159);
       $cmp97$i = ($56|0)==(0|0);
       if ($cmp97$i) {
        $rsize$4$lcssa$i = $sub101$rsize$4$i;$v$4$lcssa$i = $t$4$v$4$i;
        break;
       } else {
        $rsize$49$i = $sub101$rsize$4$i;$t$48$i = $56;$v$410$i = $t$4$v$4$i;
        label = 90;
       }
      }
     }
     $cmp116$i = ($v$4$lcssa$i|0)==(0|0);
     if ($cmp116$i) {
      $nb$0 = $and145;
     } else {
      $57 = load4((8452));
      $sub118$i = (($57) - ($and145))|0;
      $cmp119$i = ($rsize$4$lcssa$i>>>0)<($sub118$i>>>0);
      if ($cmp119$i) {
       $58 = load4((8460));
       $cmp121$i = ($v$4$lcssa$i>>>0)<($58>>>0);
       if ($cmp121$i) {
        _abort();
        // unreachable;
       }
       $add$ptr$i161 = (($v$4$lcssa$i) + ($and145)|0);
       $cmp123$i = ($v$4$lcssa$i>>>0)<($add$ptr$i161>>>0);
       if (!($cmp123$i)) {
        _abort();
        // unreachable;
       }
       $parent$i162 = ((($v$4$lcssa$i)) + 24|0);
       $59 = load4($parent$i162);
       $bk$i163 = ((($v$4$lcssa$i)) + 12|0);
       $60 = load4($bk$i163);
       $cmp128$i = ($60|0)==($v$4$lcssa$i|0);
       do {
        if ($cmp128$i) {
         $arrayidx151$i = ((($v$4$lcssa$i)) + 20|0);
         $64 = load4($arrayidx151$i);
         $cmp152$i = ($64|0)==(0|0);
         if ($cmp152$i) {
          $arrayidx155$i = ((($v$4$lcssa$i)) + 16|0);
          $65 = load4($arrayidx155$i);
          $cmp156$i = ($65|0)==(0|0);
          if ($cmp156$i) {
           $R$3$i171 = 0;
           break;
          } else {
           $R$1$i168 = $65;$RP$1$i167 = $arrayidx155$i;
          }
         } else {
          $R$1$i168 = $64;$RP$1$i167 = $arrayidx151$i;
         }
         while(1) {
          $arrayidx161$i = ((($R$1$i168)) + 20|0);
          $66 = load4($arrayidx161$i);
          $cmp162$i = ($66|0)==(0|0);
          if (!($cmp162$i)) {
           $R$1$i168 = $66;$RP$1$i167 = $arrayidx161$i;
           continue;
          }
          $arrayidx165$i169 = ((($R$1$i168)) + 16|0);
          $67 = load4($arrayidx165$i169);
          $cmp166$i = ($67|0)==(0|0);
          if ($cmp166$i) {
           break;
          } else {
           $R$1$i168 = $67;$RP$1$i167 = $arrayidx165$i169;
          }
         }
         $cmp171$i = ($RP$1$i167>>>0)<($58>>>0);
         if ($cmp171$i) {
          _abort();
          // unreachable;
         } else {
          store4($RP$1$i167,0);
          $R$3$i171 = $R$1$i168;
          break;
         }
        } else {
         $fd$i164 = ((($v$4$lcssa$i)) + 8|0);
         $61 = load4($fd$i164);
         $cmp133$i = ($61>>>0)<($58>>>0);
         if ($cmp133$i) {
          _abort();
          // unreachable;
         }
         $bk136$i = ((($61)) + 12|0);
         $62 = load4($bk136$i);
         $cmp137$i = ($62|0)==($v$4$lcssa$i|0);
         if (!($cmp137$i)) {
          _abort();
          // unreachable;
         }
         $fd139$i = ((($60)) + 8|0);
         $63 = load4($fd139$i);
         $cmp140$i = ($63|0)==($v$4$lcssa$i|0);
         if ($cmp140$i) {
          store4($bk136$i,$60);
          store4($fd139$i,$61);
          $R$3$i171 = $60;
          break;
         } else {
          _abort();
          // unreachable;
         }
        }
       } while(0);
       $cmp180$i = ($59|0)==(0|0);
       do {
        if ($cmp180$i) {
         $81 = $47;
        } else {
         $index$i172 = ((($v$4$lcssa$i)) + 28|0);
         $68 = load4($index$i172);
         $arrayidx184$i = (8748 + ($68<<2)|0);
         $69 = load4($arrayidx184$i);
         $cmp185$i = ($v$4$lcssa$i|0)==($69|0);
         if ($cmp185$i) {
          store4($arrayidx184$i,$R$3$i171);
          $cond3$i = ($R$3$i171|0)==(0|0);
          if ($cond3$i) {
           $shl192$i = 1 << $68;
           $neg$i173 = $shl192$i ^ -1;
           $and194$i = $47 & $neg$i173;
           store4((8448),$and194$i);
           $81 = $and194$i;
           break;
          }
         } else {
          $70 = load4((8460));
          $cmp198$i = ($59>>>0)<($70>>>0);
          if ($cmp198$i) {
           _abort();
           // unreachable;
          }
          $arrayidx204$i = ((($59)) + 16|0);
          $71 = load4($arrayidx204$i);
          $cmp205$i = ($71|0)==($v$4$lcssa$i|0);
          if ($cmp205$i) {
           store4($arrayidx204$i,$R$3$i171);
          } else {
           $arrayidx212$i = ((($59)) + 20|0);
           store4($arrayidx212$i,$R$3$i171);
          }
          $cmp217$i = ($R$3$i171|0)==(0|0);
          if ($cmp217$i) {
           $81 = $47;
           break;
          }
         }
         $72 = load4((8460));
         $cmp221$i = ($R$3$i171>>>0)<($72>>>0);
         if ($cmp221$i) {
          _abort();
          // unreachable;
         }
         $parent226$i = ((($R$3$i171)) + 24|0);
         store4($parent226$i,$59);
         $arrayidx228$i = ((($v$4$lcssa$i)) + 16|0);
         $73 = load4($arrayidx228$i);
         $cmp229$i = ($73|0)==(0|0);
         do {
          if (!($cmp229$i)) {
           $cmp233$i = ($73>>>0)<($72>>>0);
           if ($cmp233$i) {
            _abort();
            // unreachable;
           } else {
            $arrayidx239$i = ((($R$3$i171)) + 16|0);
            store4($arrayidx239$i,$73);
            $parent240$i = ((($73)) + 24|0);
            store4($parent240$i,$R$3$i171);
            break;
           }
          }
         } while(0);
         $arrayidx245$i = ((($v$4$lcssa$i)) + 20|0);
         $74 = load4($arrayidx245$i);
         $cmp246$i = ($74|0)==(0|0);
         if ($cmp246$i) {
          $81 = $47;
         } else {
          $75 = load4((8460));
          $cmp250$i = ($74>>>0)<($75>>>0);
          if ($cmp250$i) {
           _abort();
           // unreachable;
          } else {
           $arrayidx256$i = ((($R$3$i171)) + 20|0);
           store4($arrayidx256$i,$74);
           $parent257$i = ((($74)) + 24|0);
           store4($parent257$i,$R$3$i171);
           $81 = $47;
           break;
          }
         }
        }
       } while(0);
       $cmp265$i = ($rsize$4$lcssa$i>>>0)<(16);
       do {
        if ($cmp265$i) {
         $add268$i = (($rsize$4$lcssa$i) + ($and145))|0;
         $or270$i = $add268$i | 3;
         $head271$i = ((($v$4$lcssa$i)) + 4|0);
         store4($head271$i,$or270$i);
         $add$ptr273$i = (($v$4$lcssa$i) + ($add268$i)|0);
         $head274$i = ((($add$ptr273$i)) + 4|0);
         $76 = load4($head274$i);
         $or275$i = $76 | 1;
         store4($head274$i,$or275$i);
        } else {
         $or278$i = $and145 | 3;
         $head279$i = ((($v$4$lcssa$i)) + 4|0);
         store4($head279$i,$or278$i);
         $or280$i = $rsize$4$lcssa$i | 1;
         $head281$i = ((($add$ptr$i161)) + 4|0);
         store4($head281$i,$or280$i);
         $add$ptr282$i = (($add$ptr$i161) + ($rsize$4$lcssa$i)|0);
         store4($add$ptr282$i,$rsize$4$lcssa$i);
         $shr283$i = $rsize$4$lcssa$i >>> 3;
         $cmp284$i = ($rsize$4$lcssa$i>>>0)<(256);
         if ($cmp284$i) {
          $shl288$i = $shr283$i << 1;
          $arrayidx289$i = (8484 + ($shl288$i<<2)|0);
          $77 = load4(8444);
          $shl291$i = 1 << $shr283$i;
          $and292$i = $77 & $shl291$i;
          $tobool293$i = ($and292$i|0)==(0);
          if ($tobool293$i) {
           $or297$i = $77 | $shl291$i;
           store4(8444,$or297$i);
           $$pre$i177 = ((($arrayidx289$i)) + 8|0);
           $$pre$phi$i178Z2D = $$pre$i177;$F290$0$i = $arrayidx289$i;
          } else {
           $78 = ((($arrayidx289$i)) + 8|0);
           $79 = load4($78);
           $80 = load4((8460));
           $cmp301$i = ($79>>>0)<($80>>>0);
           if ($cmp301$i) {
            _abort();
            // unreachable;
           } else {
            $$pre$phi$i178Z2D = $78;$F290$0$i = $79;
           }
          }
          store4($$pre$phi$i178Z2D,$add$ptr$i161);
          $bk311$i = ((($F290$0$i)) + 12|0);
          store4($bk311$i,$add$ptr$i161);
          $fd312$i = ((($add$ptr$i161)) + 8|0);
          store4($fd312$i,$F290$0$i);
          $bk313$i = ((($add$ptr$i161)) + 12|0);
          store4($bk313$i,$arrayidx289$i);
          break;
         }
         $shr318$i = $rsize$4$lcssa$i >>> 8;
         $cmp319$i = ($shr318$i|0)==(0);
         if ($cmp319$i) {
          $I316$0$i = 0;
         } else {
          $cmp323$i = ($rsize$4$lcssa$i>>>0)>(16777215);
          if ($cmp323$i) {
           $I316$0$i = 31;
          } else {
           $sub329$i = (($shr318$i) + 1048320)|0;
           $shr330$i = $sub329$i >>> 16;
           $and331$i = $shr330$i & 8;
           $shl333$i = $shr318$i << $and331$i;
           $sub334$i = (($shl333$i) + 520192)|0;
           $shr335$i = $sub334$i >>> 16;
           $and336$i = $shr335$i & 4;
           $add337$i = $and336$i | $and331$i;
           $shl338$i = $shl333$i << $and336$i;
           $sub339$i = (($shl338$i) + 245760)|0;
           $shr340$i = $sub339$i >>> 16;
           $and341$i = $shr340$i & 2;
           $add342$i = $add337$i | $and341$i;
           $sub343$i = (14 - ($add342$i))|0;
           $shl344$i = $shl338$i << $and341$i;
           $shr345$i = $shl344$i >>> 15;
           $add346$i = (($sub343$i) + ($shr345$i))|0;
           $shl347$i = $add346$i << 1;
           $add348$i = (($add346$i) + 7)|0;
           $shr349$i = $rsize$4$lcssa$i >>> $add348$i;
           $and350$i = $shr349$i & 1;
           $add351$i = $and350$i | $shl347$i;
           $I316$0$i = $add351$i;
          }
         }
         $arrayidx355$i = (8748 + ($I316$0$i<<2)|0);
         $index356$i = ((($add$ptr$i161)) + 28|0);
         store4($index356$i,$I316$0$i);
         $child357$i = ((($add$ptr$i161)) + 16|0);
         $arrayidx358$i = ((($child357$i)) + 4|0);
         store4($arrayidx358$i,0);
         store4($child357$i,0);
         $shl362$i = 1 << $I316$0$i;
         $and363$i = $81 & $shl362$i;
         $tobool364$i = ($and363$i|0)==(0);
         if ($tobool364$i) {
          $or368$i = $81 | $shl362$i;
          store4((8448),$or368$i);
          store4($arrayidx355$i,$add$ptr$i161);
          $parent369$i = ((($add$ptr$i161)) + 24|0);
          store4($parent369$i,$arrayidx355$i);
          $bk370$i = ((($add$ptr$i161)) + 12|0);
          store4($bk370$i,$add$ptr$i161);
          $fd371$i = ((($add$ptr$i161)) + 8|0);
          store4($fd371$i,$add$ptr$i161);
          break;
         }
         $82 = load4($arrayidx355$i);
         $cmp374$i = ($I316$0$i|0)==(31);
         $shr378$i = $I316$0$i >>> 1;
         $sub381$i = (25 - ($shr378$i))|0;
         $cond383$i = $cmp374$i ? 0 : $sub381$i;
         $shl384$i = $rsize$4$lcssa$i << $cond383$i;
         $K373$0$i = $shl384$i;$T$0$i = $82;
         while(1) {
          $head386$i = ((($T$0$i)) + 4|0);
          $83 = load4($head386$i);
          $and387$i = $83 & -8;
          $cmp388$i = ($and387$i|0)==($rsize$4$lcssa$i|0);
          if ($cmp388$i) {
           label = 148;
           break;
          }
          $shr391$i = $K373$0$i >>> 31;
          $arrayidx394$i = (((($T$0$i)) + 16|0) + ($shr391$i<<2)|0);
          $shl395$i = $K373$0$i << 1;
          $84 = load4($arrayidx394$i);
          $cmp396$i = ($84|0)==(0|0);
          if ($cmp396$i) {
           label = 145;
           break;
          } else {
           $K373$0$i = $shl395$i;$T$0$i = $84;
          }
         }
         if ((label|0) == 145) {
          $85 = load4((8460));
          $cmp401$i = ($arrayidx394$i>>>0)<($85>>>0);
          if ($cmp401$i) {
           _abort();
           // unreachable;
          } else {
           store4($arrayidx394$i,$add$ptr$i161);
           $parent406$i = ((($add$ptr$i161)) + 24|0);
           store4($parent406$i,$T$0$i);
           $bk407$i = ((($add$ptr$i161)) + 12|0);
           store4($bk407$i,$add$ptr$i161);
           $fd408$i = ((($add$ptr$i161)) + 8|0);
           store4($fd408$i,$add$ptr$i161);
           break;
          }
         }
         else if ((label|0) == 148) {
          $fd416$i = ((($T$0$i)) + 8|0);
          $86 = load4($fd416$i);
          $87 = load4((8460));
          $cmp422$i = ($86>>>0)>=($87>>>0);
          $not$cmp418$i = ($T$0$i>>>0)>=($87>>>0);
          $88 = $cmp422$i & $not$cmp418$i;
          if ($88) {
           $bk429$i = ((($86)) + 12|0);
           store4($bk429$i,$add$ptr$i161);
           store4($fd416$i,$add$ptr$i161);
           $fd431$i = ((($add$ptr$i161)) + 8|0);
           store4($fd431$i,$86);
           $bk432$i = ((($add$ptr$i161)) + 12|0);
           store4($bk432$i,$T$0$i);
           $parent433$i = ((($add$ptr$i161)) + 24|0);
           store4($parent433$i,0);
           break;
          } else {
           _abort();
           // unreachable;
          }
         }
        }
       } while(0);
       $add$ptr441$i = ((($v$4$lcssa$i)) + 8|0);
       $retval$0 = $add$ptr441$i;
       STACKTOP = sp;return ($retval$0|0);
      } else {
       $nb$0 = $and145;
      }
     }
    }
   }
  }
 } while(0);
 $89 = load4((8452));
 $cmp156 = ($89>>>0)<($nb$0>>>0);
 if (!($cmp156)) {
  $sub160 = (($89) - ($nb$0))|0;
  $90 = load4((8464));
  $cmp162 = ($sub160>>>0)>(15);
  if ($cmp162) {
   $add$ptr166 = (($90) + ($nb$0)|0);
   store4((8464),$add$ptr166);
   store4((8452),$sub160);
   $or167 = $sub160 | 1;
   $head168 = ((($add$ptr166)) + 4|0);
   store4($head168,$or167);
   $add$ptr169 = (($add$ptr166) + ($sub160)|0);
   store4($add$ptr169,$sub160);
   $or172 = $nb$0 | 3;
   $head173 = ((($90)) + 4|0);
   store4($head173,$or172);
  } else {
   store4((8452),0);
   store4((8464),0);
   $or176 = $89 | 3;
   $head177 = ((($90)) + 4|0);
   store4($head177,$or176);
   $add$ptr178 = (($90) + ($89)|0);
   $head179 = ((($add$ptr178)) + 4|0);
   $91 = load4($head179);
   $or180 = $91 | 1;
   store4($head179,$or180);
  }
  $add$ptr182 = ((($90)) + 8|0);
  $retval$0 = $add$ptr182;
  STACKTOP = sp;return ($retval$0|0);
 }
 $92 = load4((8456));
 $cmp186 = ($92>>>0)>($nb$0>>>0);
 if ($cmp186) {
  $sub190 = (($92) - ($nb$0))|0;
  store4((8456),$sub190);
  $93 = load4((8468));
  $add$ptr193 = (($93) + ($nb$0)|0);
  store4((8468),$add$ptr193);
  $or194 = $sub190 | 1;
  $head195 = ((($add$ptr193)) + 4|0);
  store4($head195,$or194);
  $or197 = $nb$0 | 3;
  $head198 = ((($93)) + 4|0);
  store4($head198,$or197);
  $add$ptr199 = ((($93)) + 8|0);
  $retval$0 = $add$ptr199;
  STACKTOP = sp;return ($retval$0|0);
 }
 $94 = load4(8916);
 $cmp$i179 = ($94|0)==(0);
 if ($cmp$i179) {
  store4((8924),4096);
  store4((8920),4096);
  store4((8928),-1);
  store4((8932),-1);
  store4((8936),0);
  store4((8888),0);
  $95 = $magic$i$i;
  $xor$i$i = $95 & -16;
  $and6$i$i = $xor$i$i ^ 1431655768;
  store4($magic$i$i,$and6$i$i);
  store4(8916,$and6$i$i);
  $96 = 4096;
 } else {
  $$pre$i180 = load4((8924));
  $96 = $$pre$i180;
 }
 $add$i181 = (($nb$0) + 48)|0;
 $sub$i182 = (($nb$0) + 47)|0;
 $add9$i = (($96) + ($sub$i182))|0;
 $neg$i183 = (0 - ($96))|0;
 $and11$i = $add9$i & $neg$i183;
 $cmp12$i = ($and11$i>>>0)>($nb$0>>>0);
 if (!($cmp12$i)) {
  $retval$0 = 0;
  STACKTOP = sp;return ($retval$0|0);
 }
 $97 = load4((8884));
 $cmp15$i = ($97|0)==(0);
 if (!($cmp15$i)) {
  $98 = load4((8876));
  $add17$i184 = (($98) + ($and11$i))|0;
  $cmp19$i = ($add17$i184>>>0)<=($98>>>0);
  $cmp21$i = ($add17$i184>>>0)>($97>>>0);
  $or$cond1$i185 = $cmp19$i | $cmp21$i;
  if ($or$cond1$i185) {
   $retval$0 = 0;
   STACKTOP = sp;return ($retval$0|0);
  }
 }
 $99 = load4((8888));
 $and29$i = $99 & 4;
 $tobool30$i = ($and29$i|0)==(0);
 L255: do {
  if ($tobool30$i) {
   $100 = load4((8468));
   $cmp32$i186 = ($100|0)==(0|0);
   L257: do {
    if ($cmp32$i186) {
     label = 172;
    } else {
     $sp$0$i$i = (8892);
     while(1) {
      $101 = load4($sp$0$i$i);
      $cmp$i11$i = ($101>>>0)>($100>>>0);
      if (!($cmp$i11$i)) {
       $size$i$i = ((($sp$0$i$i)) + 4|0);
       $102 = load4($size$i$i);
       $add$ptr$i$i = (($101) + ($102)|0);
       $cmp2$i$i = ($add$ptr$i$i>>>0)>($100>>>0);
       if ($cmp2$i$i) {
        break;
       }
      }
      $next$i$i = ((($sp$0$i$i)) + 8|0);
      $103 = load4($next$i$i);
      $cmp3$i$i = ($103|0)==(0|0);
      if ($cmp3$i$i) {
       label = 172;
       break L257;
      } else {
       $sp$0$i$i = $103;
      }
     }
     $add77$i = (($add9$i) - ($92))|0;
     $and80$i = $add77$i & $neg$i183;
     $cmp81$i192 = ($and80$i>>>0)<(2147483647);
     if ($cmp81$i192) {
      $call83$i = (_sbrk(($and80$i|0))|0);
      $108 = load4($sp$0$i$i);
      $109 = load4($size$i$i);
      $add$ptr$i194 = (($108) + ($109)|0);
      $cmp85$i = ($call83$i|0)==($add$ptr$i194|0);
      if ($cmp85$i) {
       $cmp89$i = ($call83$i|0)==((-1)|0);
       if (!($cmp89$i)) {
        $tbase$793$i = $call83$i;$tsize$792$i = $and80$i;
        label = 190;
        break L255;
       }
      } else {
       $br$2$ph$i = $call83$i;$ssize$2$ph$i = $and80$i;
       label = 180;
      }
     }
    }
   } while(0);
   do {
    if ((label|0) == 172) {
     $call37$i = (_sbrk(0)|0);
     $cmp38$i = ($call37$i|0)==((-1)|0);
     if (!($cmp38$i)) {
      $104 = $call37$i;
      $105 = load4((8920));
      $sub41$i = (($105) + -1)|0;
      $and42$i = $sub41$i & $104;
      $cmp43$i = ($and42$i|0)==(0);
      $add46$i = (($sub41$i) + ($104))|0;
      $neg48$i = (0 - ($105))|0;
      $and49$i = $add46$i & $neg48$i;
      $sub50$i = (($and49$i) - ($104))|0;
      $add51$i = $cmp43$i ? 0 : $sub50$i;
      $and11$add51$i = (($add51$i) + ($and11$i))|0;
      $106 = load4((8876));
      $add54$i = (($and11$add51$i) + ($106))|0;
      $cmp55$i187 = ($and11$add51$i>>>0)>($nb$0>>>0);
      $cmp57$i188 = ($and11$add51$i>>>0)<(2147483647);
      $or$cond$i189 = $cmp55$i187 & $cmp57$i188;
      if ($or$cond$i189) {
       $107 = load4((8884));
       $cmp60$i = ($107|0)==(0);
       if (!($cmp60$i)) {
        $cmp63$i = ($add54$i>>>0)<=($106>>>0);
        $cmp66$i191 = ($add54$i>>>0)>($107>>>0);
        $or$cond2$i = $cmp63$i | $cmp66$i191;
        if ($or$cond2$i) {
         break;
        }
       }
       $call68$i = (_sbrk(($and11$add51$i|0))|0);
       $cmp69$i = ($call68$i|0)==($call37$i|0);
       if ($cmp69$i) {
        $tbase$793$i = $call37$i;$tsize$792$i = $and11$add51$i;
        label = 190;
        break L255;
       } else {
        $br$2$ph$i = $call68$i;$ssize$2$ph$i = $and11$add51$i;
        label = 180;
       }
      }
     }
    }
   } while(0);
   L274: do {
    if ((label|0) == 180) {
     $sub112$i = (0 - ($ssize$2$ph$i))|0;
     $cmp91$i = ($br$2$ph$i|0)!=((-1)|0);
     $cmp93$i = ($ssize$2$ph$i>>>0)<(2147483647);
     $or$cond5$i = $cmp93$i & $cmp91$i;
     $cmp96$i = ($add$i181>>>0)>($ssize$2$ph$i>>>0);
     $or$cond3$i = $cmp96$i & $or$cond5$i;
     do {
      if ($or$cond3$i) {
       $110 = load4((8924));
       $sub99$i = (($sub$i182) - ($ssize$2$ph$i))|0;
       $add101$i = (($sub99$i) + ($110))|0;
       $neg103$i = (0 - ($110))|0;
       $and104$i = $add101$i & $neg103$i;
       $cmp105$i = ($and104$i>>>0)<(2147483647);
       if ($cmp105$i) {
        $call107$i = (_sbrk(($and104$i|0))|0);
        $cmp108$i = ($call107$i|0)==((-1)|0);
        if ($cmp108$i) {
         (_sbrk(($sub112$i|0))|0);
         break L274;
        } else {
         $add110$i = (($and104$i) + ($ssize$2$ph$i))|0;
         $ssize$5$i = $add110$i;
         break;
        }
       } else {
        $ssize$5$i = $ssize$2$ph$i;
       }
      } else {
       $ssize$5$i = $ssize$2$ph$i;
      }
     } while(0);
     $cmp118$i = ($br$2$ph$i|0)==((-1)|0);
     if (!($cmp118$i)) {
      $tbase$793$i = $br$2$ph$i;$tsize$792$i = $ssize$5$i;
      label = 190;
      break L255;
     }
    }
   } while(0);
   $111 = load4((8888));
   $or$i196 = $111 | 4;
   store4((8888),$or$i196);
   label = 187;
  } else {
   label = 187;
  }
 } while(0);
 if ((label|0) == 187) {
  $cmp127$i = ($and11$i>>>0)<(2147483647);
  if ($cmp127$i) {
   $call131$i = (_sbrk(($and11$i|0))|0);
   $call132$i = (_sbrk(0)|0);
   $cmp133$i197 = ($call131$i|0)!=((-1)|0);
   $cmp135$i = ($call132$i|0)!=((-1)|0);
   $or$cond4$i = $cmp133$i197 & $cmp135$i;
   $cmp137$i198 = ($call131$i>>>0)<($call132$i>>>0);
   $or$cond7$i = $cmp137$i198 & $or$cond4$i;
   if ($or$cond7$i) {
    $sub$ptr$lhs$cast$i = $call132$i;
    $sub$ptr$rhs$cast$i = $call131$i;
    $sub$ptr$sub$i = (($sub$ptr$lhs$cast$i) - ($sub$ptr$rhs$cast$i))|0;
    $add140$i = (($nb$0) + 40)|0;
    $cmp141$not$i = ($sub$ptr$sub$i>>>0)>($add140$i>>>0);
    if ($cmp141$not$i) {
     $tbase$793$i = $call131$i;$tsize$792$i = $sub$ptr$sub$i;
     label = 190;
    }
   }
  }
 }
 if ((label|0) == 190) {
  $112 = load4((8876));
  $add150$i = (($112) + ($tsize$792$i))|0;
  store4((8876),$add150$i);
  $113 = load4((8880));
  $cmp151$i = ($add150$i>>>0)>($113>>>0);
  if ($cmp151$i) {
   store4((8880),$add150$i);
  }
  $114 = load4((8468));
  $cmp157$i = ($114|0)==(0|0);
  do {
   if ($cmp157$i) {
    $115 = load4((8460));
    $cmp159$i200 = ($115|0)==(0|0);
    $cmp162$i201 = ($tbase$793$i>>>0)<($115>>>0);
    $or$cond8$i = $cmp159$i200 | $cmp162$i201;
    if ($or$cond8$i) {
     store4((8460),$tbase$793$i);
    }
    store4((8892),$tbase$793$i);
    store4((8896),$tsize$792$i);
    store4((8904),0);
    $116 = load4(8916);
    store4((8480),$116);
    store4((8476),-1);
    $i$01$i$i = 0;
    while(1) {
     $shl$i13$i = $i$01$i$i << 1;
     $arrayidx$i14$i = (8484 + ($shl$i13$i<<2)|0);
     $117 = ((($arrayidx$i14$i)) + 12|0);
     store4($117,$arrayidx$i14$i);
     $118 = ((($arrayidx$i14$i)) + 8|0);
     store4($118,$arrayidx$i14$i);
     $inc$i$i = (($i$01$i$i) + 1)|0;
     $exitcond$i$i = ($inc$i$i|0)==(32);
     if ($exitcond$i$i) {
      break;
     } else {
      $i$01$i$i = $inc$i$i;
     }
    }
    $sub172$i = (($tsize$792$i) + -40)|0;
    $add$ptr$i16$i = ((($tbase$793$i)) + 8|0);
    $119 = $add$ptr$i16$i;
    $and$i17$i = $119 & 7;
    $cmp$i18$i = ($and$i17$i|0)==(0);
    $120 = (0 - ($119))|0;
    $and3$i$i = $120 & 7;
    $cond$i19$i = $cmp$i18$i ? 0 : $and3$i$i;
    $add$ptr4$i$i = (($tbase$793$i) + ($cond$i19$i)|0);
    $sub5$i$i = (($sub172$i) - ($cond$i19$i))|0;
    store4((8468),$add$ptr4$i$i);
    store4((8456),$sub5$i$i);
    $or$i$i = $sub5$i$i | 1;
    $head$i20$i = ((($add$ptr4$i$i)) + 4|0);
    store4($head$i20$i,$or$i$i);
    $add$ptr6$i$i = (($add$ptr4$i$i) + ($sub5$i$i)|0);
    $head7$i$i = ((($add$ptr6$i$i)) + 4|0);
    store4($head7$i$i,40);
    $121 = load4((8932));
    store4((8472),$121);
   } else {
    $sp$0104$i = (8892);
    while(1) {
     $122 = load4($sp$0104$i);
     $size188$i = ((($sp$0104$i)) + 4|0);
     $123 = load4($size188$i);
     $add$ptr189$i = (($122) + ($123)|0);
     $cmp190$i = ($tbase$793$i|0)==($add$ptr189$i|0);
     if ($cmp190$i) {
      label = 200;
      break;
     }
     $next$i = ((($sp$0104$i)) + 8|0);
     $124 = load4($next$i);
     $cmp186$i = ($124|0)==(0|0);
     if ($cmp186$i) {
      break;
     } else {
      $sp$0104$i = $124;
     }
    }
    if ((label|0) == 200) {
     $sflags193$i = ((($sp$0104$i)) + 12|0);
     $125 = load4($sflags193$i);
     $and194$i205 = $125 & 8;
     $tobool195$i = ($and194$i205|0)==(0);
     if ($tobool195$i) {
      $cmp203$i = ($114>>>0)>=($122>>>0);
      $cmp209$i = ($114>>>0)<($tbase$793$i>>>0);
      $or$cond95$i = $cmp209$i & $cmp203$i;
      if ($or$cond95$i) {
       $add212$i = (($123) + ($tsize$792$i))|0;
       store4($size188$i,$add212$i);
       $126 = load4((8456));
       $add$ptr$i49$i = ((($114)) + 8|0);
       $127 = $add$ptr$i49$i;
       $and$i50$i = $127 & 7;
       $cmp$i51$i = ($and$i50$i|0)==(0);
       $128 = (0 - ($127))|0;
       $and3$i52$i = $128 & 7;
       $cond$i53$i = $cmp$i51$i ? 0 : $and3$i52$i;
       $add$ptr4$i54$i = (($114) + ($cond$i53$i)|0);
       $add215$i = (($tsize$792$i) - ($cond$i53$i))|0;
       $sub5$i55$i = (($add215$i) + ($126))|0;
       store4((8468),$add$ptr4$i54$i);
       store4((8456),$sub5$i55$i);
       $or$i56$i = $sub5$i55$i | 1;
       $head$i57$i = ((($add$ptr4$i54$i)) + 4|0);
       store4($head$i57$i,$or$i56$i);
       $add$ptr6$i58$i = (($add$ptr4$i54$i) + ($sub5$i55$i)|0);
       $head7$i59$i = ((($add$ptr6$i58$i)) + 4|0);
       store4($head7$i59$i,40);
       $129 = load4((8932));
       store4((8472),$129);
       break;
      }
     }
    }
    $130 = load4((8460));
    $cmp218$i = ($tbase$793$i>>>0)<($130>>>0);
    if ($cmp218$i) {
     store4((8460),$tbase$793$i);
     $145 = $tbase$793$i;
    } else {
     $145 = $130;
    }
    $add$ptr227$i = (($tbase$793$i) + ($tsize$792$i)|0);
    $sp$1103$i = (8892);
    while(1) {
     $131 = load4($sp$1103$i);
     $cmp228$i = ($131|0)==($add$ptr227$i|0);
     if ($cmp228$i) {
      label = 208;
      break;
     }
     $next231$i = ((($sp$1103$i)) + 8|0);
     $132 = load4($next231$i);
     $cmp224$i = ($132|0)==(0|0);
     if ($cmp224$i) {
      $sp$0$i$i$i = (8892);
      break;
     } else {
      $sp$1103$i = $132;
     }
    }
    if ((label|0) == 208) {
     $sflags235$i = ((($sp$1103$i)) + 12|0);
     $133 = load4($sflags235$i);
     $and236$i = $133 & 8;
     $tobool237$i = ($and236$i|0)==(0);
     if ($tobool237$i) {
      store4($sp$1103$i,$tbase$793$i);
      $size245$i = ((($sp$1103$i)) + 4|0);
      $134 = load4($size245$i);
      $add246$i = (($134) + ($tsize$792$i))|0;
      store4($size245$i,$add246$i);
      $add$ptr$i21$i = ((($tbase$793$i)) + 8|0);
      $135 = $add$ptr$i21$i;
      $and$i22$i = $135 & 7;
      $cmp$i23$i = ($and$i22$i|0)==(0);
      $136 = (0 - ($135))|0;
      $and3$i24$i = $136 & 7;
      $cond$i25$i = $cmp$i23$i ? 0 : $and3$i24$i;
      $add$ptr4$i26$i = (($tbase$793$i) + ($cond$i25$i)|0);
      $add$ptr5$i$i = ((($add$ptr227$i)) + 8|0);
      $137 = $add$ptr5$i$i;
      $and6$i27$i = $137 & 7;
      $cmp7$i$i = ($and6$i27$i|0)==(0);
      $138 = (0 - ($137))|0;
      $and13$i$i = $138 & 7;
      $cond15$i$i = $cmp7$i$i ? 0 : $and13$i$i;
      $add$ptr16$i$i = (($add$ptr227$i) + ($cond15$i$i)|0);
      $sub$ptr$lhs$cast$i28$i = $add$ptr16$i$i;
      $sub$ptr$rhs$cast$i29$i = $add$ptr4$i26$i;
      $sub$ptr$sub$i30$i = (($sub$ptr$lhs$cast$i28$i) - ($sub$ptr$rhs$cast$i29$i))|0;
      $add$ptr17$i$i = (($add$ptr4$i26$i) + ($nb$0)|0);
      $sub18$i$i = (($sub$ptr$sub$i30$i) - ($nb$0))|0;
      $or19$i$i = $nb$0 | 3;
      $head$i31$i = ((($add$ptr4$i26$i)) + 4|0);
      store4($head$i31$i,$or19$i$i);
      $cmp20$i$i = ($add$ptr16$i$i|0)==($114|0);
      do {
       if ($cmp20$i$i) {
        $139 = load4((8456));
        $add$i$i = (($139) + ($sub18$i$i))|0;
        store4((8456),$add$i$i);
        store4((8468),$add$ptr17$i$i);
        $or22$i$i = $add$i$i | 1;
        $head23$i$i = ((($add$ptr17$i$i)) + 4|0);
        store4($head23$i$i,$or22$i$i);
       } else {
        $140 = load4((8464));
        $cmp24$i$i = ($add$ptr16$i$i|0)==($140|0);
        if ($cmp24$i$i) {
         $141 = load4((8452));
         $add26$i$i = (($141) + ($sub18$i$i))|0;
         store4((8452),$add26$i$i);
         store4((8464),$add$ptr17$i$i);
         $or28$i$i = $add26$i$i | 1;
         $head29$i$i = ((($add$ptr17$i$i)) + 4|0);
         store4($head29$i$i,$or28$i$i);
         $add$ptr30$i$i = (($add$ptr17$i$i) + ($add26$i$i)|0);
         store4($add$ptr30$i$i,$add26$i$i);
         break;
        }
        $head32$i$i = ((($add$ptr16$i$i)) + 4|0);
        $142 = load4($head32$i$i);
        $and33$i$i = $142 & 3;
        $cmp34$i$i = ($and33$i$i|0)==(1);
        if ($cmp34$i$i) {
         $and37$i$i = $142 & -8;
         $shr$i34$i = $142 >>> 3;
         $cmp38$i$i = ($142>>>0)<(256);
         L326: do {
          if ($cmp38$i$i) {
           $fd$i$i = ((($add$ptr16$i$i)) + 8|0);
           $143 = load4($fd$i$i);
           $bk$i35$i = ((($add$ptr16$i$i)) + 12|0);
           $144 = load4($bk$i35$i);
           $shl$i36$i = $shr$i34$i << 1;
           $arrayidx$i37$i = (8484 + ($shl$i36$i<<2)|0);
           $cmp41$i$i = ($143|0)==($arrayidx$i37$i|0);
           do {
            if (!($cmp41$i$i)) {
             $cmp42$i$i = ($143>>>0)<($145>>>0);
             if ($cmp42$i$i) {
              _abort();
              // unreachable;
             }
             $bk43$i$i = ((($143)) + 12|0);
             $146 = load4($bk43$i$i);
             $cmp44$i$i = ($146|0)==($add$ptr16$i$i|0);
             if ($cmp44$i$i) {
              break;
             }
             _abort();
             // unreachable;
            }
           } while(0);
           $cmp46$i38$i = ($144|0)==($143|0);
           if ($cmp46$i38$i) {
            $shl48$i$i = 1 << $shr$i34$i;
            $neg$i$i = $shl48$i$i ^ -1;
            $147 = load4(8444);
            $and49$i$i = $147 & $neg$i$i;
            store4(8444,$and49$i$i);
            break;
           }
           $cmp54$i$i = ($144|0)==($arrayidx$i37$i|0);
           do {
            if ($cmp54$i$i) {
             $$pre5$i$i = ((($144)) + 8|0);
             $fd68$pre$phi$i$iZ2D = $$pre5$i$i;
            } else {
             $cmp57$i$i = ($144>>>0)<($145>>>0);
             if ($cmp57$i$i) {
              _abort();
              // unreachable;
             }
             $fd59$i$i = ((($144)) + 8|0);
             $148 = load4($fd59$i$i);
             $cmp60$i$i = ($148|0)==($add$ptr16$i$i|0);
             if ($cmp60$i$i) {
              $fd68$pre$phi$i$iZ2D = $fd59$i$i;
              break;
             }
             _abort();
             // unreachable;
            }
           } while(0);
           $bk67$i$i = ((($143)) + 12|0);
           store4($bk67$i$i,$144);
           store4($fd68$pre$phi$i$iZ2D,$143);
          } else {
           $parent$i40$i = ((($add$ptr16$i$i)) + 24|0);
           $149 = load4($parent$i40$i);
           $bk74$i$i = ((($add$ptr16$i$i)) + 12|0);
           $150 = load4($bk74$i$i);
           $cmp75$i$i = ($150|0)==($add$ptr16$i$i|0);
           do {
            if ($cmp75$i$i) {
             $child$i$i = ((($add$ptr16$i$i)) + 16|0);
             $arrayidx96$i$i = ((($child$i$i)) + 4|0);
             $154 = load4($arrayidx96$i$i);
             $cmp97$i$i = ($154|0)==(0|0);
             if ($cmp97$i$i) {
              $155 = load4($child$i$i);
              $cmp100$i$i = ($155|0)==(0|0);
              if ($cmp100$i$i) {
               $R$3$i$i = 0;
               break;
              } else {
               $R$1$i$i = $155;$RP$1$i$i = $child$i$i;
              }
             } else {
              $R$1$i$i = $154;$RP$1$i$i = $arrayidx96$i$i;
             }
             while(1) {
              $arrayidx103$i$i = ((($R$1$i$i)) + 20|0);
              $156 = load4($arrayidx103$i$i);
              $cmp104$i$i = ($156|0)==(0|0);
              if (!($cmp104$i$i)) {
               $R$1$i$i = $156;$RP$1$i$i = $arrayidx103$i$i;
               continue;
              }
              $arrayidx107$i$i = ((($R$1$i$i)) + 16|0);
              $157 = load4($arrayidx107$i$i);
              $cmp108$i$i = ($157|0)==(0|0);
              if ($cmp108$i$i) {
               break;
              } else {
               $R$1$i$i = $157;$RP$1$i$i = $arrayidx107$i$i;
              }
             }
             $cmp112$i$i = ($RP$1$i$i>>>0)<($145>>>0);
             if ($cmp112$i$i) {
              _abort();
              // unreachable;
             } else {
              store4($RP$1$i$i,0);
              $R$3$i$i = $R$1$i$i;
              break;
             }
            } else {
             $fd78$i$i = ((($add$ptr16$i$i)) + 8|0);
             $151 = load4($fd78$i$i);
             $cmp81$i$i = ($151>>>0)<($145>>>0);
             if ($cmp81$i$i) {
              _abort();
              // unreachable;
             }
             $bk82$i$i = ((($151)) + 12|0);
             $152 = load4($bk82$i$i);
             $cmp83$i$i = ($152|0)==($add$ptr16$i$i|0);
             if (!($cmp83$i$i)) {
              _abort();
              // unreachable;
             }
             $fd85$i$i = ((($150)) + 8|0);
             $153 = load4($fd85$i$i);
             $cmp86$i$i = ($153|0)==($add$ptr16$i$i|0);
             if ($cmp86$i$i) {
              store4($bk82$i$i,$150);
              store4($fd85$i$i,$151);
              $R$3$i$i = $150;
              break;
             } else {
              _abort();
              // unreachable;
             }
            }
           } while(0);
           $cmp120$i42$i = ($149|0)==(0|0);
           if ($cmp120$i42$i) {
            break;
           }
           $index$i43$i = ((($add$ptr16$i$i)) + 28|0);
           $158 = load4($index$i43$i);
           $arrayidx123$i$i = (8748 + ($158<<2)|0);
           $159 = load4($arrayidx123$i$i);
           $cmp124$i$i = ($add$ptr16$i$i|0)==($159|0);
           do {
            if ($cmp124$i$i) {
             store4($arrayidx123$i$i,$R$3$i$i);
             $cond2$i$i = ($R$3$i$i|0)==(0|0);
             if (!($cond2$i$i)) {
              break;
             }
             $shl131$i$i = 1 << $158;
             $neg132$i$i = $shl131$i$i ^ -1;
             $160 = load4((8448));
             $and133$i$i = $160 & $neg132$i$i;
             store4((8448),$and133$i$i);
             break L326;
            } else {
             $161 = load4((8460));
             $cmp137$i$i = ($149>>>0)<($161>>>0);
             if ($cmp137$i$i) {
              _abort();
              // unreachable;
             }
             $arrayidx143$i$i = ((($149)) + 16|0);
             $162 = load4($arrayidx143$i$i);
             $cmp144$i$i = ($162|0)==($add$ptr16$i$i|0);
             if ($cmp144$i$i) {
              store4($arrayidx143$i$i,$R$3$i$i);
             } else {
              $arrayidx151$i$i = ((($149)) + 20|0);
              store4($arrayidx151$i$i,$R$3$i$i);
             }
             $cmp156$i$i = ($R$3$i$i|0)==(0|0);
             if ($cmp156$i$i) {
              break L326;
             }
            }
           } while(0);
           $163 = load4((8460));
           $cmp160$i$i = ($R$3$i$i>>>0)<($163>>>0);
           if ($cmp160$i$i) {
            _abort();
            // unreachable;
           }
           $parent165$i$i = ((($R$3$i$i)) + 24|0);
           store4($parent165$i$i,$149);
           $child166$i$i = ((($add$ptr16$i$i)) + 16|0);
           $164 = load4($child166$i$i);
           $cmp168$i$i = ($164|0)==(0|0);
           do {
            if (!($cmp168$i$i)) {
             $cmp172$i$i = ($164>>>0)<($163>>>0);
             if ($cmp172$i$i) {
              _abort();
              // unreachable;
             } else {
              $arrayidx178$i$i = ((($R$3$i$i)) + 16|0);
              store4($arrayidx178$i$i,$164);
              $parent179$i$i = ((($164)) + 24|0);
              store4($parent179$i$i,$R$3$i$i);
              break;
             }
            }
           } while(0);
           $arrayidx184$i$i = ((($child166$i$i)) + 4|0);
           $165 = load4($arrayidx184$i$i);
           $cmp185$i$i = ($165|0)==(0|0);
           if ($cmp185$i$i) {
            break;
           }
           $166 = load4((8460));
           $cmp189$i$i = ($165>>>0)<($166>>>0);
           if ($cmp189$i$i) {
            _abort();
            // unreachable;
           } else {
            $arrayidx195$i$i = ((($R$3$i$i)) + 20|0);
            store4($arrayidx195$i$i,$165);
            $parent196$i$i = ((($165)) + 24|0);
            store4($parent196$i$i,$R$3$i$i);
            break;
           }
          }
         } while(0);
         $add$ptr205$i$i = (($add$ptr16$i$i) + ($and37$i$i)|0);
         $add206$i$i = (($and37$i$i) + ($sub18$i$i))|0;
         $oldfirst$0$i$i = $add$ptr205$i$i;$qsize$0$i$i = $add206$i$i;
        } else {
         $oldfirst$0$i$i = $add$ptr16$i$i;$qsize$0$i$i = $sub18$i$i;
        }
        $head208$i$i = ((($oldfirst$0$i$i)) + 4|0);
        $167 = load4($head208$i$i);
        $and209$i$i = $167 & -2;
        store4($head208$i$i,$and209$i$i);
        $or210$i$i = $qsize$0$i$i | 1;
        $head211$i$i = ((($add$ptr17$i$i)) + 4|0);
        store4($head211$i$i,$or210$i$i);
        $add$ptr212$i$i = (($add$ptr17$i$i) + ($qsize$0$i$i)|0);
        store4($add$ptr212$i$i,$qsize$0$i$i);
        $shr214$i$i = $qsize$0$i$i >>> 3;
        $cmp215$i$i = ($qsize$0$i$i>>>0)<(256);
        if ($cmp215$i$i) {
         $shl221$i$i = $shr214$i$i << 1;
         $arrayidx223$i$i = (8484 + ($shl221$i$i<<2)|0);
         $168 = load4(8444);
         $shl226$i$i = 1 << $shr214$i$i;
         $and227$i$i = $168 & $shl226$i$i;
         $tobool228$i$i = ($and227$i$i|0)==(0);
         do {
          if ($tobool228$i$i) {
           $or232$i$i = $168 | $shl226$i$i;
           store4(8444,$or232$i$i);
           $$pre$i45$i = ((($arrayidx223$i$i)) + 8|0);
           $$pre$phi$i46$iZ2D = $$pre$i45$i;$F224$0$i$i = $arrayidx223$i$i;
          } else {
           $169 = ((($arrayidx223$i$i)) + 8|0);
           $170 = load4($169);
           $171 = load4((8460));
           $cmp236$i$i = ($170>>>0)<($171>>>0);
           if (!($cmp236$i$i)) {
            $$pre$phi$i46$iZ2D = $169;$F224$0$i$i = $170;
            break;
           }
           _abort();
           // unreachable;
          }
         } while(0);
         store4($$pre$phi$i46$iZ2D,$add$ptr17$i$i);
         $bk246$i$i = ((($F224$0$i$i)) + 12|0);
         store4($bk246$i$i,$add$ptr17$i$i);
         $fd247$i$i = ((($add$ptr17$i$i)) + 8|0);
         store4($fd247$i$i,$F224$0$i$i);
         $bk248$i$i = ((($add$ptr17$i$i)) + 12|0);
         store4($bk248$i$i,$arrayidx223$i$i);
         break;
        }
        $shr253$i$i = $qsize$0$i$i >>> 8;
        $cmp254$i$i = ($shr253$i$i|0)==(0);
        do {
         if ($cmp254$i$i) {
          $I252$0$i$i = 0;
         } else {
          $cmp258$i$i = ($qsize$0$i$i>>>0)>(16777215);
          if ($cmp258$i$i) {
           $I252$0$i$i = 31;
           break;
          }
          $sub262$i$i = (($shr253$i$i) + 1048320)|0;
          $shr263$i$i = $sub262$i$i >>> 16;
          $and264$i$i = $shr263$i$i & 8;
          $shl265$i$i = $shr253$i$i << $and264$i$i;
          $sub266$i$i = (($shl265$i$i) + 520192)|0;
          $shr267$i$i = $sub266$i$i >>> 16;
          $and268$i$i = $shr267$i$i & 4;
          $add269$i$i = $and268$i$i | $and264$i$i;
          $shl270$i$i = $shl265$i$i << $and268$i$i;
          $sub271$i$i = (($shl270$i$i) + 245760)|0;
          $shr272$i$i = $sub271$i$i >>> 16;
          $and273$i$i = $shr272$i$i & 2;
          $add274$i$i = $add269$i$i | $and273$i$i;
          $sub275$i$i = (14 - ($add274$i$i))|0;
          $shl276$i$i = $shl270$i$i << $and273$i$i;
          $shr277$i$i = $shl276$i$i >>> 15;
          $add278$i$i = (($sub275$i$i) + ($shr277$i$i))|0;
          $shl279$i$i = $add278$i$i << 1;
          $add280$i$i = (($add278$i$i) + 7)|0;
          $shr281$i$i = $qsize$0$i$i >>> $add280$i$i;
          $and282$i$i = $shr281$i$i & 1;
          $add283$i$i = $and282$i$i | $shl279$i$i;
          $I252$0$i$i = $add283$i$i;
         }
        } while(0);
        $arrayidx287$i$i = (8748 + ($I252$0$i$i<<2)|0);
        $index288$i$i = ((($add$ptr17$i$i)) + 28|0);
        store4($index288$i$i,$I252$0$i$i);
        $child289$i$i = ((($add$ptr17$i$i)) + 16|0);
        $arrayidx290$i$i = ((($child289$i$i)) + 4|0);
        store4($arrayidx290$i$i,0);
        store4($child289$i$i,0);
        $172 = load4((8448));
        $shl294$i$i = 1 << $I252$0$i$i;
        $and295$i$i = $172 & $shl294$i$i;
        $tobool296$i$i = ($and295$i$i|0)==(0);
        if ($tobool296$i$i) {
         $or300$i$i = $172 | $shl294$i$i;
         store4((8448),$or300$i$i);
         store4($arrayidx287$i$i,$add$ptr17$i$i);
         $parent301$i$i = ((($add$ptr17$i$i)) + 24|0);
         store4($parent301$i$i,$arrayidx287$i$i);
         $bk302$i$i = ((($add$ptr17$i$i)) + 12|0);
         store4($bk302$i$i,$add$ptr17$i$i);
         $fd303$i$i = ((($add$ptr17$i$i)) + 8|0);
         store4($fd303$i$i,$add$ptr17$i$i);
         break;
        }
        $173 = load4($arrayidx287$i$i);
        $cmp306$i$i = ($I252$0$i$i|0)==(31);
        $shr310$i$i = $I252$0$i$i >>> 1;
        $sub313$i$i = (25 - ($shr310$i$i))|0;
        $cond315$i$i = $cmp306$i$i ? 0 : $sub313$i$i;
        $shl316$i$i = $qsize$0$i$i << $cond315$i$i;
        $K305$0$i$i = $shl316$i$i;$T$0$i47$i = $173;
        while(1) {
         $head317$i$i = ((($T$0$i47$i)) + 4|0);
         $174 = load4($head317$i$i);
         $and318$i$i = $174 & -8;
         $cmp319$i$i = ($and318$i$i|0)==($qsize$0$i$i|0);
         if ($cmp319$i$i) {
          label = 278;
          break;
         }
         $shr322$i$i = $K305$0$i$i >>> 31;
         $arrayidx325$i$i = (((($T$0$i47$i)) + 16|0) + ($shr322$i$i<<2)|0);
         $shl326$i$i = $K305$0$i$i << 1;
         $175 = load4($arrayidx325$i$i);
         $cmp327$i$i = ($175|0)==(0|0);
         if ($cmp327$i$i) {
          label = 275;
          break;
         } else {
          $K305$0$i$i = $shl326$i$i;$T$0$i47$i = $175;
         }
        }
        if ((label|0) == 275) {
         $176 = load4((8460));
         $cmp332$i$i = ($arrayidx325$i$i>>>0)<($176>>>0);
         if ($cmp332$i$i) {
          _abort();
          // unreachable;
         } else {
          store4($arrayidx325$i$i,$add$ptr17$i$i);
          $parent337$i$i = ((($add$ptr17$i$i)) + 24|0);
          store4($parent337$i$i,$T$0$i47$i);
          $bk338$i$i = ((($add$ptr17$i$i)) + 12|0);
          store4($bk338$i$i,$add$ptr17$i$i);
          $fd339$i$i = ((($add$ptr17$i$i)) + 8|0);
          store4($fd339$i$i,$add$ptr17$i$i);
          break;
         }
        }
        else if ((label|0) == 278) {
         $fd344$i$i = ((($T$0$i47$i)) + 8|0);
         $177 = load4($fd344$i$i);
         $178 = load4((8460));
         $cmp350$i$i = ($177>>>0)>=($178>>>0);
         $not$cmp346$i$i = ($T$0$i47$i>>>0)>=($178>>>0);
         $179 = $cmp350$i$i & $not$cmp346$i$i;
         if ($179) {
          $bk357$i$i = ((($177)) + 12|0);
          store4($bk357$i$i,$add$ptr17$i$i);
          store4($fd344$i$i,$add$ptr17$i$i);
          $fd359$i$i = ((($add$ptr17$i$i)) + 8|0);
          store4($fd359$i$i,$177);
          $bk360$i$i = ((($add$ptr17$i$i)) + 12|0);
          store4($bk360$i$i,$T$0$i47$i);
          $parent361$i$i = ((($add$ptr17$i$i)) + 24|0);
          store4($parent361$i$i,0);
          break;
         } else {
          _abort();
          // unreachable;
         }
        }
       }
      } while(0);
      $add$ptr369$i$i = ((($add$ptr4$i26$i)) + 8|0);
      $retval$0 = $add$ptr369$i$i;
      STACKTOP = sp;return ($retval$0|0);
     } else {
      $sp$0$i$i$i = (8892);
     }
    }
    while(1) {
     $180 = load4($sp$0$i$i$i);
     $cmp$i$i$i = ($180>>>0)>($114>>>0);
     if (!($cmp$i$i$i)) {
      $size$i$i$i = ((($sp$0$i$i$i)) + 4|0);
      $181 = load4($size$i$i$i);
      $add$ptr$i$i$i = (($180) + ($181)|0);
      $cmp2$i$i$i = ($add$ptr$i$i$i>>>0)>($114>>>0);
      if ($cmp2$i$i$i) {
       break;
      }
     }
     $next$i$i$i = ((($sp$0$i$i$i)) + 8|0);
     $182 = load4($next$i$i$i);
     $sp$0$i$i$i = $182;
    }
    $add$ptr2$i$i = ((($add$ptr$i$i$i)) + -47|0);
    $add$ptr3$i$i = ((($add$ptr2$i$i)) + 8|0);
    $183 = $add$ptr3$i$i;
    $and$i$i = $183 & 7;
    $cmp$i9$i = ($and$i$i|0)==(0);
    $184 = (0 - ($183))|0;
    $and6$i10$i = $184 & 7;
    $cond$i$i = $cmp$i9$i ? 0 : $and6$i10$i;
    $add$ptr7$i$i = (($add$ptr2$i$i) + ($cond$i$i)|0);
    $add$ptr8$i118$i = ((($114)) + 16|0);
    $cmp9$i$i = ($add$ptr7$i$i>>>0)<($add$ptr8$i118$i>>>0);
    $cond13$i$i = $cmp9$i$i ? $114 : $add$ptr7$i$i;
    $add$ptr14$i$i = ((($cond13$i$i)) + 8|0);
    $add$ptr15$i$i = ((($cond13$i$i)) + 24|0);
    $sub16$i$i = (($tsize$792$i) + -40)|0;
    $add$ptr$i1$i$i = ((($tbase$793$i)) + 8|0);
    $185 = $add$ptr$i1$i$i;
    $and$i$i$i = $185 & 7;
    $cmp$i2$i$i = ($and$i$i$i|0)==(0);
    $186 = (0 - ($185))|0;
    $and3$i$i$i = $186 & 7;
    $cond$i$i$i = $cmp$i2$i$i ? 0 : $and3$i$i$i;
    $add$ptr4$i$i$i = (($tbase$793$i) + ($cond$i$i$i)|0);
    $sub5$i$i$i = (($sub16$i$i) - ($cond$i$i$i))|0;
    store4((8468),$add$ptr4$i$i$i);
    store4((8456),$sub5$i$i$i);
    $or$i$i$i = $sub5$i$i$i | 1;
    $head$i$i$i = ((($add$ptr4$i$i$i)) + 4|0);
    store4($head$i$i$i,$or$i$i$i);
    $add$ptr6$i$i$i = (($add$ptr4$i$i$i) + ($sub5$i$i$i)|0);
    $head7$i$i$i = ((($add$ptr6$i$i$i)) + 4|0);
    store4($head7$i$i$i,40);
    $187 = load4((8932));
    store4((8472),$187);
    $head$i$i = ((($cond13$i$i)) + 4|0);
    store4($head$i$i,27);
    ; store8($add$ptr14$i$i,load8((8892),4),4); store8($add$ptr14$i$i+8 | 0,load8((8892)+8 | 0,4),4);
    store4((8892),$tbase$793$i);
    store4((8896),$tsize$792$i);
    store4((8904),0);
    store4((8900),$add$ptr14$i$i);
    $p$0$i$i = $add$ptr15$i$i;
    while(1) {
     $add$ptr24$i$i = ((($p$0$i$i)) + 4|0);
     store4($add$ptr24$i$i,7);
     $188 = ((($add$ptr24$i$i)) + 4|0);
     $cmp27$i$i = ($188>>>0)<($add$ptr$i$i$i>>>0);
     if ($cmp27$i$i) {
      $p$0$i$i = $add$ptr24$i$i;
     } else {
      break;
     }
    }
    $cmp28$i$i = ($cond13$i$i|0)==($114|0);
    if (!($cmp28$i$i)) {
     $sub$ptr$lhs$cast$i$i = $cond13$i$i;
     $sub$ptr$rhs$cast$i$i = $114;
     $sub$ptr$sub$i$i = (($sub$ptr$lhs$cast$i$i) - ($sub$ptr$rhs$cast$i$i))|0;
     $189 = load4($head$i$i);
     $and32$i$i = $189 & -2;
     store4($head$i$i,$and32$i$i);
     $or33$i$i = $sub$ptr$sub$i$i | 1;
     $head34$i$i = ((($114)) + 4|0);
     store4($head34$i$i,$or33$i$i);
     store4($cond13$i$i,$sub$ptr$sub$i$i);
     $shr$i$i = $sub$ptr$sub$i$i >>> 3;
     $cmp36$i$i = ($sub$ptr$sub$i$i>>>0)<(256);
     if ($cmp36$i$i) {
      $shl$i$i = $shr$i$i << 1;
      $arrayidx$i$i = (8484 + ($shl$i$i<<2)|0);
      $190 = load4(8444);
      $shl39$i$i = 1 << $shr$i$i;
      $and40$i$i = $190 & $shl39$i$i;
      $tobool$i$i = ($and40$i$i|0)==(0);
      if ($tobool$i$i) {
       $or44$i$i = $190 | $shl39$i$i;
       store4(8444,$or44$i$i);
       $$pre$i$i = ((($arrayidx$i$i)) + 8|0);
       $$pre$phi$i$iZ2D = $$pre$i$i;$F$0$i$i = $arrayidx$i$i;
      } else {
       $191 = ((($arrayidx$i$i)) + 8|0);
       $192 = load4($191);
       $193 = load4((8460));
       $cmp46$i$i = ($192>>>0)<($193>>>0);
       if ($cmp46$i$i) {
        _abort();
        // unreachable;
       } else {
        $$pre$phi$i$iZ2D = $191;$F$0$i$i = $192;
       }
      }
      store4($$pre$phi$i$iZ2D,$114);
      $bk$i$i = ((($F$0$i$i)) + 12|0);
      store4($bk$i$i,$114);
      $fd54$i$i = ((($114)) + 8|0);
      store4($fd54$i$i,$F$0$i$i);
      $bk55$i$i = ((($114)) + 12|0);
      store4($bk55$i$i,$arrayidx$i$i);
      break;
     }
     $shr58$i$i = $sub$ptr$sub$i$i >>> 8;
     $cmp59$i$i = ($shr58$i$i|0)==(0);
     if ($cmp59$i$i) {
      $I57$0$i$i = 0;
     } else {
      $cmp63$i$i = ($sub$ptr$sub$i$i>>>0)>(16777215);
      if ($cmp63$i$i) {
       $I57$0$i$i = 31;
      } else {
       $sub67$i$i = (($shr58$i$i) + 1048320)|0;
       $shr68$i$i = $sub67$i$i >>> 16;
       $and69$i$i = $shr68$i$i & 8;
       $shl70$i$i = $shr58$i$i << $and69$i$i;
       $sub71$i$i = (($shl70$i$i) + 520192)|0;
       $shr72$i$i = $sub71$i$i >>> 16;
       $and73$i$i = $shr72$i$i & 4;
       $add74$i$i = $and73$i$i | $and69$i$i;
       $shl75$i$i = $shl70$i$i << $and73$i$i;
       $sub76$i$i = (($shl75$i$i) + 245760)|0;
       $shr77$i$i = $sub76$i$i >>> 16;
       $and78$i$i = $shr77$i$i & 2;
       $add79$i$i = $add74$i$i | $and78$i$i;
       $sub80$i$i = (14 - ($add79$i$i))|0;
       $shl81$i$i = $shl75$i$i << $and78$i$i;
       $shr82$i$i = $shl81$i$i >>> 15;
       $add83$i$i = (($sub80$i$i) + ($shr82$i$i))|0;
       $shl84$i$i = $add83$i$i << 1;
       $add85$i$i = (($add83$i$i) + 7)|0;
       $shr86$i$i = $sub$ptr$sub$i$i >>> $add85$i$i;
       $and87$i$i = $shr86$i$i & 1;
       $add88$i$i = $and87$i$i | $shl84$i$i;
       $I57$0$i$i = $add88$i$i;
      }
     }
     $arrayidx91$i$i = (8748 + ($I57$0$i$i<<2)|0);
     $index$i$i = ((($114)) + 28|0);
     store4($index$i$i,$I57$0$i$i);
     $arrayidx92$i$i = ((($114)) + 20|0);
     store4($arrayidx92$i$i,0);
     store4($add$ptr8$i118$i,0);
     $194 = load4((8448));
     $shl95$i$i = 1 << $I57$0$i$i;
     $and96$i$i = $194 & $shl95$i$i;
     $tobool97$i$i = ($and96$i$i|0)==(0);
     if ($tobool97$i$i) {
      $or101$i$i = $194 | $shl95$i$i;
      store4((8448),$or101$i$i);
      store4($arrayidx91$i$i,$114);
      $parent$i$i = ((($114)) + 24|0);
      store4($parent$i$i,$arrayidx91$i$i);
      $bk102$i$i = ((($114)) + 12|0);
      store4($bk102$i$i,$114);
      $fd103$i$i = ((($114)) + 8|0);
      store4($fd103$i$i,$114);
      break;
     }
     $195 = load4($arrayidx91$i$i);
     $cmp106$i$i = ($I57$0$i$i|0)==(31);
     $shr110$i$i = $I57$0$i$i >>> 1;
     $sub113$i$i = (25 - ($shr110$i$i))|0;
     $cond115$i$i = $cmp106$i$i ? 0 : $sub113$i$i;
     $shl116$i$i = $sub$ptr$sub$i$i << $cond115$i$i;
     $K105$0$i$i = $shl116$i$i;$T$0$i$i = $195;
     while(1) {
      $head118$i$i = ((($T$0$i$i)) + 4|0);
      $196 = load4($head118$i$i);
      $and119$i$i = $196 & -8;
      $cmp120$i$i = ($and119$i$i|0)==($sub$ptr$sub$i$i|0);
      if ($cmp120$i$i) {
       label = 304;
       break;
      }
      $shr123$i$i = $K105$0$i$i >>> 31;
      $arrayidx126$i$i = (((($T$0$i$i)) + 16|0) + ($shr123$i$i<<2)|0);
      $shl127$i$i = $K105$0$i$i << 1;
      $197 = load4($arrayidx126$i$i);
      $cmp128$i$i = ($197|0)==(0|0);
      if ($cmp128$i$i) {
       label = 301;
       break;
      } else {
       $K105$0$i$i = $shl127$i$i;$T$0$i$i = $197;
      }
     }
     if ((label|0) == 301) {
      $198 = load4((8460));
      $cmp133$i$i = ($arrayidx126$i$i>>>0)<($198>>>0);
      if ($cmp133$i$i) {
       _abort();
       // unreachable;
      } else {
       store4($arrayidx126$i$i,$114);
       $parent138$i$i = ((($114)) + 24|0);
       store4($parent138$i$i,$T$0$i$i);
       $bk139$i$i = ((($114)) + 12|0);
       store4($bk139$i$i,$114);
       $fd140$i$i = ((($114)) + 8|0);
       store4($fd140$i$i,$114);
       break;
      }
     }
     else if ((label|0) == 304) {
      $fd148$i$i = ((($T$0$i$i)) + 8|0);
      $199 = load4($fd148$i$i);
      $200 = load4((8460));
      $cmp153$i$i = ($199>>>0)>=($200>>>0);
      $not$cmp150$i$i = ($T$0$i$i>>>0)>=($200>>>0);
      $201 = $cmp153$i$i & $not$cmp150$i$i;
      if ($201) {
       $bk158$i$i = ((($199)) + 12|0);
       store4($bk158$i$i,$114);
       store4($fd148$i$i,$114);
       $fd160$i$i = ((($114)) + 8|0);
       store4($fd160$i$i,$199);
       $bk161$i$i = ((($114)) + 12|0);
       store4($bk161$i$i,$T$0$i$i);
       $parent162$i$i = ((($114)) + 24|0);
       store4($parent162$i$i,0);
       break;
      } else {
       _abort();
       // unreachable;
      }
     }
    }
   }
  } while(0);
  $202 = load4((8456));
  $cmp257$i = ($202>>>0)>($nb$0>>>0);
  if ($cmp257$i) {
   $sub260$i = (($202) - ($nb$0))|0;
   store4((8456),$sub260$i);
   $203 = load4((8468));
   $add$ptr262$i = (($203) + ($nb$0)|0);
   store4((8468),$add$ptr262$i);
   $or264$i = $sub260$i | 1;
   $head265$i = ((($add$ptr262$i)) + 4|0);
   store4($head265$i,$or264$i);
   $or267$i = $nb$0 | 3;
   $head268$i = ((($203)) + 4|0);
   store4($head268$i,$or267$i);
   $add$ptr269$i = ((($203)) + 8|0);
   $retval$0 = $add$ptr269$i;
   STACKTOP = sp;return ($retval$0|0);
  }
 }
 $call275$i = (___errno_location()|0);
 store4($call275$i,12);
 $retval$0 = 0;
 STACKTOP = sp;return ($retval$0|0);
}
function _free($mem) {
 $mem = $mem|0;
 var $$pre = 0, $$pre$phiZ2D = 0, $$pre307 = 0, $$pre308 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $71 = 0, $72 = 0, $73 = 0, $74 = 0, $8 = 0, $9 = 0, $F510$0 = 0;
 var $I534$0 = 0, $K583$0 = 0, $R$1 = 0, $R$3 = 0, $R332$1 = 0, $R332$3 = 0, $RP$1 = 0, $RP360$1 = 0, $T$0 = 0, $add$ptr = 0, $add$ptr16 = 0, $add$ptr217 = 0, $add$ptr261 = 0, $add$ptr482 = 0, $add$ptr498 = 0, $add$ptr6 = 0, $add17 = 0, $add246 = 0, $add258 = 0, $add267 = 0;
 var $add550 = 0, $add555 = 0, $add559 = 0, $add561 = 0, $add564 = 0, $and = 0, $and140 = 0, $and210 = 0, $and215 = 0, $and232 = 0, $and240 = 0, $and266 = 0, $and301 = 0, $and410 = 0, $and46 = 0, $and495 = 0, $and5 = 0, $and512 = 0, $and545 = 0, $and549 = 0;
 var $and554 = 0, $and563 = 0, $and574 = 0, $and592 = 0, $and8 = 0, $arrayidx = 0, $arrayidx108 = 0, $arrayidx113 = 0, $arrayidx130 = 0, $arrayidx149 = 0, $arrayidx157 = 0, $arrayidx182 = 0, $arrayidx188 = 0, $arrayidx198 = 0, $arrayidx279 = 0, $arrayidx362 = 0, $arrayidx374 = 0, $arrayidx379 = 0, $arrayidx400 = 0, $arrayidx419 = 0;
 var $arrayidx427 = 0, $arrayidx454 = 0, $arrayidx460 = 0, $arrayidx470 = 0, $arrayidx509 = 0, $arrayidx567 = 0, $arrayidx570 = 0, $arrayidx599 = 0, $arrayidx99 = 0, $bk = 0, $bk275 = 0, $bk286 = 0, $bk321 = 0, $bk333 = 0, $bk34 = 0, $bk343 = 0, $bk529 = 0, $bk531 = 0, $bk580 = 0, $bk611 = 0;
 var $bk631 = 0, $bk634 = 0, $bk66 = 0, $bk73 = 0, $bk82 = 0, $child = 0, $child171 = 0, $child361 = 0, $child443 = 0, $child569 = 0, $cmp = 0, $cmp$i = 0, $cmp1 = 0, $cmp100 = 0, $cmp104 = 0, $cmp109 = 0, $cmp114 = 0, $cmp118 = 0, $cmp127 = 0, $cmp13 = 0;
 var $cmp131 = 0, $cmp143 = 0, $cmp150 = 0, $cmp162 = 0, $cmp165 = 0, $cmp173 = 0, $cmp176 = 0, $cmp18 = 0, $cmp189 = 0, $cmp192 = 0, $cmp2 = 0, $cmp211 = 0, $cmp22 = 0, $cmp228 = 0, $cmp243 = 0, $cmp249 = 0, $cmp25 = 0, $cmp255 = 0, $cmp269 = 0, $cmp280 = 0;
 var $cmp283 = 0, $cmp287 = 0, $cmp29 = 0, $cmp296 = 0, $cmp305 = 0, $cmp308 = 0, $cmp31 = 0, $cmp312 = 0, $cmp334 = 0, $cmp340 = 0, $cmp344 = 0, $cmp348 = 0, $cmp35 = 0, $cmp363 = 0, $cmp368 = 0, $cmp375 = 0, $cmp380 = 0, $cmp386 = 0, $cmp395 = 0, $cmp401 = 0;
 var $cmp413 = 0, $cmp42 = 0, $cmp420 = 0, $cmp432 = 0, $cmp435 = 0, $cmp445 = 0, $cmp448 = 0, $cmp461 = 0, $cmp464 = 0, $cmp484 = 0, $cmp50 = 0, $cmp502 = 0, $cmp519 = 0, $cmp53 = 0, $cmp536 = 0, $cmp540 = 0, $cmp57 = 0, $cmp584 = 0, $cmp593 = 0, $cmp601 = 0;
 var $cmp605 = 0, $cmp624 = 0, $cmp640 = 0, $cmp74 = 0, $cmp80 = 0, $cmp83 = 0, $cmp87 = 0, $cond = 0, $cond291 = 0, $cond292 = 0, $dec = 0, $fd = 0, $fd273 = 0, $fd311 = 0, $fd322$pre$phiZ2D = 0, $fd338 = 0, $fd347 = 0, $fd530 = 0, $fd56 = 0, $fd581 = 0;
 var $fd612 = 0, $fd620 = 0, $fd633 = 0, $fd67$pre$phiZ2D = 0, $fd78 = 0, $fd86 = 0, $head = 0, $head209 = 0, $head216 = 0, $head231 = 0, $head248 = 0, $head260 = 0, $head481 = 0, $head497 = 0, $head591 = 0, $idx$neg = 0, $index = 0, $index399 = 0, $index568 = 0, $neg = 0;
 var $neg139 = 0, $neg300 = 0, $neg409 = 0, $next4$i = 0, $not$cmp621 = 0, $or = 0, $or247 = 0, $or259 = 0, $or480 = 0, $or496 = 0, $or516 = 0, $or578 = 0, $p$1 = 0, $parent = 0, $parent170 = 0, $parent183 = 0, $parent199 = 0, $parent331 = 0, $parent442 = 0, $parent455 = 0;
 var $parent471 = 0, $parent579 = 0, $parent610 = 0, $parent635 = 0, $psize$1 = 0, $psize$2 = 0, $shl = 0, $shl138 = 0, $shl278 = 0, $shl299 = 0, $shl408 = 0, $shl45 = 0, $shl508 = 0, $shl511 = 0, $shl546 = 0, $shl551 = 0, $shl557 = 0, $shl560 = 0, $shl573 = 0, $shl590 = 0;
 var $shl600 = 0, $shr = 0, $shr268 = 0, $shr501 = 0, $shr535 = 0, $shr544 = 0, $shr548 = 0, $shr553 = 0, $shr558 = 0, $shr562 = 0, $shr586 = 0, $shr596 = 0, $sp$0$i = 0, $sp$0$in$i = 0, $sub = 0, $sub547 = 0, $sub552 = 0, $sub556 = 0, $sub589 = 0, $tobool233 = 0;
 var $tobool241 = 0, $tobool513 = 0, $tobool575 = 0, $tobool9 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $cmp = ($mem|0)==(0|0);
 if ($cmp) {
  return;
 }
 $add$ptr = ((($mem)) + -8|0);
 $0 = load4((8460));
 $cmp1 = ($add$ptr>>>0)<($0>>>0);
 if ($cmp1) {
  _abort();
  // unreachable;
 }
 $head = ((($mem)) + -4|0);
 $1 = load4($head);
 $and = $1 & 3;
 $cmp2 = ($and|0)==(1);
 if ($cmp2) {
  _abort();
  // unreachable;
 }
 $and5 = $1 & -8;
 $add$ptr6 = (($add$ptr) + ($and5)|0);
 $and8 = $1 & 1;
 $tobool9 = ($and8|0)==(0);
 do {
  if ($tobool9) {
   $2 = load4($add$ptr);
   $cmp13 = ($and|0)==(0);
   if ($cmp13) {
    return;
   }
   $idx$neg = (0 - ($2))|0;
   $add$ptr16 = (($add$ptr) + ($idx$neg)|0);
   $add17 = (($2) + ($and5))|0;
   $cmp18 = ($add$ptr16>>>0)<($0>>>0);
   if ($cmp18) {
    _abort();
    // unreachable;
   }
   $3 = load4((8464));
   $cmp22 = ($add$ptr16|0)==($3|0);
   if ($cmp22) {
    $head209 = ((($add$ptr6)) + 4|0);
    $27 = load4($head209);
    $and210 = $27 & 3;
    $cmp211 = ($and210|0)==(3);
    if (!($cmp211)) {
     $p$1 = $add$ptr16;$psize$1 = $add17;
     break;
    }
    store4((8452),$add17);
    $and215 = $27 & -2;
    store4($head209,$and215);
    $or = $add17 | 1;
    $head216 = ((($add$ptr16)) + 4|0);
    store4($head216,$or);
    $add$ptr217 = (($add$ptr16) + ($add17)|0);
    store4($add$ptr217,$add17);
    return;
   }
   $shr = $2 >>> 3;
   $cmp25 = ($2>>>0)<(256);
   if ($cmp25) {
    $fd = ((($add$ptr16)) + 8|0);
    $4 = load4($fd);
    $bk = ((($add$ptr16)) + 12|0);
    $5 = load4($bk);
    $shl = $shr << 1;
    $arrayidx = (8484 + ($shl<<2)|0);
    $cmp29 = ($4|0)==($arrayidx|0);
    if (!($cmp29)) {
     $cmp31 = ($4>>>0)<($0>>>0);
     if ($cmp31) {
      _abort();
      // unreachable;
     }
     $bk34 = ((($4)) + 12|0);
     $6 = load4($bk34);
     $cmp35 = ($6|0)==($add$ptr16|0);
     if (!($cmp35)) {
      _abort();
      // unreachable;
     }
    }
    $cmp42 = ($5|0)==($4|0);
    if ($cmp42) {
     $shl45 = 1 << $shr;
     $neg = $shl45 ^ -1;
     $7 = load4(8444);
     $and46 = $7 & $neg;
     store4(8444,$and46);
     $p$1 = $add$ptr16;$psize$1 = $add17;
     break;
    }
    $cmp50 = ($5|0)==($arrayidx|0);
    if ($cmp50) {
     $$pre308 = ((($5)) + 8|0);
     $fd67$pre$phiZ2D = $$pre308;
    } else {
     $cmp53 = ($5>>>0)<($0>>>0);
     if ($cmp53) {
      _abort();
      // unreachable;
     }
     $fd56 = ((($5)) + 8|0);
     $8 = load4($fd56);
     $cmp57 = ($8|0)==($add$ptr16|0);
     if ($cmp57) {
      $fd67$pre$phiZ2D = $fd56;
     } else {
      _abort();
      // unreachable;
     }
    }
    $bk66 = ((($4)) + 12|0);
    store4($bk66,$5);
    store4($fd67$pre$phiZ2D,$4);
    $p$1 = $add$ptr16;$psize$1 = $add17;
    break;
   }
   $parent = ((($add$ptr16)) + 24|0);
   $9 = load4($parent);
   $bk73 = ((($add$ptr16)) + 12|0);
   $10 = load4($bk73);
   $cmp74 = ($10|0)==($add$ptr16|0);
   do {
    if ($cmp74) {
     $child = ((($add$ptr16)) + 16|0);
     $arrayidx99 = ((($child)) + 4|0);
     $14 = load4($arrayidx99);
     $cmp100 = ($14|0)==(0|0);
     if ($cmp100) {
      $15 = load4($child);
      $cmp104 = ($15|0)==(0|0);
      if ($cmp104) {
       $R$3 = 0;
       break;
      } else {
       $R$1 = $15;$RP$1 = $child;
      }
     } else {
      $R$1 = $14;$RP$1 = $arrayidx99;
     }
     while(1) {
      $arrayidx108 = ((($R$1)) + 20|0);
      $16 = load4($arrayidx108);
      $cmp109 = ($16|0)==(0|0);
      if (!($cmp109)) {
       $R$1 = $16;$RP$1 = $arrayidx108;
       continue;
      }
      $arrayidx113 = ((($R$1)) + 16|0);
      $17 = load4($arrayidx113);
      $cmp114 = ($17|0)==(0|0);
      if ($cmp114) {
       break;
      } else {
       $R$1 = $17;$RP$1 = $arrayidx113;
      }
     }
     $cmp118 = ($RP$1>>>0)<($0>>>0);
     if ($cmp118) {
      _abort();
      // unreachable;
     } else {
      store4($RP$1,0);
      $R$3 = $R$1;
      break;
     }
    } else {
     $fd78 = ((($add$ptr16)) + 8|0);
     $11 = load4($fd78);
     $cmp80 = ($11>>>0)<($0>>>0);
     if ($cmp80) {
      _abort();
      // unreachable;
     }
     $bk82 = ((($11)) + 12|0);
     $12 = load4($bk82);
     $cmp83 = ($12|0)==($add$ptr16|0);
     if (!($cmp83)) {
      _abort();
      // unreachable;
     }
     $fd86 = ((($10)) + 8|0);
     $13 = load4($fd86);
     $cmp87 = ($13|0)==($add$ptr16|0);
     if ($cmp87) {
      store4($bk82,$10);
      store4($fd86,$11);
      $R$3 = $10;
      break;
     } else {
      _abort();
      // unreachable;
     }
    }
   } while(0);
   $cmp127 = ($9|0)==(0|0);
   if ($cmp127) {
    $p$1 = $add$ptr16;$psize$1 = $add17;
   } else {
    $index = ((($add$ptr16)) + 28|0);
    $18 = load4($index);
    $arrayidx130 = (8748 + ($18<<2)|0);
    $19 = load4($arrayidx130);
    $cmp131 = ($add$ptr16|0)==($19|0);
    if ($cmp131) {
     store4($arrayidx130,$R$3);
     $cond291 = ($R$3|0)==(0|0);
     if ($cond291) {
      $shl138 = 1 << $18;
      $neg139 = $shl138 ^ -1;
      $20 = load4((8448));
      $and140 = $20 & $neg139;
      store4((8448),$and140);
      $p$1 = $add$ptr16;$psize$1 = $add17;
      break;
     }
    } else {
     $21 = load4((8460));
     $cmp143 = ($9>>>0)<($21>>>0);
     if ($cmp143) {
      _abort();
      // unreachable;
     }
     $arrayidx149 = ((($9)) + 16|0);
     $22 = load4($arrayidx149);
     $cmp150 = ($22|0)==($add$ptr16|0);
     if ($cmp150) {
      store4($arrayidx149,$R$3);
     } else {
      $arrayidx157 = ((($9)) + 20|0);
      store4($arrayidx157,$R$3);
     }
     $cmp162 = ($R$3|0)==(0|0);
     if ($cmp162) {
      $p$1 = $add$ptr16;$psize$1 = $add17;
      break;
     }
    }
    $23 = load4((8460));
    $cmp165 = ($R$3>>>0)<($23>>>0);
    if ($cmp165) {
     _abort();
     // unreachable;
    }
    $parent170 = ((($R$3)) + 24|0);
    store4($parent170,$9);
    $child171 = ((($add$ptr16)) + 16|0);
    $24 = load4($child171);
    $cmp173 = ($24|0)==(0|0);
    do {
     if (!($cmp173)) {
      $cmp176 = ($24>>>0)<($23>>>0);
      if ($cmp176) {
       _abort();
       // unreachable;
      } else {
       $arrayidx182 = ((($R$3)) + 16|0);
       store4($arrayidx182,$24);
       $parent183 = ((($24)) + 24|0);
       store4($parent183,$R$3);
       break;
      }
     }
    } while(0);
    $arrayidx188 = ((($child171)) + 4|0);
    $25 = load4($arrayidx188);
    $cmp189 = ($25|0)==(0|0);
    if ($cmp189) {
     $p$1 = $add$ptr16;$psize$1 = $add17;
    } else {
     $26 = load4((8460));
     $cmp192 = ($25>>>0)<($26>>>0);
     if ($cmp192) {
      _abort();
      // unreachable;
     } else {
      $arrayidx198 = ((($R$3)) + 20|0);
      store4($arrayidx198,$25);
      $parent199 = ((($25)) + 24|0);
      store4($parent199,$R$3);
      $p$1 = $add$ptr16;$psize$1 = $add17;
      break;
     }
    }
   }
  } else {
   $p$1 = $add$ptr;$psize$1 = $and5;
  }
 } while(0);
 $cmp228 = ($p$1>>>0)<($add$ptr6>>>0);
 if (!($cmp228)) {
  _abort();
  // unreachable;
 }
 $head231 = ((($add$ptr6)) + 4|0);
 $28 = load4($head231);
 $and232 = $28 & 1;
 $tobool233 = ($and232|0)==(0);
 if ($tobool233) {
  _abort();
  // unreachable;
 }
 $and240 = $28 & 2;
 $tobool241 = ($and240|0)==(0);
 if ($tobool241) {
  $29 = load4((8468));
  $cmp243 = ($add$ptr6|0)==($29|0);
  if ($cmp243) {
   $30 = load4((8456));
   $add246 = (($30) + ($psize$1))|0;
   store4((8456),$add246);
   store4((8468),$p$1);
   $or247 = $add246 | 1;
   $head248 = ((($p$1)) + 4|0);
   store4($head248,$or247);
   $31 = load4((8464));
   $cmp249 = ($p$1|0)==($31|0);
   if (!($cmp249)) {
    return;
   }
   store4((8464),0);
   store4((8452),0);
   return;
  }
  $32 = load4((8464));
  $cmp255 = ($add$ptr6|0)==($32|0);
  if ($cmp255) {
   $33 = load4((8452));
   $add258 = (($33) + ($psize$1))|0;
   store4((8452),$add258);
   store4((8464),$p$1);
   $or259 = $add258 | 1;
   $head260 = ((($p$1)) + 4|0);
   store4($head260,$or259);
   $add$ptr261 = (($p$1) + ($add258)|0);
   store4($add$ptr261,$add258);
   return;
  }
  $and266 = $28 & -8;
  $add267 = (($and266) + ($psize$1))|0;
  $shr268 = $28 >>> 3;
  $cmp269 = ($28>>>0)<(256);
  do {
   if ($cmp269) {
    $fd273 = ((($add$ptr6)) + 8|0);
    $34 = load4($fd273);
    $bk275 = ((($add$ptr6)) + 12|0);
    $35 = load4($bk275);
    $shl278 = $shr268 << 1;
    $arrayidx279 = (8484 + ($shl278<<2)|0);
    $cmp280 = ($34|0)==($arrayidx279|0);
    if (!($cmp280)) {
     $36 = load4((8460));
     $cmp283 = ($34>>>0)<($36>>>0);
     if ($cmp283) {
      _abort();
      // unreachable;
     }
     $bk286 = ((($34)) + 12|0);
     $37 = load4($bk286);
     $cmp287 = ($37|0)==($add$ptr6|0);
     if (!($cmp287)) {
      _abort();
      // unreachable;
     }
    }
    $cmp296 = ($35|0)==($34|0);
    if ($cmp296) {
     $shl299 = 1 << $shr268;
     $neg300 = $shl299 ^ -1;
     $38 = load4(8444);
     $and301 = $38 & $neg300;
     store4(8444,$and301);
     break;
    }
    $cmp305 = ($35|0)==($arrayidx279|0);
    if ($cmp305) {
     $$pre307 = ((($35)) + 8|0);
     $fd322$pre$phiZ2D = $$pre307;
    } else {
     $39 = load4((8460));
     $cmp308 = ($35>>>0)<($39>>>0);
     if ($cmp308) {
      _abort();
      // unreachable;
     }
     $fd311 = ((($35)) + 8|0);
     $40 = load4($fd311);
     $cmp312 = ($40|0)==($add$ptr6|0);
     if ($cmp312) {
      $fd322$pre$phiZ2D = $fd311;
     } else {
      _abort();
      // unreachable;
     }
    }
    $bk321 = ((($34)) + 12|0);
    store4($bk321,$35);
    store4($fd322$pre$phiZ2D,$34);
   } else {
    $parent331 = ((($add$ptr6)) + 24|0);
    $41 = load4($parent331);
    $bk333 = ((($add$ptr6)) + 12|0);
    $42 = load4($bk333);
    $cmp334 = ($42|0)==($add$ptr6|0);
    do {
     if ($cmp334) {
      $child361 = ((($add$ptr6)) + 16|0);
      $arrayidx362 = ((($child361)) + 4|0);
      $47 = load4($arrayidx362);
      $cmp363 = ($47|0)==(0|0);
      if ($cmp363) {
       $48 = load4($child361);
       $cmp368 = ($48|0)==(0|0);
       if ($cmp368) {
        $R332$3 = 0;
        break;
       } else {
        $R332$1 = $48;$RP360$1 = $child361;
       }
      } else {
       $R332$1 = $47;$RP360$1 = $arrayidx362;
      }
      while(1) {
       $arrayidx374 = ((($R332$1)) + 20|0);
       $49 = load4($arrayidx374);
       $cmp375 = ($49|0)==(0|0);
       if (!($cmp375)) {
        $R332$1 = $49;$RP360$1 = $arrayidx374;
        continue;
       }
       $arrayidx379 = ((($R332$1)) + 16|0);
       $50 = load4($arrayidx379);
       $cmp380 = ($50|0)==(0|0);
       if ($cmp380) {
        break;
       } else {
        $R332$1 = $50;$RP360$1 = $arrayidx379;
       }
      }
      $51 = load4((8460));
      $cmp386 = ($RP360$1>>>0)<($51>>>0);
      if ($cmp386) {
       _abort();
       // unreachable;
      } else {
       store4($RP360$1,0);
       $R332$3 = $R332$1;
       break;
      }
     } else {
      $fd338 = ((($add$ptr6)) + 8|0);
      $43 = load4($fd338);
      $44 = load4((8460));
      $cmp340 = ($43>>>0)<($44>>>0);
      if ($cmp340) {
       _abort();
       // unreachable;
      }
      $bk343 = ((($43)) + 12|0);
      $45 = load4($bk343);
      $cmp344 = ($45|0)==($add$ptr6|0);
      if (!($cmp344)) {
       _abort();
       // unreachable;
      }
      $fd347 = ((($42)) + 8|0);
      $46 = load4($fd347);
      $cmp348 = ($46|0)==($add$ptr6|0);
      if ($cmp348) {
       store4($bk343,$42);
       store4($fd347,$43);
       $R332$3 = $42;
       break;
      } else {
       _abort();
       // unreachable;
      }
     }
    } while(0);
    $cmp395 = ($41|0)==(0|0);
    if (!($cmp395)) {
     $index399 = ((($add$ptr6)) + 28|0);
     $52 = load4($index399);
     $arrayidx400 = (8748 + ($52<<2)|0);
     $53 = load4($arrayidx400);
     $cmp401 = ($add$ptr6|0)==($53|0);
     if ($cmp401) {
      store4($arrayidx400,$R332$3);
      $cond292 = ($R332$3|0)==(0|0);
      if ($cond292) {
       $shl408 = 1 << $52;
       $neg409 = $shl408 ^ -1;
       $54 = load4((8448));
       $and410 = $54 & $neg409;
       store4((8448),$and410);
       break;
      }
     } else {
      $55 = load4((8460));
      $cmp413 = ($41>>>0)<($55>>>0);
      if ($cmp413) {
       _abort();
       // unreachable;
      }
      $arrayidx419 = ((($41)) + 16|0);
      $56 = load4($arrayidx419);
      $cmp420 = ($56|0)==($add$ptr6|0);
      if ($cmp420) {
       store4($arrayidx419,$R332$3);
      } else {
       $arrayidx427 = ((($41)) + 20|0);
       store4($arrayidx427,$R332$3);
      }
      $cmp432 = ($R332$3|0)==(0|0);
      if ($cmp432) {
       break;
      }
     }
     $57 = load4((8460));
     $cmp435 = ($R332$3>>>0)<($57>>>0);
     if ($cmp435) {
      _abort();
      // unreachable;
     }
     $parent442 = ((($R332$3)) + 24|0);
     store4($parent442,$41);
     $child443 = ((($add$ptr6)) + 16|0);
     $58 = load4($child443);
     $cmp445 = ($58|0)==(0|0);
     do {
      if (!($cmp445)) {
       $cmp448 = ($58>>>0)<($57>>>0);
       if ($cmp448) {
        _abort();
        // unreachable;
       } else {
        $arrayidx454 = ((($R332$3)) + 16|0);
        store4($arrayidx454,$58);
        $parent455 = ((($58)) + 24|0);
        store4($parent455,$R332$3);
        break;
       }
      }
     } while(0);
     $arrayidx460 = ((($child443)) + 4|0);
     $59 = load4($arrayidx460);
     $cmp461 = ($59|0)==(0|0);
     if (!($cmp461)) {
      $60 = load4((8460));
      $cmp464 = ($59>>>0)<($60>>>0);
      if ($cmp464) {
       _abort();
       // unreachable;
      } else {
       $arrayidx470 = ((($R332$3)) + 20|0);
       store4($arrayidx470,$59);
       $parent471 = ((($59)) + 24|0);
       store4($parent471,$R332$3);
       break;
      }
     }
    }
   }
  } while(0);
  $or480 = $add267 | 1;
  $head481 = ((($p$1)) + 4|0);
  store4($head481,$or480);
  $add$ptr482 = (($p$1) + ($add267)|0);
  store4($add$ptr482,$add267);
  $61 = load4((8464));
  $cmp484 = ($p$1|0)==($61|0);
  if ($cmp484) {
   store4((8452),$add267);
   return;
  } else {
   $psize$2 = $add267;
  }
 } else {
  $and495 = $28 & -2;
  store4($head231,$and495);
  $or496 = $psize$1 | 1;
  $head497 = ((($p$1)) + 4|0);
  store4($head497,$or496);
  $add$ptr498 = (($p$1) + ($psize$1)|0);
  store4($add$ptr498,$psize$1);
  $psize$2 = $psize$1;
 }
 $shr501 = $psize$2 >>> 3;
 $cmp502 = ($psize$2>>>0)<(256);
 if ($cmp502) {
  $shl508 = $shr501 << 1;
  $arrayidx509 = (8484 + ($shl508<<2)|0);
  $62 = load4(8444);
  $shl511 = 1 << $shr501;
  $and512 = $62 & $shl511;
  $tobool513 = ($and512|0)==(0);
  if ($tobool513) {
   $or516 = $62 | $shl511;
   store4(8444,$or516);
   $$pre = ((($arrayidx509)) + 8|0);
   $$pre$phiZ2D = $$pre;$F510$0 = $arrayidx509;
  } else {
   $63 = ((($arrayidx509)) + 8|0);
   $64 = load4($63);
   $65 = load4((8460));
   $cmp519 = ($64>>>0)<($65>>>0);
   if ($cmp519) {
    _abort();
    // unreachable;
   } else {
    $$pre$phiZ2D = $63;$F510$0 = $64;
   }
  }
  store4($$pre$phiZ2D,$p$1);
  $bk529 = ((($F510$0)) + 12|0);
  store4($bk529,$p$1);
  $fd530 = ((($p$1)) + 8|0);
  store4($fd530,$F510$0);
  $bk531 = ((($p$1)) + 12|0);
  store4($bk531,$arrayidx509);
  return;
 }
 $shr535 = $psize$2 >>> 8;
 $cmp536 = ($shr535|0)==(0);
 if ($cmp536) {
  $I534$0 = 0;
 } else {
  $cmp540 = ($psize$2>>>0)>(16777215);
  if ($cmp540) {
   $I534$0 = 31;
  } else {
   $sub = (($shr535) + 1048320)|0;
   $shr544 = $sub >>> 16;
   $and545 = $shr544 & 8;
   $shl546 = $shr535 << $and545;
   $sub547 = (($shl546) + 520192)|0;
   $shr548 = $sub547 >>> 16;
   $and549 = $shr548 & 4;
   $add550 = $and549 | $and545;
   $shl551 = $shl546 << $and549;
   $sub552 = (($shl551) + 245760)|0;
   $shr553 = $sub552 >>> 16;
   $and554 = $shr553 & 2;
   $add555 = $add550 | $and554;
   $sub556 = (14 - ($add555))|0;
   $shl557 = $shl551 << $and554;
   $shr558 = $shl557 >>> 15;
   $add559 = (($sub556) + ($shr558))|0;
   $shl560 = $add559 << 1;
   $add561 = (($add559) + 7)|0;
   $shr562 = $psize$2 >>> $add561;
   $and563 = $shr562 & 1;
   $add564 = $and563 | $shl560;
   $I534$0 = $add564;
  }
 }
 $arrayidx567 = (8748 + ($I534$0<<2)|0);
 $index568 = ((($p$1)) + 28|0);
 store4($index568,$I534$0);
 $child569 = ((($p$1)) + 16|0);
 $arrayidx570 = ((($p$1)) + 20|0);
 store4($arrayidx570,0);
 store4($child569,0);
 $66 = load4((8448));
 $shl573 = 1 << $I534$0;
 $and574 = $66 & $shl573;
 $tobool575 = ($and574|0)==(0);
 do {
  if ($tobool575) {
   $or578 = $66 | $shl573;
   store4((8448),$or578);
   store4($arrayidx567,$p$1);
   $parent579 = ((($p$1)) + 24|0);
   store4($parent579,$arrayidx567);
   $bk580 = ((($p$1)) + 12|0);
   store4($bk580,$p$1);
   $fd581 = ((($p$1)) + 8|0);
   store4($fd581,$p$1);
  } else {
   $67 = load4($arrayidx567);
   $cmp584 = ($I534$0|0)==(31);
   $shr586 = $I534$0 >>> 1;
   $sub589 = (25 - ($shr586))|0;
   $cond = $cmp584 ? 0 : $sub589;
   $shl590 = $psize$2 << $cond;
   $K583$0 = $shl590;$T$0 = $67;
   while(1) {
    $head591 = ((($T$0)) + 4|0);
    $68 = load4($head591);
    $and592 = $68 & -8;
    $cmp593 = ($and592|0)==($psize$2|0);
    if ($cmp593) {
     label = 130;
     break;
    }
    $shr596 = $K583$0 >>> 31;
    $arrayidx599 = (((($T$0)) + 16|0) + ($shr596<<2)|0);
    $shl600 = $K583$0 << 1;
    $69 = load4($arrayidx599);
    $cmp601 = ($69|0)==(0|0);
    if ($cmp601) {
     label = 127;
     break;
    } else {
     $K583$0 = $shl600;$T$0 = $69;
    }
   }
   if ((label|0) == 127) {
    $70 = load4((8460));
    $cmp605 = ($arrayidx599>>>0)<($70>>>0);
    if ($cmp605) {
     _abort();
     // unreachable;
    } else {
     store4($arrayidx599,$p$1);
     $parent610 = ((($p$1)) + 24|0);
     store4($parent610,$T$0);
     $bk611 = ((($p$1)) + 12|0);
     store4($bk611,$p$1);
     $fd612 = ((($p$1)) + 8|0);
     store4($fd612,$p$1);
     break;
    }
   }
   else if ((label|0) == 130) {
    $fd620 = ((($T$0)) + 8|0);
    $71 = load4($fd620);
    $72 = load4((8460));
    $cmp624 = ($71>>>0)>=($72>>>0);
    $not$cmp621 = ($T$0>>>0)>=($72>>>0);
    $73 = $cmp624 & $not$cmp621;
    if ($73) {
     $bk631 = ((($71)) + 12|0);
     store4($bk631,$p$1);
     store4($fd620,$p$1);
     $fd633 = ((($p$1)) + 8|0);
     store4($fd633,$71);
     $bk634 = ((($p$1)) + 12|0);
     store4($bk634,$T$0);
     $parent635 = ((($p$1)) + 24|0);
     store4($parent635,0);
     break;
    } else {
     _abort();
     // unreachable;
    }
   }
  }
 } while(0);
 $74 = load4((8476));
 $dec = (($74) + -1)|0;
 store4((8476),$dec);
 $cmp640 = ($dec|0)==(0);
 if ($cmp640) {
  $sp$0$in$i = (8900);
 } else {
  return;
 }
 while(1) {
  $sp$0$i = load4($sp$0$in$i);
  $cmp$i = ($sp$0$i|0)==(0|0);
  $next4$i = ((($sp$0$i)) + 8|0);
  if ($cmp$i) {
   break;
  } else {
   $sp$0$in$i = $next4$i;
  }
 }
 store4((8476),-1);
 return;
}
function _calloc($n_elements,$elem_size) {
 $n_elements = $n_elements|0;
 $elem_size = $elem_size|0;
 var $0 = 0, $and6 = 0, $call = 0, $cmp = 0, $cmp1 = 0, $cmp4 = 0, $cmp7 = 0, $div = 0, $head = 0, $mul = 0, $mul$ = 0, $or = 0, $req$0 = 0, $tobool = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $cmp = ($n_elements|0)==(0);
 if ($cmp) {
  $req$0 = 0;
 } else {
  $mul = Math_imul($elem_size, $n_elements)|0;
  $or = $elem_size | $n_elements;
  $tobool = ($or>>>0)>(65535);
  if ($tobool) {
   $div = (($mul>>>0) / ($n_elements>>>0))&-1;
   $cmp1 = ($div|0)==($elem_size|0);
   $mul$ = $cmp1 ? $mul : -1;
   $req$0 = $mul$;
  } else {
   $req$0 = $mul;
  }
 }
 $call = (_malloc($req$0)|0);
 $cmp4 = ($call|0)==(0|0);
 if ($cmp4) {
  return ($call|0);
 }
 $head = ((($call)) + -4|0);
 $0 = load4($head);
 $and6 = $0 & 3;
 $cmp7 = ($and6|0)==(0);
 if ($cmp7) {
  return ($call|0);
 }
 _memset(($call|0),0,($req$0|0))|0;
 return ($call|0);
}
function _realloc($oldmem,$bytes) {
 $oldmem = $oldmem|0;
 $bytes = $bytes|0;
 var $0 = 0, $add$ptr = 0, $add$ptr10 = 0, $add6 = 0, $and = 0, $and15 = 0, $and17 = 0, $call = 0, $call12 = 0, $call3 = 0, $call7 = 0, $cmp = 0, $cmp1 = 0, $cmp13 = 0, $cmp18 = 0, $cmp20 = 0, $cmp5 = 0, $cmp8 = 0, $cond = 0, $cond19 = 0;
 var $cond24 = 0, $head = 0, $mem$1 = 0, $sub = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $cmp = ($oldmem|0)==(0|0);
 if ($cmp) {
  $call = (_malloc($bytes)|0);
  $mem$1 = $call;
  return ($mem$1|0);
 }
 $cmp1 = ($bytes>>>0)>(4294967231);
 if ($cmp1) {
  $call3 = (___errno_location()|0);
  store4($call3,12);
  $mem$1 = 0;
  return ($mem$1|0);
 }
 $cmp5 = ($bytes>>>0)<(11);
 $add6 = (($bytes) + 11)|0;
 $and = $add6 & -8;
 $cond = $cmp5 ? 16 : $and;
 $add$ptr = ((($oldmem)) + -8|0);
 $call7 = (_try_realloc_chunk($add$ptr,$cond)|0);
 $cmp8 = ($call7|0)==(0|0);
 if (!($cmp8)) {
  $add$ptr10 = ((($call7)) + 8|0);
  $mem$1 = $add$ptr10;
  return ($mem$1|0);
 }
 $call12 = (_malloc($bytes)|0);
 $cmp13 = ($call12|0)==(0|0);
 if ($cmp13) {
  $mem$1 = 0;
  return ($mem$1|0);
 }
 $head = ((($oldmem)) + -4|0);
 $0 = load4($head);
 $and15 = $0 & -8;
 $and17 = $0 & 3;
 $cmp18 = ($and17|0)==(0);
 $cond19 = $cmp18 ? 8 : 4;
 $sub = (($and15) - ($cond19))|0;
 $cmp20 = ($sub>>>0)<($bytes>>>0);
 $cond24 = $cmp20 ? $sub : $bytes;
 _memcpy(($call12|0),($oldmem|0),($cond24|0))|0;
 _free($oldmem);
 $mem$1 = $call12;
 return ($mem$1|0);
}
function _try_realloc_chunk($p,$nb) {
 $p = $p|0;
 $nb = $nb|0;
 var $$pre = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0, $23 = 0, $24 = 0, $25 = 0;
 var $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $4 = 0, $5 = 0, $6 = 0, $7 = 0, $8 = 0, $9 = 0, $R$1 = 0, $R$3 = 0, $RP$1 = 0;
 var $add = 0, $add$i = 0, $add$ptr = 0, $add$ptr17 = 0, $add$ptr298 = 0, $add$ptr30 = 0, $add$ptr303 = 0, $add$ptr317 = 0, $add$ptr41 = 0, $add$ptr66 = 0, $add$ptr67 = 0, $add$ptr91 = 0, $add105 = 0, $add58 = 0, $and = 0, $and100 = 0, $and104 = 0, $and128 = 0, $and19 = 0, $and2 = 0;
 var $and216 = 0, $and294 = 0, $and305 = 0, $and43 = 0, $and69 = 0, $and7 = 0, $and80 = 0, $and87 = 0, $arrayidx = 0, $arrayidx179 = 0, $arrayidx186 = 0, $arrayidx190 = 0, $arrayidx206 = 0, $arrayidx226 = 0, $arrayidx234 = 0, $arrayidx261 = 0, $arrayidx267 = 0, $arrayidx278 = 0, $bk = 0, $bk118 = 0;
 var $bk147 = 0, $bk155 = 0, $bk164 = 0, $child = 0, $child249 = 0, $cmp$i = 0, $cmp1$i = 0, $cmp106 = 0, $cmp11 = 0, $cmp111 = 0, $cmp114 = 0, $cmp116 = 0, $cmp119 = 0, $cmp125 = 0, $cmp13 = 0, $cmp133 = 0, $cmp136 = 0, $cmp139 = 0, $cmp15 = 0, $cmp156 = 0;
 var $cmp162 = 0, $cmp165 = 0, $cmp168 = 0, $cmp180 = 0, $cmp183 = 0, $cmp187 = 0, $cmp191 = 0, $cmp195 = 0, $cmp2$i = 0, $cmp203 = 0, $cmp207 = 0, $cmp220 = 0, $cmp227 = 0, $cmp239 = 0, $cmp243 = 0, $cmp251 = 0, $cmp255 = 0, $cmp268 = 0, $cmp272 = 0, $cmp288 = 0;
 var $cmp34 = 0, $cmp36 = 0, $cmp5 = 0, $cmp56 = 0, $cmp59 = 0, $cmp63 = 0, $cond = 0, $fd = 0, $fd138 = 0, $fd148$pre$phiZ2D = 0, $fd159 = 0, $fd167 = 0, $head = 0, $head23 = 0, $head299 = 0, $head31 = 0, $head310 = 0, $head318 = 0, $head48 = 0, $head6 = 0;
 var $head74 = 0, $head79 = 0, $head92 = 0, $index = 0, $neg = 0, $neg215 = 0, $newp$2 = 0, $notlhs = 0, $notrhs = 0, $or = 0, $or$cond$not = 0, $or$cond2 = 0, $or20 = 0, $or28 = 0, $or295 = 0, $or296 = 0, $or300 = 0, $or306 = 0, $or307 = 0, $or315 = 0;
 var $or319 = 0, $or32 = 0, $or44 = 0, $or45 = 0, $or50 = 0, $or70 = 0, $or71 = 0, $or76 = 0, $or88 = 0, $or89 = 0, $or93 = 0, $parent = 0, $parent248 = 0, $parent262 = 0, $parent279 = 0, $shl = 0, $shl$i = 0, $shl127 = 0, $shl214 = 0, $shr = 0;
 var $storemerge = 0, $storemerge1 = 0, $sub = 0, $sub$i = 0, $sub110 = 0, $sub40 = 0, $sub62 = 0, $tobool = 0, $tobool101 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $head = ((($p)) + 4|0);
 $0 = load4($head);
 $and = $0 & -8;
 $add$ptr = (($p) + ($and)|0);
 $1 = load4((8460));
 $and2 = $0 & 3;
 $notlhs = ($p>>>0)>=($1>>>0);
 $notrhs = ($and2|0)!=(1);
 $or$cond$not = $notrhs & $notlhs;
 $cmp5 = ($p>>>0)<($add$ptr>>>0);
 $or$cond2 = $or$cond$not & $cmp5;
 if (!($or$cond2)) {
  _abort();
  // unreachable;
 }
 $head6 = ((($add$ptr)) + 4|0);
 $2 = load4($head6);
 $and7 = $2 & 1;
 $tobool = ($and7|0)==(0);
 if ($tobool) {
  _abort();
  // unreachable;
 }
 $cmp11 = ($and2|0)==(0);
 if ($cmp11) {
  $cmp$i = ($nb>>>0)<(256);
  if ($cmp$i) {
   $newp$2 = 0;
   return ($newp$2|0);
  }
  $add$i = (($nb) + 4)|0;
  $cmp1$i = ($and>>>0)<($add$i>>>0);
  if (!($cmp1$i)) {
   $sub$i = (($and) - ($nb))|0;
   $3 = load4((8924));
   $shl$i = $3 << 1;
   $cmp2$i = ($sub$i>>>0)>($shl$i>>>0);
   if (!($cmp2$i)) {
    $newp$2 = $p;
    return ($newp$2|0);
   }
  }
  $newp$2 = 0;
  return ($newp$2|0);
 }
 $cmp13 = ($and>>>0)<($nb>>>0);
 if (!($cmp13)) {
  $sub = (($and) - ($nb))|0;
  $cmp15 = ($sub>>>0)>(15);
  if (!($cmp15)) {
   $newp$2 = $p;
   return ($newp$2|0);
  }
  $add$ptr17 = (($p) + ($nb)|0);
  $and19 = $0 & 1;
  $or = $and19 | $nb;
  $or20 = $or | 2;
  store4($head,$or20);
  $head23 = ((($add$ptr17)) + 4|0);
  $or28 = $sub | 3;
  store4($head23,$or28);
  $add$ptr30 = (($add$ptr17) + ($sub)|0);
  $head31 = ((($add$ptr30)) + 4|0);
  $4 = load4($head31);
  $or32 = $4 | 1;
  store4($head31,$or32);
  _dispose_chunk($add$ptr17,$sub);
  $newp$2 = $p;
  return ($newp$2|0);
 }
 $5 = load4((8468));
 $cmp34 = ($add$ptr|0)==($5|0);
 if ($cmp34) {
  $6 = load4((8456));
  $add = (($6) + ($and))|0;
  $cmp36 = ($add>>>0)>($nb>>>0);
  if (!($cmp36)) {
   $newp$2 = 0;
   return ($newp$2|0);
  }
  $sub40 = (($add) - ($nb))|0;
  $add$ptr41 = (($p) + ($nb)|0);
  $and43 = $0 & 1;
  $or44 = $and43 | $nb;
  $or45 = $or44 | 2;
  store4($head,$or45);
  $head48 = ((($add$ptr41)) + 4|0);
  $or50 = $sub40 | 1;
  store4($head48,$or50);
  store4((8468),$add$ptr41);
  store4((8456),$sub40);
  $newp$2 = $p;
  return ($newp$2|0);
 }
 $7 = load4((8464));
 $cmp56 = ($add$ptr|0)==($7|0);
 if ($cmp56) {
  $8 = load4((8452));
  $add58 = (($8) + ($and))|0;
  $cmp59 = ($add58>>>0)<($nb>>>0);
  if ($cmp59) {
   $newp$2 = 0;
   return ($newp$2|0);
  }
  $sub62 = (($add58) - ($nb))|0;
  $cmp63 = ($sub62>>>0)>(15);
  if ($cmp63) {
   $add$ptr66 = (($p) + ($nb)|0);
   $add$ptr67 = (($add$ptr66) + ($sub62)|0);
   $and69 = $0 & 1;
   $or70 = $and69 | $nb;
   $or71 = $or70 | 2;
   store4($head,$or71);
   $head74 = ((($add$ptr66)) + 4|0);
   $or76 = $sub62 | 1;
   store4($head74,$or76);
   store4($add$ptr67,$sub62);
   $head79 = ((($add$ptr67)) + 4|0);
   $9 = load4($head79);
   $and80 = $9 & -2;
   store4($head79,$and80);
   $storemerge = $add$ptr66;$storemerge1 = $sub62;
  } else {
   $and87 = $0 & 1;
   $or88 = $and87 | $add58;
   $or89 = $or88 | 2;
   store4($head,$or89);
   $add$ptr91 = (($p) + ($add58)|0);
   $head92 = ((($add$ptr91)) + 4|0);
   $10 = load4($head92);
   $or93 = $10 | 1;
   store4($head92,$or93);
   $storemerge = 0;$storemerge1 = 0;
  }
  store4((8452),$storemerge1);
  store4((8464),$storemerge);
  $newp$2 = $p;
  return ($newp$2|0);
 }
 $and100 = $2 & 2;
 $tobool101 = ($and100|0)==(0);
 if (!($tobool101)) {
  $newp$2 = 0;
  return ($newp$2|0);
 }
 $and104 = $2 & -8;
 $add105 = (($and104) + ($and))|0;
 $cmp106 = ($add105>>>0)<($nb>>>0);
 if ($cmp106) {
  $newp$2 = 0;
  return ($newp$2|0);
 }
 $sub110 = (($add105) - ($nb))|0;
 $shr = $2 >>> 3;
 $cmp111 = ($2>>>0)<(256);
 do {
  if ($cmp111) {
   $fd = ((($add$ptr)) + 8|0);
   $11 = load4($fd);
   $bk = ((($add$ptr)) + 12|0);
   $12 = load4($bk);
   $shl = $shr << 1;
   $arrayidx = (8484 + ($shl<<2)|0);
   $cmp114 = ($11|0)==($arrayidx|0);
   if (!($cmp114)) {
    $cmp116 = ($11>>>0)<($1>>>0);
    if ($cmp116) {
     _abort();
     // unreachable;
    }
    $bk118 = ((($11)) + 12|0);
    $13 = load4($bk118);
    $cmp119 = ($13|0)==($add$ptr|0);
    if (!($cmp119)) {
     _abort();
     // unreachable;
    }
   }
   $cmp125 = ($12|0)==($11|0);
   if ($cmp125) {
    $shl127 = 1 << $shr;
    $neg = $shl127 ^ -1;
    $14 = load4(8444);
    $and128 = $14 & $neg;
    store4(8444,$and128);
    break;
   }
   $cmp133 = ($12|0)==($arrayidx|0);
   if ($cmp133) {
    $$pre = ((($12)) + 8|0);
    $fd148$pre$phiZ2D = $$pre;
   } else {
    $cmp136 = ($12>>>0)<($1>>>0);
    if ($cmp136) {
     _abort();
     // unreachable;
    }
    $fd138 = ((($12)) + 8|0);
    $15 = load4($fd138);
    $cmp139 = ($15|0)==($add$ptr|0);
    if ($cmp139) {
     $fd148$pre$phiZ2D = $fd138;
    } else {
     _abort();
     // unreachable;
    }
   }
   $bk147 = ((($11)) + 12|0);
   store4($bk147,$12);
   store4($fd148$pre$phiZ2D,$11);
  } else {
   $parent = ((($add$ptr)) + 24|0);
   $16 = load4($parent);
   $bk155 = ((($add$ptr)) + 12|0);
   $17 = load4($bk155);
   $cmp156 = ($17|0)==($add$ptr|0);
   do {
    if ($cmp156) {
     $child = ((($add$ptr)) + 16|0);
     $arrayidx179 = ((($child)) + 4|0);
     $21 = load4($arrayidx179);
     $cmp180 = ($21|0)==(0|0);
     if ($cmp180) {
      $22 = load4($child);
      $cmp183 = ($22|0)==(0|0);
      if ($cmp183) {
       $R$3 = 0;
       break;
      } else {
       $R$1 = $22;$RP$1 = $child;
      }
     } else {
      $R$1 = $21;$RP$1 = $arrayidx179;
     }
     while(1) {
      $arrayidx186 = ((($R$1)) + 20|0);
      $23 = load4($arrayidx186);
      $cmp187 = ($23|0)==(0|0);
      if (!($cmp187)) {
       $R$1 = $23;$RP$1 = $arrayidx186;
       continue;
      }
      $arrayidx190 = ((($R$1)) + 16|0);
      $24 = load4($arrayidx190);
      $cmp191 = ($24|0)==(0|0);
      if ($cmp191) {
       break;
      } else {
       $R$1 = $24;$RP$1 = $arrayidx190;
      }
     }
     $cmp195 = ($RP$1>>>0)<($1>>>0);
     if ($cmp195) {
      _abort();
      // unreachable;
     } else {
      store4($RP$1,0);
      $R$3 = $R$1;
      break;
     }
    } else {
     $fd159 = ((($add$ptr)) + 8|0);
     $18 = load4($fd159);
     $cmp162 = ($18>>>0)<($1>>>0);
     if ($cmp162) {
      _abort();
      // unreachable;
     }
     $bk164 = ((($18)) + 12|0);
     $19 = load4($bk164);
     $cmp165 = ($19|0)==($add$ptr|0);
     if (!($cmp165)) {
      _abort();
      // unreachable;
     }
     $fd167 = ((($17)) + 8|0);
     $20 = load4($fd167);
     $cmp168 = ($20|0)==($add$ptr|0);
     if ($cmp168) {
      store4($bk164,$17);
      store4($fd167,$18);
      $R$3 = $17;
      break;
     } else {
      _abort();
      // unreachable;
     }
    }
   } while(0);
   $cmp203 = ($16|0)==(0|0);
   if (!($cmp203)) {
    $index = ((($add$ptr)) + 28|0);
    $25 = load4($index);
    $arrayidx206 = (8748 + ($25<<2)|0);
    $26 = load4($arrayidx206);
    $cmp207 = ($add$ptr|0)==($26|0);
    if ($cmp207) {
     store4($arrayidx206,$R$3);
     $cond = ($R$3|0)==(0|0);
     if ($cond) {
      $shl214 = 1 << $25;
      $neg215 = $shl214 ^ -1;
      $27 = load4((8448));
      $and216 = $27 & $neg215;
      store4((8448),$and216);
      break;
     }
    } else {
     $28 = load4((8460));
     $cmp220 = ($16>>>0)<($28>>>0);
     if ($cmp220) {
      _abort();
      // unreachable;
     }
     $arrayidx226 = ((($16)) + 16|0);
     $29 = load4($arrayidx226);
     $cmp227 = ($29|0)==($add$ptr|0);
     if ($cmp227) {
      store4($arrayidx226,$R$3);
     } else {
      $arrayidx234 = ((($16)) + 20|0);
      store4($arrayidx234,$R$3);
     }
     $cmp239 = ($R$3|0)==(0|0);
     if ($cmp239) {
      break;
     }
    }
    $30 = load4((8460));
    $cmp243 = ($R$3>>>0)<($30>>>0);
    if ($cmp243) {
     _abort();
     // unreachable;
    }
    $parent248 = ((($R$3)) + 24|0);
    store4($parent248,$16);
    $child249 = ((($add$ptr)) + 16|0);
    $31 = load4($child249);
    $cmp251 = ($31|0)==(0|0);
    do {
     if (!($cmp251)) {
      $cmp255 = ($31>>>0)<($30>>>0);
      if ($cmp255) {
       _abort();
       // unreachable;
      } else {
       $arrayidx261 = ((($R$3)) + 16|0);
       store4($arrayidx261,$31);
       $parent262 = ((($31)) + 24|0);
       store4($parent262,$R$3);
       break;
      }
     }
    } while(0);
    $arrayidx267 = ((($child249)) + 4|0);
    $32 = load4($arrayidx267);
    $cmp268 = ($32|0)==(0|0);
    if (!($cmp268)) {
     $33 = load4((8460));
     $cmp272 = ($32>>>0)<($33>>>0);
     if ($cmp272) {
      _abort();
      // unreachable;
     } else {
      $arrayidx278 = ((($R$3)) + 20|0);
      store4($arrayidx278,$32);
      $parent279 = ((($32)) + 24|0);
      store4($parent279,$R$3);
      break;
     }
    }
   }
  }
 } while(0);
 $cmp288 = ($sub110>>>0)<(16);
 if ($cmp288) {
  $and294 = $0 & 1;
  $or295 = $add105 | $and294;
  $or296 = $or295 | 2;
  store4($head,$or296);
  $add$ptr298 = (($p) + ($add105)|0);
  $head299 = ((($add$ptr298)) + 4|0);
  $34 = load4($head299);
  $or300 = $34 | 1;
  store4($head299,$or300);
  $newp$2 = $p;
  return ($newp$2|0);
 } else {
  $add$ptr303 = (($p) + ($nb)|0);
  $and305 = $0 & 1;
  $or306 = $and305 | $nb;
  $or307 = $or306 | 2;
  store4($head,$or307);
  $head310 = ((($add$ptr303)) + 4|0);
  $or315 = $sub110 | 3;
  store4($head310,$or315);
  $add$ptr317 = (($add$ptr303) + ($sub110)|0);
  $head318 = ((($add$ptr317)) + 4|0);
  $35 = load4($head318);
  $or319 = $35 | 1;
  store4($head318,$or319);
  _dispose_chunk($add$ptr303,$sub110);
  $newp$2 = $p;
  return ($newp$2|0);
 }
 return (0)|0;
}
function _dispose_chunk($p,$psize) {
 $p = $p|0;
 $psize = $psize|0;
 var $$pre = 0, $$pre$phiZ2D = 0, $$pre8 = 0, $$pre9 = 0, $0 = 0, $1 = 0, $10 = 0, $11 = 0, $12 = 0, $13 = 0, $14 = 0, $15 = 0, $16 = 0, $17 = 0, $18 = 0, $19 = 0, $2 = 0, $20 = 0, $21 = 0, $22 = 0;
 var $23 = 0, $24 = 0, $25 = 0, $26 = 0, $27 = 0, $28 = 0, $29 = 0, $3 = 0, $30 = 0, $31 = 0, $32 = 0, $33 = 0, $34 = 0, $35 = 0, $36 = 0, $37 = 0, $38 = 0, $39 = 0, $4 = 0, $40 = 0;
 var $41 = 0, $42 = 0, $43 = 0, $44 = 0, $45 = 0, $46 = 0, $47 = 0, $48 = 0, $49 = 0, $5 = 0, $50 = 0, $51 = 0, $52 = 0, $53 = 0, $54 = 0, $55 = 0, $56 = 0, $57 = 0, $58 = 0, $59 = 0;
 var $6 = 0, $60 = 0, $61 = 0, $62 = 0, $63 = 0, $64 = 0, $65 = 0, $66 = 0, $67 = 0, $68 = 0, $69 = 0, $7 = 0, $70 = 0, $8 = 0, $9 = 0, $F517$0 = 0, $I545$0 = 0, $K597$0 = 0, $R$1 = 0, $R$3 = 0;
 var $R328$1 = 0, $R328$3 = 0, $RP$1 = 0, $RP357$1 = 0, $T$0 = 0, $add$ptr = 0, $add$ptr209 = 0, $add$ptr252 = 0, $add$ptr486 = 0, $add$ptr5 = 0, $add$ptr504 = 0, $add230 = 0, $add248 = 0, $add258 = 0, $add561 = 0, $add566 = 0, $add570 = 0, $add572 = 0, $add575 = 0, $add6 = 0;
 var $and = 0, $and128 = 0, $and2 = 0, $and202 = 0, $and207 = 0, $and224 = 0, $and257 = 0, $and295 = 0, $and32 = 0, $and410 = 0, $and501 = 0, $and520 = 0, $and556 = 0, $and560 = 0, $and565 = 0, $and574 = 0, $and587 = 0, $and606 = 0, $arrayidx = 0, $arrayidx100 = 0;
 var $arrayidx118 = 0, $arrayidx138 = 0, $arrayidx146 = 0, $arrayidx173 = 0, $arrayidx179 = 0, $arrayidx190 = 0, $arrayidx271 = 0, $arrayidx359 = 0, $arrayidx371 = 0, $arrayidx376 = 0, $arrayidx399 = 0, $arrayidx420 = 0, $arrayidx428 = 0, $arrayidx457 = 0, $arrayidx463 = 0, $arrayidx474 = 0, $arrayidx516 = 0, $arrayidx579 = 0, $arrayidx582 = 0, $arrayidx613 = 0;
 var $arrayidx86 = 0, $arrayidx95 = 0, $bk = 0, $bk22 = 0, $bk266 = 0, $bk279 = 0, $bk317 = 0, $bk329 = 0, $bk340 = 0, $bk52 = 0, $bk539 = 0, $bk541 = 0, $bk594 = 0, $bk60 = 0, $bk626 = 0, $bk648 = 0, $bk651 = 0, $bk70 = 0, $child = 0, $child161 = 0;
 var $child358 = 0, $child445 = 0, $child581 = 0, $cmp = 0, $cmp10 = 0, $cmp101 = 0, $cmp106 = 0, $cmp115 = 0, $cmp119 = 0, $cmp13 = 0, $cmp132 = 0, $cmp139 = 0, $cmp151 = 0, $cmp155 = 0, $cmp163 = 0, $cmp167 = 0, $cmp17 = 0, $cmp180 = 0, $cmp184 = 0, $cmp20 = 0;
 var $cmp203 = 0, $cmp218 = 0, $cmp227 = 0, $cmp23 = 0, $cmp235 = 0, $cmp244 = 0, $cmp260 = 0, $cmp272 = 0, $cmp276 = 0, $cmp28 = 0, $cmp280 = 0, $cmp289 = 0, $cmp300 = 0, $cmp304 = 0, $cmp308 = 0, $cmp330 = 0, $cmp337 = 0, $cmp341 = 0, $cmp345 = 0, $cmp36 = 0;
 var $cmp360 = 0, $cmp365 = 0, $cmp372 = 0, $cmp377 = 0, $cmp384 = 0, $cmp393 = 0, $cmp40 = 0, $cmp400 = 0, $cmp414 = 0, $cmp421 = 0, $cmp433 = 0, $cmp437 = 0, $cmp44 = 0, $cmp447 = 0, $cmp451 = 0, $cmp464 = 0, $cmp468 = 0, $cmp489 = 0, $cmp508 = 0, $cmp529 = 0;
 var $cmp547 = 0, $cmp551 = 0, $cmp598 = 0, $cmp607 = 0, $cmp61 = 0, $cmp615 = 0, $cmp620 = 0, $cmp641 = 0, $cmp68 = 0, $cmp7 = 0, $cmp71 = 0, $cmp75 = 0, $cmp87 = 0, $cmp91 = 0, $cmp96 = 0, $cond = 0, $cond4 = 0, $cond5 = 0, $fd = 0, $fd264 = 0;
 var $fd307 = 0, $fd318$pre$phiZ2D = 0, $fd334 = 0, $fd344 = 0, $fd43 = 0, $fd53$pre$phiZ2D = 0, $fd540 = 0, $fd595 = 0, $fd627 = 0, $fd635 = 0, $fd65 = 0, $fd650 = 0, $fd74 = 0, $head = 0, $head201 = 0, $head208 = 0, $head223 = 0, $head233 = 0, $head251 = 0, $head485 = 0;
 var $head503 = 0, $head605 = 0, $idx$neg = 0, $index = 0, $index397 = 0, $index580 = 0, $neg = 0, $neg127 = 0, $neg293 = 0, $neg408 = 0, $not$cmp637 = 0, $or = 0, $or232 = 0, $or250 = 0, $or484 = 0, $or502 = 0, $or525 = 0, $or592 = 0, $p$addr$1 = 0, $parent = 0;
 var $parent160 = 0, $parent174 = 0, $parent191 = 0, $parent327 = 0, $parent444 = 0, $parent458 = 0, $parent475 = 0, $parent593 = 0, $parent625 = 0, $parent652 = 0, $psize$addr$1 = 0, $psize$addr$2 = 0, $shl = 0, $shl126 = 0, $shl269 = 0, $shl292 = 0, $shl31 = 0, $shl407 = 0, $shl514 = 0, $shl519 = 0;
 var $shl557 = 0, $shl562 = 0, $shl568 = 0, $shl571 = 0, $shl586 = 0, $shl604 = 0, $shl614 = 0, $shr = 0, $shr259 = 0, $shr507 = 0, $shr546 = 0, $shr555 = 0, $shr559 = 0, $shr564 = 0, $shr569 = 0, $shr573 = 0, $shr600 = 0, $shr610 = 0, $sub = 0, $sub558 = 0;
 var $sub563 = 0, $sub567 = 0, $sub603 = 0, $tobool = 0, $tobool225 = 0, $tobool521 = 0, $tobool588 = 0, label = 0, sp = 0;
 sp = STACKTOP;
 $add$ptr = (($p) + ($psize)|0);
 $head = ((($p)) + 4|0);
 $0 = load4($head);
 $and = $0 & 1;
 $tobool = ($and|0)==(0);
 do {
  if ($tobool) {
   $1 = load4($p);
   $and2 = $0 & 3;
   $cmp = ($and2|0)==(0);
   if ($cmp) {
    return;
   }
   $idx$neg = (0 - ($1))|0;
   $add$ptr5 = (($p) + ($idx$neg)|0);
   $add6 = (($1) + ($psize))|0;
   $2 = load4((8460));
   $cmp7 = ($add$ptr5>>>0)<($2>>>0);
   if ($cmp7) {
    _abort();
    // unreachable;
   }
   $3 = load4((8464));
   $cmp10 = ($add$ptr5|0)==($3|0);
   if ($cmp10) {
    $head201 = ((($add$ptr)) + 4|0);
    $27 = load4($head201);
    $and202 = $27 & 3;
    $cmp203 = ($and202|0)==(3);
    if (!($cmp203)) {
     $p$addr$1 = $add$ptr5;$psize$addr$1 = $add6;
     break;
    }
    store4((8452),$add6);
    $and207 = $27 & -2;
    store4($head201,$and207);
    $or = $add6 | 1;
    $head208 = ((($add$ptr5)) + 4|0);
    store4($head208,$or);
    $add$ptr209 = (($add$ptr5) + ($add6)|0);
    store4($add$ptr209,$add6);
    return;
   }
   $shr = $1 >>> 3;
   $cmp13 = ($1>>>0)<(256);
   if ($cmp13) {
    $fd = ((($add$ptr5)) + 8|0);
    $4 = load4($fd);
    $bk = ((($add$ptr5)) + 12|0);
    $5 = load4($bk);
    $shl = $shr << 1;
    $arrayidx = (8484 + ($shl<<2)|0);
    $cmp17 = ($4|0)==($arrayidx|0);
    if (!($cmp17)) {
     $cmp20 = ($4>>>0)<($2>>>0);
     if ($cmp20) {
      _abort();
      // unreachable;
     }
     $bk22 = ((($4)) + 12|0);
     $6 = load4($bk22);
     $cmp23 = ($6|0)==($add$ptr5|0);
     if (!($cmp23)) {
      _abort();
      // unreachable;
     }
    }
    $cmp28 = ($5|0)==($4|0);
    if ($cmp28) {
     $shl31 = 1 << $shr;
     $neg = $shl31 ^ -1;
     $7 = load4(8444);
     $and32 = $7 & $neg;
     store4(8444,$and32);
     $p$addr$1 = $add$ptr5;$psize$addr$1 = $add6;
     break;
    }
    $cmp36 = ($5|0)==($arrayidx|0);
    if ($cmp36) {
     $$pre9 = ((($5)) + 8|0);
     $fd53$pre$phiZ2D = $$pre9;
    } else {
     $cmp40 = ($5>>>0)<($2>>>0);
     if ($cmp40) {
      _abort();
      // unreachable;
     }
     $fd43 = ((($5)) + 8|0);
     $8 = load4($fd43);
     $cmp44 = ($8|0)==($add$ptr5|0);
     if ($cmp44) {
      $fd53$pre$phiZ2D = $fd43;
     } else {
      _abort();
      // unreachable;
     }
    }
    $bk52 = ((($4)) + 12|0);
    store4($bk52,$5);
    store4($fd53$pre$phiZ2D,$4);
    $p$addr$1 = $add$ptr5;$psize$addr$1 = $add6;
    break;
   }
   $parent = ((($add$ptr5)) + 24|0);
   $9 = load4($parent);
   $bk60 = ((($add$ptr5)) + 12|0);
   $10 = load4($bk60);
   $cmp61 = ($10|0)==($add$ptr5|0);
   do {
    if ($cmp61) {
     $child = ((($add$ptr5)) + 16|0);
     $arrayidx86 = ((($child)) + 4|0);
     $14 = load4($arrayidx86);
     $cmp87 = ($14|0)==(0|0);
     if ($cmp87) {
      $15 = load4($child);
      $cmp91 = ($15|0)==(0|0);
      if ($cmp91) {
       $R$3 = 0;
       break;
      } else {
       $R$1 = $15;$RP$1 = $child;
      }
     } else {
      $R$1 = $14;$RP$1 = $arrayidx86;
     }
     while(1) {
      $arrayidx95 = ((($R$1)) + 20|0);
      $16 = load4($arrayidx95);
      $cmp96 = ($16|0)==(0|0);
      if (!($cmp96)) {
       $R$1 = $16;$RP$1 = $arrayidx95;
       continue;
      }
      $arrayidx100 = ((($R$1)) + 16|0);
      $17 = load4($arrayidx100);
      $cmp101 = ($17|0)==(0|0);
      if ($cmp101) {
       break;
      } else {
       $R$1 = $17;$RP$1 = $arrayidx100;
      }
     }
     $cmp106 = ($RP$1>>>0)<($2>>>0);
     if ($cmp106) {
      _abort();
      // unreachable;
     } else {
      store4($RP$1,0);
      $R$3 = $R$1;
      break;
     }
    } else {
     $fd65 = ((($add$ptr5)) + 8|0);
     $11 = load4($fd65);
     $cmp68 = ($11>>>0)<($2>>>0);
     if ($cmp68) {
      _abort();
      // unreachable;
     }
     $bk70 = ((($11)) + 12|0);
     $12 = load4($bk70);
     $cmp71 = ($12|0)==($add$ptr5|0);
     if (!($cmp71)) {
      _abort();
      // unreachable;
     }
     $fd74 = ((($10)) + 8|0);
     $13 = load4($fd74);
     $cmp75 = ($13|0)==($add$ptr5|0);
     if ($cmp75) {
      store4($bk70,$10);
      store4($fd74,$11);
      $R$3 = $10;
      break;
     } else {
      _abort();
      // unreachable;
     }
    }
   } while(0);
   $cmp115 = ($9|0)==(0|0);
   if ($cmp115) {
    $p$addr$1 = $add$ptr5;$psize$addr$1 = $add6;
   } else {
    $index = ((($add$ptr5)) + 28|0);
    $18 = load4($index);
    $arrayidx118 = (8748 + ($18<<2)|0);
    $19 = load4($arrayidx118);
    $cmp119 = ($add$ptr5|0)==($19|0);
    if ($cmp119) {
     store4($arrayidx118,$R$3);
     $cond4 = ($R$3|0)==(0|0);
     if ($cond4) {
      $shl126 = 1 << $18;
      $neg127 = $shl126 ^ -1;
      $20 = load4((8448));
      $and128 = $20 & $neg127;
      store4((8448),$and128);
      $p$addr$1 = $add$ptr5;$psize$addr$1 = $add6;
      break;
     }
    } else {
     $21 = load4((8460));
     $cmp132 = ($9>>>0)<($21>>>0);
     if ($cmp132) {
      _abort();
      // unreachable;
     }
     $arrayidx138 = ((($9)) + 16|0);
     $22 = load4($arrayidx138);
     $cmp139 = ($22|0)==($add$ptr5|0);
     if ($cmp139) {
      store4($arrayidx138,$R$3);
     } else {
      $arrayidx146 = ((($9)) + 20|0);
      store4($arrayidx146,$R$3);
     }
     $cmp151 = ($R$3|0)==(0|0);
     if ($cmp151) {
      $p$addr$1 = $add$ptr5;$psize$addr$1 = $add6;
      break;
     }
    }
    $23 = load4((8460));
    $cmp155 = ($R$3>>>0)<($23>>>0);
    if ($cmp155) {
     _abort();
     // unreachable;
    }
    $parent160 = ((($R$3)) + 24|0);
    store4($parent160,$9);
    $child161 = ((($add$ptr5)) + 16|0);
    $24 = load4($child161);
    $cmp163 = ($24|0)==(0|0);
    do {
     if (!($cmp163)) {
      $cmp167 = ($24>>>0)<($23>>>0);
      if ($cmp167) {
       _abort();
       // unreachable;
      } else {
       $arrayidx173 = ((($R$3)) + 16|0);
       store4($arrayidx173,$24);
       $parent174 = ((($24)) + 24|0);
       store4($parent174,$R$3);
       break;
      }
     }
    } while(0);
    $arrayidx179 = ((($child161)) + 4|0);
    $25 = load4($arrayidx179);
    $cmp180 = ($25|0)==(0|0);
    if ($cmp180) {
     $p$addr$1 = $add$ptr5;$psize$addr$1 = $add6;
    } else {
     $26 = load4((8460));
     $cmp184 = ($25>>>0)<($26>>>0);
     if ($cmp184) {
      _abort();
      // unreachable;
     } else {
      $arrayidx190 = ((($R$3)) + 20|0);
      store4($arrayidx190,$25);
      $parent191 = ((($25)) + 24|0);
      store4($parent191,$R$3);
      $p$addr$1 = $add$ptr5;$psize$addr$1 = $add6;
      break;
     }
    }
   }
  } else {
   $p$addr$1 = $p;$psize$addr$1 = $psize;
  }
 } while(0);
 $28 = load4((8460));
 $cmp218 = ($add$ptr>>>0)<($28>>>0);
 if ($cmp218) {
  _abort();
  // unreachable;
 }
 $head223 = ((($add$ptr)) + 4|0);
 $29 = load4($head223);
 $and224 = $29 & 2;
 $tobool225 = ($and224|0)==(0);
 if ($tobool225) {
  $30 = load4((8468));
  $cmp227 = ($add$ptr|0)==($30|0);
  if ($cmp227) {
   $31 = load4((8456));
   $add230 = (($31) + ($psize$addr$1))|0;
   store4((8456),$add230);
   store4((8468),$p$addr$1);
   $or232 = $add230 | 1;
   $head233 = ((($p$addr$1)) + 4|0);
   store4($head233,$or232);
   $32 = load4((8464));
   $cmp235 = ($p$addr$1|0)==($32|0);
   if (!($cmp235)) {
    return;
   }
   store4((8464),0);
   store4((8452),0);
   return;
  }
  $33 = load4((8464));
  $cmp244 = ($add$ptr|0)==($33|0);
  if ($cmp244) {
   $34 = load4((8452));
   $add248 = (($34) + ($psize$addr$1))|0;
   store4((8452),$add248);
   store4((8464),$p$addr$1);
   $or250 = $add248 | 1;
   $head251 = ((($p$addr$1)) + 4|0);
   store4($head251,$or250);
   $add$ptr252 = (($p$addr$1) + ($add248)|0);
   store4($add$ptr252,$add248);
   return;
  }
  $and257 = $29 & -8;
  $add258 = (($and257) + ($psize$addr$1))|0;
  $shr259 = $29 >>> 3;
  $cmp260 = ($29>>>0)<(256);
  do {
   if ($cmp260) {
    $fd264 = ((($add$ptr)) + 8|0);
    $35 = load4($fd264);
    $bk266 = ((($add$ptr)) + 12|0);
    $36 = load4($bk266);
    $shl269 = $shr259 << 1;
    $arrayidx271 = (8484 + ($shl269<<2)|0);
    $cmp272 = ($35|0)==($arrayidx271|0);
    if (!($cmp272)) {
     $cmp276 = ($35>>>0)<($28>>>0);
     if ($cmp276) {
      _abort();
      // unreachable;
     }
     $bk279 = ((($35)) + 12|0);
     $37 = load4($bk279);
     $cmp280 = ($37|0)==($add$ptr|0);
     if (!($cmp280)) {
      _abort();
      // unreachable;
     }
    }
    $cmp289 = ($36|0)==($35|0);
    if ($cmp289) {
     $shl292 = 1 << $shr259;
     $neg293 = $shl292 ^ -1;
     $38 = load4(8444);
     $and295 = $38 & $neg293;
     store4(8444,$and295);
     break;
    }
    $cmp300 = ($36|0)==($arrayidx271|0);
    if ($cmp300) {
     $$pre8 = ((($36)) + 8|0);
     $fd318$pre$phiZ2D = $$pre8;
    } else {
     $cmp304 = ($36>>>0)<($28>>>0);
     if ($cmp304) {
      _abort();
      // unreachable;
     }
     $fd307 = ((($36)) + 8|0);
     $39 = load4($fd307);
     $cmp308 = ($39|0)==($add$ptr|0);
     if ($cmp308) {
      $fd318$pre$phiZ2D = $fd307;
     } else {
      _abort();
      // unreachable;
     }
    }
    $bk317 = ((($35)) + 12|0);
    store4($bk317,$36);
    store4($fd318$pre$phiZ2D,$35);
   } else {
    $parent327 = ((($add$ptr)) + 24|0);
    $40 = load4($parent327);
    $bk329 = ((($add$ptr)) + 12|0);
    $41 = load4($bk329);
    $cmp330 = ($41|0)==($add$ptr|0);
    do {
     if ($cmp330) {
      $child358 = ((($add$ptr)) + 16|0);
      $arrayidx359 = ((($child358)) + 4|0);
      $45 = load4($arrayidx359);
      $cmp360 = ($45|0)==(0|0);
      if ($cmp360) {
       $46 = load4($child358);
       $cmp365 = ($46|0)==(0|0);
       if ($cmp365) {
        $R328$3 = 0;
        break;
       } else {
        $R328$1 = $46;$RP357$1 = $child358;
       }
      } else {
       $R328$1 = $45;$RP357$1 = $arrayidx359;
      }
      while(1) {
       $arrayidx371 = ((($R328$1)) + 20|0);
       $47 = load4($arrayidx371);
       $cmp372 = ($47|0)==(0|0);
       if (!($cmp372)) {
        $R328$1 = $47;$RP357$1 = $arrayidx371;
        continue;
       }
       $arrayidx376 = ((($R328$1)) + 16|0);
       $48 = load4($arrayidx376);
       $cmp377 = ($48|0)==(0|0);
       if ($cmp377) {
        break;
       } else {
        $R328$1 = $48;$RP357$1 = $arrayidx376;
       }
      }
      $cmp384 = ($RP357$1>>>0)<($28>>>0);
      if ($cmp384) {
       _abort();
       // unreachable;
      } else {
       store4($RP357$1,0);
       $R328$3 = $R328$1;
       break;
      }
     } else {
      $fd334 = ((($add$ptr)) + 8|0);
      $42 = load4($fd334);
      $cmp337 = ($42>>>0)<($28>>>0);
      if ($cmp337) {
       _abort();
       // unreachable;
      }
      $bk340 = ((($42)) + 12|0);
      $43 = load4($bk340);
      $cmp341 = ($43|0)==($add$ptr|0);
      if (!($cmp341)) {
       _abort();
       // unreachable;
      }
      $fd344 = ((($41)) + 8|0);
      $44 = load4($fd344);
      $cmp345 = ($44|0)==($add$ptr|0);
      if ($cmp345) {
       store4($bk340,$41);
       store4($fd344,$42);
       $R328$3 = $41;
       break;
      } else {
       _abort();
       // unreachable;
      }
     }
    } while(0);
    $cmp393 = ($40|0)==(0|0);
    if (!($cmp393)) {
     $index397 = ((($add$ptr)) + 28|0);
     $49 = load4($index397);
     $arrayidx399 = (8748 + ($49<<2)|0);
     $50 = load4($arrayidx399);
     $cmp400 = ($add$ptr|0)==($50|0);
     if ($cmp400) {
      store4($arrayidx399,$R328$3);
      $cond5 = ($R328$3|0)==(0|0);
      if ($cond5) {
       $shl407 = 1 << $49;
       $neg408 = $shl407 ^ -1;
       $51 = load4((8448));
       $and410 = $51 & $neg408;
       store4((8448),$and410);
       break;
      }
     } else {
      $52 = load4((8460));
      $cmp414 = ($40>>>0)<($52>>>0);
      if ($cmp414) {
       _abort();
       // unreachable;
      }
      $arrayidx420 = ((($40)) + 16|0);
      $53 = load4($arrayidx420);
      $cmp421 = ($53|0)==($add$ptr|0);
      if ($cmp421) {
       store4($arrayidx420,$R328$3);
      } else {
       $arrayidx428 = ((($40)) + 20|0);
       store4($arrayidx428,$R328$3);
      }
      $cmp433 = ($R328$3|0)==(0|0);
      if ($cmp433) {
       break;
      }
     }
     $54 = load4((8460));
     $cmp437 = ($R328$3>>>0)<($54>>>0);
     if ($cmp437) {
      _abort();
      // unreachable;
     }
     $parent444 = ((($R328$3)) + 24|0);
     store4($parent444,$40);
     $child445 = ((($add$ptr)) + 16|0);
     $55 = load4($child445);
     $cmp447 = ($55|0)==(0|0);
     do {
      if (!($cmp447)) {
       $cmp451 = ($55>>>0)<($54>>>0);
       if ($cmp451) {
        _abort();
        // unreachable;
       } else {
        $arrayidx457 = ((($R328$3)) + 16|0);
        store4($arrayidx457,$55);
        $parent458 = ((($55)) + 24|0);
        store4($parent458,$R328$3);
        break;
       }
      }
     } while(0);
     $arrayidx463 = ((($child445)) + 4|0);
     $56 = load4($arrayidx463);
     $cmp464 = ($56|0)==(0|0);
     if (!($cmp464)) {
      $57 = load4((8460));
      $cmp468 = ($56>>>0)<($57>>>0);
      if ($cmp468) {
       _abort();
       // unreachable;
      } else {
       $arrayidx474 = ((($R328$3)) + 20|0);
       store4($arrayidx474,$56);
       $parent475 = ((($56)) + 24|0);
       store4($parent475,$R328$3);
       break;
      }
     }
    }
   }
  } while(0);
  $or484 = $add258 | 1;
  $head485 = ((($p$addr$1)) + 4|0);
  store4($head485,$or484);
  $add$ptr486 = (($p$addr$1) + ($add258)|0);
  store4($add$ptr486,$add258);
  $58 = load4((8464));
  $cmp489 = ($p$addr$1|0)==($58|0);
  if ($cmp489) {
   store4((8452),$add258);
   return;
  } else {
   $psize$addr$2 = $add258;
  }
 } else {
  $and501 = $29 & -2;
  store4($head223,$and501);
  $or502 = $psize$addr$1 | 1;
  $head503 = ((($p$addr$1)) + 4|0);
  store4($head503,$or502);
  $add$ptr504 = (($p$addr$1) + ($psize$addr$1)|0);
  store4($add$ptr504,$psize$addr$1);
  $psize$addr$2 = $psize$addr$1;
 }
 $shr507 = $psize$addr$2 >>> 3;
 $cmp508 = ($psize$addr$2>>>0)<(256);
 if ($cmp508) {
  $shl514 = $shr507 << 1;
  $arrayidx516 = (8484 + ($shl514<<2)|0);
  $59 = load4(8444);
  $shl519 = 1 << $shr507;
  $and520 = $59 & $shl519;
  $tobool521 = ($and520|0)==(0);
  if ($tobool521) {
   $or525 = $59 | $shl519;
   store4(8444,$or525);
   $$pre = ((($arrayidx516)) + 8|0);
   $$pre$phiZ2D = $$pre;$F517$0 = $arrayidx516;
  } else {
   $60 = ((($arrayidx516)) + 8|0);
   $61 = load4($60);
   $62 = load4((8460));
   $cmp529 = ($61>>>0)<($62>>>0);
   if ($cmp529) {
    _abort();
    // unreachable;
   } else {
    $$pre$phiZ2D = $60;$F517$0 = $61;
   }
  }
  store4($$pre$phiZ2D,$p$addr$1);
  $bk539 = ((($F517$0)) + 12|0);
  store4($bk539,$p$addr$1);
  $fd540 = ((($p$addr$1)) + 8|0);
  store4($fd540,$F517$0);
  $bk541 = ((($p$addr$1)) + 12|0);
  store4($bk541,$arrayidx516);
  return;
 }
 $shr546 = $psize$addr$2 >>> 8;
 $cmp547 = ($shr546|0)==(0);
 if ($cmp547) {
  $I545$0 = 0;
 } else {
  $cmp551 = ($psize$addr$2>>>0)>(16777215);
  if ($cmp551) {
   $I545$0 = 31;
  } else {
   $sub = (($shr546) + 1048320)|0;
   $shr555 = $sub >>> 16;
   $and556 = $shr555 & 8;
   $shl557 = $shr546 << $and556;
   $sub558 = (($shl557) + 520192)|0;
   $shr559 = $sub558 >>> 16;
   $and560 = $shr559 & 4;
   $add561 = $and560 | $and556;
   $shl562 = $shl557 << $and560;
   $sub563 = (($shl562) + 245760)|0;
   $shr564 = $sub563 >>> 16;
   $and565 = $shr564 & 2;
   $add566 = $add561 | $and565;
   $sub567 = (14 - ($add566))|0;
   $shl568 = $shl562 << $and565;
   $shr569 = $shl568 >>> 15;
   $add570 = (($sub567) + ($shr569))|0;
   $shl571 = $add570 << 1;
   $add572 = (($add570) + 7)|0;
   $shr573 = $psize$addr$2 >>> $add572;
   $and574 = $shr573 & 1;
   $add575 = $and574 | $shl571;
   $I545$0 = $add575;
  }
 }
 $arrayidx579 = (8748 + ($I545$0<<2)|0);
 $index580 = ((($p$addr$1)) + 28|0);
 store4($index580,$I545$0);
 $child581 = ((($p$addr$1)) + 16|0);
 $arrayidx582 = ((($p$addr$1)) + 20|0);
 store4($arrayidx582,0);
 store4($child581,0);
 $63 = load4((8448));
 $shl586 = 1 << $I545$0;
 $and587 = $63 & $shl586;
 $tobool588 = ($and587|0)==(0);
 if ($tobool588) {
  $or592 = $63 | $shl586;
  store4((8448),$or592);
  store4($arrayidx579,$p$addr$1);
  $parent593 = ((($p$addr$1)) + 24|0);
  store4($parent593,$arrayidx579);
  $bk594 = ((($p$addr$1)) + 12|0);
  store4($bk594,$p$addr$1);
  $fd595 = ((($p$addr$1)) + 8|0);
  store4($fd595,$p$addr$1);
  return;
 }
 $64 = load4($arrayidx579);
 $cmp598 = ($I545$0|0)==(31);
 $shr600 = $I545$0 >>> 1;
 $sub603 = (25 - ($shr600))|0;
 $cond = $cmp598 ? 0 : $sub603;
 $shl604 = $psize$addr$2 << $cond;
 $K597$0 = $shl604;$T$0 = $64;
 while(1) {
  $head605 = ((($T$0)) + 4|0);
  $65 = load4($head605);
  $and606 = $65 & -8;
  $cmp607 = ($and606|0)==($psize$addr$2|0);
  if ($cmp607) {
   label = 127;
   break;
  }
  $shr610 = $K597$0 >>> 31;
  $arrayidx613 = (((($T$0)) + 16|0) + ($shr610<<2)|0);
  $shl614 = $K597$0 << 1;
  $66 = load4($arrayidx613);
  $cmp615 = ($66|0)==(0|0);
  if ($cmp615) {
   label = 124;
   break;
  } else {
   $K597$0 = $shl614;$T$0 = $66;
  }
 }
 if ((label|0) == 124) {
  $67 = load4((8460));
  $cmp620 = ($arrayidx613>>>0)<($67>>>0);
  if ($cmp620) {
   _abort();
   // unreachable;
  }
  store4($arrayidx613,$p$addr$1);
  $parent625 = ((($p$addr$1)) + 24|0);
  store4($parent625,$T$0);
  $bk626 = ((($p$addr$1)) + 12|0);
  store4($bk626,$p$addr$1);
  $fd627 = ((($p$addr$1)) + 8|0);
  store4($fd627,$p$addr$1);
  return;
 }
 else if ((label|0) == 127) {
  $fd635 = ((($T$0)) + 8|0);
  $68 = load4($fd635);
  $69 = load4((8460));
  $cmp641 = ($68>>>0)>=($69>>>0);
  $not$cmp637 = ($T$0>>>0)>=($69>>>0);
  $70 = $cmp641 & $not$cmp637;
  if (!($70)) {
   _abort();
   // unreachable;
  }
  $bk648 = ((($68)) + 12|0);
  store4($bk648,$p$addr$1);
  store4($fd635,$p$addr$1);
  $fd650 = ((($p$addr$1)) + 8|0);
  store4($fd650,$68);
  $bk651 = ((($p$addr$1)) + 12|0);
  store4($bk651,$T$0);
  $parent652 = ((($p$addr$1)) + 24|0);
  store4($parent652,0);
  return;
 }
}
function runPostSets() {
}
function _memset(ptr, value, num) {
    ptr = ptr|0; value = value|0; num = num|0;
    var stop = 0, value4 = 0, stop4 = 0, unaligned = 0;
    stop = (ptr + num)|0;
    if ((num|0) >= 20) {
      // This is unaligned, but quite large, so work hard to get to aligned settings
      value = value & 0xff;
      unaligned = ptr & 3;
      value4 = value | (value << 8) | (value << 16) | (value << 24);
      stop4 = stop & ~3;
      if (unaligned) {
        unaligned = (ptr + 4 - unaligned)|0;
        while ((ptr|0) < (unaligned|0)) { // no need to check for stop, since we have large num
          HEAP8[((ptr)>>0)]=value;
          ptr = (ptr+1)|0;
        }
      }
      while ((ptr|0) < (stop4|0)) {
        HEAP32[((ptr)>>2)]=value4;
        ptr = (ptr+4)|0;
      }
    }
    while ((ptr|0) < (stop|0)) {
      HEAP8[((ptr)>>0)]=value;
      ptr = (ptr+1)|0;
    }
    return (ptr-num)|0;
}
function _sbrk(increment) {
    increment = increment|0;
    var oldDynamicTop = 0;
    var oldDynamicTopOnChange = 0;
    var newDynamicTop = 0;
    var totalMemory = 0;
    increment = ((increment + 15) & -16)|0;
    oldDynamicTop = HEAP32[DYNAMICTOP_PTR>>2]|0;
    newDynamicTop = oldDynamicTop + increment | 0;

    if (((increment|0) > 0 & (newDynamicTop|0) < (oldDynamicTop|0)) // Detect and fail if we would wrap around signed 32-bit int.
      | (newDynamicTop|0) < 0) { // Also underflow, sbrk() should be able to be used to subtract.
      abortOnCannotGrowMemory()|0;
      ___setErrNo(12);
      return -1;
    }

    HEAP32[DYNAMICTOP_PTR>>2] = newDynamicTop;
    totalMemory = getTotalMemory()|0;
    if ((newDynamicTop|0) > (totalMemory|0)) {
      if ((enlargeMemory()|0) == 0) {
        ___setErrNo(12);
        HEAP32[DYNAMICTOP_PTR>>2] = oldDynamicTop;
        return -1;
      }
    }
    return oldDynamicTop|0;
}
function _memcpy(dest, src, num) {
    dest = dest|0; src = src|0; num = num|0;
    var ret = 0;
    if ((num|0) >= 4096) return _emscripten_memcpy_big(dest|0, src|0, num|0)|0;
    ret = dest|0;
    if ((dest&3) == (src&3)) {
      while (dest & 3) {
        if ((num|0) == 0) return ret|0;
        HEAP8[((dest)>>0)]=((HEAP8[((src)>>0)])|0);
        dest = (dest+1)|0;
        src = (src+1)|0;
        num = (num-1)|0;
      }
      while ((num|0) >= 4) {
        HEAP32[((dest)>>2)]=((HEAP32[((src)>>2)])|0);
        dest = (dest+4)|0;
        src = (src+4)|0;
        num = (num-4)|0;
      }
    }
    while ((num|0) > 0) {
      HEAP8[((dest)>>0)]=((HEAP8[((src)>>0)])|0);
      dest = (dest+1)|0;
      src = (src+1)|0;
      num = (num-1)|0;
    }
    return ret|0;
}
function _pthread_self() {
    return 0;
}

  
function dynCall_ii(index,a1) {
  index = index|0;
  a1=a1|0;
  return FUNCTION_TABLE_ii[index&1](a1|0)|0;
}


function dynCall_iiii(index,a1,a2,a3) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0;
  return FUNCTION_TABLE_iiii[index&7](a1|0,a2|0,a3|0)|0;
}


function dynCall_iii(index,a1,a2) {
  index = index|0;
  a1=a1|0; a2=a2|0;
  return FUNCTION_TABLE_iii[index&15](a1|0,a2|0)|0;
}


function dynCall_iiiii(index,a1,a2,a3,a4) {
  index = index|0;
  a1=a1|0; a2=a2|0; a3=a3|0; a4=a4|0;
  return FUNCTION_TABLE_iiiii[index&7](a1|0,a2|0,a3|0,a4|0)|0;
}


function dynCall_vi(index,a1) {
  index = index|0;
  a1=a1|0;
  FUNCTION_TABLE_vi[index&7](a1|0);
}

function b0(p0) {
 p0 = p0|0; nullFunc_ii(0);return 0;
}
function b1(p0,p1,p2) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0; nullFunc_iiii(1);return 0;
}
function b2(p0,p1) {
 p0 = p0|0;p1 = p1|0; nullFunc_iii(2);return 0;
}
function b3(p0,p1,p2,p3) {
 p0 = p0|0;p1 = p1|0;p2 = p2|0;p3 = p3|0; nullFunc_iiiii(3);return 0;
}
function b4(p0) {
 p0 = p0|0; nullFunc_vi(4);
}

// EMSCRIPTEN_END_FUNCS
var FUNCTION_TABLE_ii = [b0,___stdio_close];
var FUNCTION_TABLE_iiii = [b1,b1,___stdout_write,___stdio_seek,b1,___stdio_write,b1,b1];
var FUNCTION_TABLE_iii = [b2,b2,b2,b2,b2,b2,b2,_ignore_err,_sort,b2,b2,b2,b2,b2,b2,b2];
var FUNCTION_TABLE_iiiii = [b3,b3,b3,b3,_glob,b3,b3,b3];
var FUNCTION_TABLE_vi = [b4,b4,b4,b4,b4,b4,_cleanup_369,b4];

  return { _sbrk: _sbrk, _free: _free, _main: _main, _pthread_self: _pthread_self, _memset: _memset, _malloc: _malloc, _memcpy: _memcpy, _fflush: _fflush, ___errno_location: ___errno_location, runPostSets: runPostSets, stackAlloc: stackAlloc, stackSave: stackSave, stackRestore: stackRestore, establishStackSpace: establishStackSpace, setThrew: setThrew, setTempRet0: setTempRet0, getTempRet0: getTempRet0, dynCall_ii: dynCall_ii, dynCall_iiii: dynCall_iiii, dynCall_iii: dynCall_iii, dynCall_iiiii: dynCall_iiiii, dynCall_vi: dynCall_vi };
})
;